<?php
/**
* Plugin Name: Projectopia - WooCommerce Add-On
* Description: The Projectopia WooCommerce Add-On Allows you to automatically create projects with pre-defined templates based on the sale of selected WooCommerce products
* Version: 1.0.1
* Author: Projectopia
* Author URI: http://projectopia.io
* Text Domain: cqpim-woocommerce
* Domain Path: /languages
*/
define('PTO_WOOCOMMERCE_VERSION', '1.0.1');
// Paths
define('PTO_WOOCOMMERCE_PATH', plugin_dir_path( __FILE__ ));
define('PTO_WOOCOMMERCE_DIRNAME', basename( plugin_basename( PTO_WOOCOMMERCE_PATH ) ));
define('PTO_WOOCOMMERCE_PLUGIN_URL', plugins_url() . '/' . PTO_WOOCOMMERCE_DIRNAME);
// Languages
function pto_woocommerce_plugin_setup() {
	load_plugin_textdomain('cqpim-woocommerce', false, dirname(plugin_basename(__FILE__)) . '/languages/');
} 
add_action('plugins_loaded', 'pto_woocommerce_plugin_setup');
register_activation_hook( __FILE__, 'pto_woocommerce_activation' );
function pto_woocommerce_activation() {
	if(is_plugin_active(PTO_DIRNAME . '/projectopia.php')) {
		$cqpim_version = PTO_VERSION;
		if($cqpim_version < '4.0.7') {
			$message = __('You need to have at least version 4.0.7 of the Projectopia Core plugin installed to use this add-on', 'cqpim-woocommerce');
			wp_die($message, 'Projectopia Core Plugin Version Problem');				
		} else {
			
		}
	} else {
		$message = __('You need to have the core Projectopia Plugin active to activate this Add-On', 'cqpim-woocommerce');
		wp_die($message, 'Projectopia Core Plugin Missing');
	}
}
// Includes
require_once( 'woocommerce.php' );
// Metaboxes
require_once('functions/pto_woocommerce_functions.php');