<?php
add_action( 'admin_menu' , 'register_pto_woocommerce_page', 27 ); 
function register_pto_woocommerce_page() {
	$mypage = add_submenu_page(	
				'pto-dashboard',
				__('WooCommerce Dashboard', 'cqpim-woocommerce'), 			
				__('WooCommerce Dashboard', 'cqpim-woocommerce'),  			
				'view_cqpim_woocommerce', 			
				'pto-woocommerce',
				'pto_woocommerce'
	);
	add_action( 'load-' . $mypage, 'pto_enqueue_plugin_option_scripts' );
	add_action( 'admin_init', 'register_pto_wc_settings' );
}
function register_pto_wc_settings() {
	register_setting( 'pto_woocommerce', 'cqpim_wc_product_links');
}
function pto_wc_settings_page_capability( $capability ) {
	return 'view_cqpim_woocommerce';
}
add_filter( 'option_page_capability_pto_woocommerce', 'pto_wc_settings_page_capability' );
function pto_woocommerce() { ?>
	<div class="masonry-grid">
		<div class="grid-sizer"></div>
		<div class="cqpim-dash-item-full grid-item">
			<div class="cqpim_block">
				<div class="cqpim_block_title">
					<div class="caption">
						<span class="caption-subject font-green-sharp sbold"><?php _e('WooCommerce Orders', 'cqpim-woocommerce'); ?> </span>
					</div>
					<div class="actions">
					</div>
				</div>
				<div class="cqpim-dash-item-inside">
					<?php $args = array(					
						'post_type' => 'shop_order',
						'posts_per_page' => -1,
						'post_status' => 'all',
						'meta_key' => 'pto_order',
						'meta_value' => true
					);
					$orders = get_posts($args); 
					if(!empty($orders)) { 
					$date = get_option('cqpim_date_format'); ?>
						<table class="dataTable-WC datatable_style">
							<thead>
								<tr>
									<th><?php _e('Order ID', 'cqpim-woocommerce'); ?></th>
									<th><?php _e('Date', 'cqpim-woocommerce'); ?></th>
									<th><?php _e('Client', 'cqpim-woocommerce'); ?></th>
									<th><?php _e('Resulting Project', 'cqpim-woocommerce'); ?></th>
								</tr>
							</thead>
							<tbody>
								<?php
								foreach($orders as $order) {
									$user = get_post_meta($order->ID, '_customer_user', true);
									$user = get_user_by('id', $user);
									$client = pto_get_client_from_userid($user);
									$client = get_post($client['assigned']);
									$project = get_post_meta($order->ID, 'resulting_project', true);
									$project = get_post($project);
									echo '<tr>';
									echo '<td><a href="' . get_edit_post_link($order->ID) . '">' . $order->ID . '</a></td>';
									echo '<td>' . get_the_date($date, $order->ID) . '</td>';
									echo '<td><a href="' . get_edit_post_link($client->ID) . '">' . $client->post_title . '</a></td>';
									echo '<td><a href="' . get_edit_post_link($project->ID) . '">' . $project->post_title . '</a></td>';
									echo '</tr>';
								}
								?>
							</tbody>
						</table>
					<?php } else {
						echo '<p>' . __('There are no orders to show.', 'cqpim-woocommerce') . '</p>';
					} ?>
				</div>
			</div>
		</div>
		<div class="cqpim-dash-item-full grid-item">
			<div class="cqpim_block">
				<div class="cqpim_block_title">
					<div class="caption">
						<span class="caption-subject font-green-sharp sbold"><?php _e('Product and Template Links', 'cqpim-woocommerce'); ?> <i class="fa fa-question-circle cqpim_tooltip" aria-hidden="true" title="<?php _e('This section contains all of the WooCommerce Products from your store that have been linked to Milestone Templates. When one of these products is purchased, a project will be created using the Milestone / Task Template that the product is linked to.', 'cqpim-woocommerce'); ?>"></i></span>
					</div>
				</div>
				<div class="cqpim-dash-item-inside">
					<form method="post" action="options.php" enctype="multipart/form-data">
						<?php 
						$option_group = 'pto_woocommerce';
						settings_fields( $option_group );
						$links = get_option('cqpim_wc_product_links');
						?>
						<br />
						<div class="cqpim_wc_repeater">	
							<div data-repeater-list="cqpim_wc_product_links">
									<?php if(!empty($links) && is_array($links)) { 
										$i = 0;
										foreach($links as $item) { 
											$team_member_array = isset($item['team_members']) ? $item['team_members'] : array(); ?>
											<div class="line_item" data-repeater-item>
												<table style="table-layout: fixed" class="cqpim_table invoice-items">
													<tbody>
														<tr>							
															<td style="width:90%">
																<div class="wc_linkbox_1">
																	<span style="padding-right:10px"><?php _e('Product:', 'cqpim-woocommerce'); ?></span>
																	<select data-row="0" id="cqpim_wc_product_<?php echo $i; ?>" name="product" required>
																		<option value=""><?php _e('Choose a Product', 'cqpim-woocommerce'); ?></option>
																		<?php
																		$products = pto_woocommerce_get_products(true);
																		foreach($products as $product) {
																			echo '<option value="' . $product->ID . '" ' . selected($product->ID, $item['product'], false) . '>' . $product->post_title . '</option>';
																		}
																		?>
																	</select>																
																	<span style="padding-left:10px; padding-right:10px"><?php _e('Template:', 'cqpim-woocommerce'); ?></span>
																	<select data-row="0" id="cqpim_wc_template_<?php echo $i; ?>" name="template" required>
																		<option value=""><?php _e('Choose a Template', 'cqpim-woocommerce'); ?></option>
																		<?php
																		$templates = pto_woocommerce_get_templates();
																		foreach($templates as $template) {
																			echo '<option value="' . $template->ID . '" ' . selected($template->ID, $item['template'], false) . '>' . $template->post_title . '</option>';
																		}
																		?>
																	</select>
																	<br />
																	<?php if(!empty($item['template'])) { 
																		$template = get_post_meta($item['template'], 'project_template', true);
																		if(empty($template)) {
																			$template = array();
																		}
																		$milestones = isset($template['milestones']) ? $template['milestones'] : '';
																		$assignees = array();
																		foreach($milestones as $key => $element) {
																			$tasks = isset($element['tasks']['task_arrays']) ? $element['tasks']['task_arrays'] : array();
																			foreach($tasks as $task) {
																				if(!empty($task['assignee'])) {
																					$assignees[] = $task['assignee'];
																				}
																				$subtasks = isset($task['subtasks']['task_arrays']) ? $task['subtasks']['task_arrays'] : array();	
																				foreach($subtasks as $subtask) {
																					if(!empty($subtask['assignee'])) {
																						$assignees[] = $subtask['assignee'];
																					}			
																				}			
																			}
																		}	
																		if(!empty($assignees)) { 
																			$i = 0; 
																			$team_string = '';
																			foreach($assignees as $assignee) {
																				if(!in_array($assignee, $team_member_array)) {
																					$team_details = get_post_meta($assignee, 'team_details', true);
																					$team_name = isset($team_details['team_name']) ? $team_details['team_name'] : __('Team Member name not set', 'cqpim-woocommerce');
																					if(empty($i)) {
																						$team_string .= ' ' . $team_name;
																					} else {
																						$team_string .= ', ' . $team_name;
																					}
																					$i++;
																				}
																			} 
																			if(!empty($team_string)) { ?>
																				<div class="cqpim-alert cqpim-alert-warning alert-display">
																					<?php _e('The selected template has tasks that are assigned to Team Members. You should configure this link to automatically assign the following team members to projects created by this product link:', 'cqpim-woocommerce');
																					echo $team_string;
																					?>
																				</div>
																			<?php } else { ?>
																				<br />
																			<?php } ?>
																		<?php } ?>														
																	<?php } ?>
																	<?php _e('Team Members:', 'cqpim-woocommerce'); ?>  <i class="fa fa-question-circle cqpim_tooltip" aria-hidden="true" title="<?php _e('Add the following Team Members to projects created by this product link.', 'cqpim-woocommerce'); ?>"></i><br />
																	<?php $args = array(
																		'post_type' => 'cqpim_teams',
																		'posts_per_page' => -1,
																		'post_status' => 'private'
																	); 
																	$team_members = get_posts($args);
																	foreach($team_members as $team_member) {
																		$team_details = get_post_meta($team_member->ID, 'team_details', true);
																		echo '<div class="task_watcher"><input type="checkbox" value="' . $team_member->ID . '" name="team_members" ' . checked(true, in_array($team_member->ID, $team_member_array), false) . '/> ' . $team_details['team_name'] . '</div>';
																		
																	} ?>
																
																</div>
															</td>
															<td style="padding:0; text-align:center; width:10%"><input data-row="<?php echo $i; ?>" class="line_delete cqpim_button cqpim_small_button bg-red rounded_2 border-red op" data-repeater-delete type="button" value=""/></td>
														</tr>
													</tbody>
												</table>
											</div>
										<?php $i++;
										} 
									} else { ?>
										<div class="line_item" data-repeater-item>
											<table style="table-layout: fixed" class="cqpim_table invoice-items">
												<tbody>
													<tr>
														<td style="width:90%">
															<span class="cqpim_mobile"><?php _e('Product', 'cqpim-woocommerce'); ?> </span>
															<select data-row="0" id="cqpim_wc_product" name="product" required>
																<option value=""><?php _e('Choose a Product', 'cqpim-woocommerce'); ?></option>
																<?php
																$products = pto_woocommerce_get_products(false);
																foreach($products as $product) {
																	echo '<option value="' . $product->ID . '">' . $product->post_title . '</option>';
																}
																?>
															</select>
															<span class="cqpim_mobile"><?php _e('Template', 'cqpim-woocommerce'); ?></span>
															<select data-row="0" id="cqpim_wc_template" name="template" required>
																<option value=""><?php _e('Choose a Template', 'cqpim-woocommerce'); ?></option>
																<?php
																$templates = pto_woocommerce_get_templates();
																foreach($templates as $template) {
																	echo '<option value="' . $template->ID . '">' . $template->post_title . '</option>';
																}
																?>
															</select>													
														</td>
														<td style="padding:0; text-align:center; width:10%"><input data-row="0" class="line_delete cqpim_button cqpim_small_button bg-red rounded_2 border-red op" data-repeater-delete type="button" value=""/></td>
													</tr>
												</tbody>
											</table>
										</div>
									<?php } ?>
							</div>
							<input class="add_line_item_row cqpim_button bg-green rounded_2 border-green op" data-repeater-create type="button" value=""/>
						</div>


						<p class="submit">
							<input type="submit" class="button-primary" value="<?php _e('Save Changes', 'cqpim'); ?>" />
						</p>	
					</form>
				</div>
			</div>
		</div>
	</div>	
<?php } ?>