<?php
add_action( 'admin_menu' , 'register_pto_updates_page', 10 ); 
function register_pto_updates_page() {
	$mypage = add_submenu_page(	
				'pto-updates',
				__('Project Updates', 'cqpim'), 			
				__('Project Updates', 'cqpim'), 			
				'cqpim_view_dashboard', 			
				'pto-updates', 		
				'pto_updates'
	);
	add_action( 'load-' . $mypage, 'pto_enqueue_plugin_option_scripts' );
}
function pto_updates() { ?>
	<div class="masonry-grid">
		<div class="grid-sizer"></div>
		<div class="cqpim-dash-item-full grid-item tasks-box">
			<div class="cqpim_block">
				<div class="cqpim_block_title">
					<div class="caption">
						<i class="fa fa-tasks font-green-sharp" aria-hidden="true"></i>
						<span class="caption-subject font-green-sharp sbold"><?php _e('Project Updates', 'cqpim'); ?> </span>
					</div>
				</div>
				<?php
				$avatar = get_option('cqpim_disable_avatars');
				$args = array(
					'post_type' => 'cqpim_project',
					'posts_per_page' => -1,
					'post_status' => 'private'
				);
				$projects = get_posts($args);
				$index = 0;
				$updates = array();
				if(!empty($projects)) {
					foreach($projects as $project) {
						$access = false;
						$edit_url = get_edit_post_link($project->ID);
						$title = get_the_title($project->ID); 
						$project_details = get_post_meta($project->ID, 'project_details', true);
						$closed = isset($project_details['closed']) ? $project_details['closed'] : '';
						$project_progress = get_post_meta($project->ID, 'project_progress', true);
						if(empty($project_progress)) {
							$project_progress = array();
						}
						$project_contributors = get_post_meta($project->ID, 'project_contributors', true);
						if(current_user_can('cqpim_view_all_projects') && empty($closed)) { $index++;
							foreach($project_progress as $progress) {
								$date = isset($progress['date']) ? $progress['date'] : '';
								$updates[$date] = array(
									'pid' => $project->ID,
									'by' => isset($progress['by'])?$progress['by']:null,
									'date' => isset($progress['date'])?$progress['date']:null,
									'update' => isset($progress['update'])?$progress['update']:null,
								);
							}
						} else {
							if(!is_array($project_contributors)) {
								$project_contributors = array($project_contributors);
							}
							foreach($project_contributors as $contributor) {
								if(!empty($contributor['team_id']) && $assigned == $contributor['team_id']) {
									$access = true;
								}
							}
							if(!empty($access) && empty($closed)) { $index++; 
								foreach($project_progress as $progress) {
									$date = isset($progress['date']) ? $progress['date'] : '';
									$updates[$date] = array(
										'pid' => $project->ID,
										'by' => $progress['by'],
										'date' => $progress['date'],
										'update' => $progress['update'],
									);
								}						
							}
						}
					}
					ksort($updates);
					$updates = array_reverse($updates);	?>
					<div style="max-height:800px; overflow:auto">
						<ul class="project_summary_progress" style="margin:0">
							<?php foreach($updates as $pupdate) {
								$project_details = get_post_meta($pupdate['pid'], 'project_details', true);
								$url = get_edit_post_link($pupdate['pid']);
								$project_ref = get_the_title($pupdate['pid']);
								if(is_numeric($pupdate['date'])) { $pupdate['date'] = wp_date(get_option('cqpim_date_format') . ' H:i', $pupdate['date']); } else { $pupdate['date'] = $pupdate['date']; } ?>
								<li style="margin-bottom:0">
									<div class="timeline-entry">
										<?php if(empty($avatar)) {
											echo '<div class="update-who">';
											echo get_avatar( pto_get_user_id_by_display_name($pupdate['by']), 60, '', false, array('force_display' => true) );
											echo '</div>';
										} ?>
										<?php if(empty($avatar)) { ?>
											<div class="update-data">
										<?php } else { ?>
											<div style="width:100%; float:none" class="update-data">
										<?php } ?>
											<div class="timeline-body-arrow"> </div>
											<div class="timeline-by font-blue-madison sbold"><?php echo $pupdate['by']; ?></div>
											<div class="clear"></div>
											<div class="timeline-update font-grey-cascade"><a class="cqpim-link font-grey-cascade" href="<?php echo $url; ?>"><?php echo $project_ref; ?></a> - <?php echo $pupdate['update']; ?></div>
											<div class="clear"></div>
											<div class="timeline-date font-grey-cascade"><?php echo $pupdate['date']; ?></div>
										</div>
										<div class="clear"></div>
									</div>
								</li>
						<?php } ?>
						</ul>
					</div>
				<?php }
				if($index == 0) { ?>
						<div style="padding:20px">
							<h4 style="margin:0"><?php _e('Nothing Here!', 'cqpim'); ?></h4>
							<span><?php _e('You have not been assigned to any open projects...', 'cqpim'); ?></span>	
						</div>					
				<?php } ?>			
			</div>
		</div>
	</div>	
<?php }