<?php
require_once('admin/admin_functions.php');
require_once('client/client_functions.php');
require_once('frontend/frontend_functions.php');
require_once('general/general_functions.php');
require_once('teams/team_functions.php');
require_once('messaging/messaging_functions.php');
require_once('invoice/invoice_functions.php');
require_once('quote/quote_functions.php');
require_once('project/project_functions.php');
require_once('task/task_functions.php');
require_once('ticket/ticket_functions.php');
require_once('forms/forms_functions.php');
require_once('templates/template_functions.php');
require_once('fields/field_functions.php');
require_once('piping/piping_functions.php');
require_once('leads/leads_functions.php');
require_once('notifications/notification_functions.php');
require_once('faq/faq_functions.php');

/**
 * Function to remove the preview link for all CPT.
 */
add_filter( 'preview_post_link', 'pto_hide_client_cpt_preview_link', 10, 2 );
function pto_hide_client_cpt_preview_link( $preview_link, $post ) {
    $all_CPT = array(
        'cqpim_client', 'cqpim_clients',
        'cqpim_faq', 'cqpim_faqs',
        'cqpim_form', 'cqpim_forms',
        'cqpim_invoice', 'cqpim_invoices',
        'cqpim_leadform', 'cqpim_leadforms',
        'cqpim_lead', 'cqpim_leads',
        'cqpim_messages',
        'cqpim_conversations',
        'cqpim_project', 'cqpim_projects',
        'cqpim_quote', 'cqpim_quotes',
        'cqpim_support', 'cqpim_supports',
        'cqpim_task', 'cqpim_tasks',
        'cqpim_teams', 'cqpim_team',
        'cqpim_template', 'cqpim_templates',
        'cqpim_term', 'cqpim_terms'
    );
	if ( empty( $preview_link ) || in_array( $post->post_type, $all_CPT ) ) {
		return;
	}
	return $preview_link;
}

add_action('post_locked_dialog', 'pto_post_locked_dialog', 10, 2);
add_action('post_lock_lost_dialog', 'pto_post_locked_dialog', 10);
function pto_post_locked_dialog($post, $user = '') {
	?>
	<p class="post_locked_button_wrapper">
		<a class="button post-preview-link" href="javascript:void(0)" data-postid="<?php echo $post->ID; ?>"><?php _e('View'); ?></a>
		<script type="text/javascript">
			jQuery(function($){
				jQuery(document).on('click', '.post-preview-link', function(){
					jQuery('#post-lock-dialog').addClass('pto-hidden');
					jQuery('form').each(function (){
						jQuery(this).find(':input').attr('readonly', 'readonly').attr('disabled', 'disabled');
						jQuery(this).find('input[type=checkbox], input[type=radio], input[type=file], input[type=date]').attr('disabled', 'disabled');
						jQuery(this).find('button, input[type=submit]').attr('disabled', 'disabled');
					});
					if (typeof tinymce != 'undefined'){
						if (tinymce.editors.length > 0) {
							for (i = 0; i < tinymce.editors.length; i++) {
								tinymce.editors[i].getBody().setAttribute('contenteditable', false);
							}
						}
					}
				});
			});
		</script>
		<style type="text/css">
			.pto-hidden{display:none !important;}.post_locked_button_wrapper{display: inline-block;margin: 1em;}.post_locked_button_wrapper + p{float:left;}
			input.disabled, input:disabled, select.disabled, select:disabled, textarea.disabled, textarea:disabled{background-color: transparent;border-color: #7e8993;box-shadow: none;color: inherit;}
		</style>
	</p>
	<?php
}