<?php
function pto_invoice_escrow_metabox_callback( $post ) {
 	wp_nonce_field( 
	'invoice_escrow_metabox', 
	'invoice_escrow_metabox_nonce' ); 
	$escrow_transaction = get_post_meta($post->ID, 'escrow_transaction', true); ?>
	<?php if(!empty($escrow_transaction)) { ?>
		<?php $schedule = $escrow_transaction->items[0]->schedule[0]; ?>
		<?php $items = $escrow_transaction->items[0]; ?>
		<?php $fees = $escrow_transaction->items[0]->fees[0]; ?>
		<table class="cqpim_table">
			<tr>
				<th><?php _e('ID', 'cqpim'); ?></th>
				<td><?php echo isset($escrow_transaction->id) ? $escrow_transaction->id : 0; ?></td>
			</tr>
			<tr>
				<th><?php _e('Creation Date', 'cqpim'); ?></th>
				<td><?php echo isset($escrow_transaction->creation_date) ? $escrow_transaction->creation_date : 0; ?></td>
			</tr>
			<tr>
				<th><?php _e('Title', 'cqpim'); ?></th>
				<td><?php echo isset($items->title) ? $items->title : 0; ?></td>
			</tr>
			<tr>
				<th><?php _e('Description', 'cqpim'); ?></th>
				<td><?php echo isset($escrow_transaction->description) ? $escrow_transaction->description : 0; ?></td>
			</tr>
			<tr>
				<th><?php _e('Beneficiary Customer', 'cqpim'); ?></th>
				<td><?php echo isset($schedule->beneficiary_customer) ? $schedule->beneficiary_customer : 0; ?></td>
			</tr>
			<tr>
				<th><?php _e('Payer Customer', 'cqpim'); ?></th>
				<td><?php echo isset($schedule->payer_customer) ? $schedule->payer_customer : 0; ?></td>
			</tr>
			<tr>
				<th><?php _e('Type', 'cqpim'); ?></th>
				<td><?php echo isset($items->type) ? $items->type : 0; ?></td>
			</tr>
			<tr>
				<th><?php _e('Amount', 'cqpim'); ?></th>
				<td><?php echo isset($schedule->amount) ? $schedule->amount : 0; ?></td>
			</tr>	
			<tr>
				<th><?php _e('Fees', 'cqpim'); ?></th>
				<td><?php echo isset($fees->amount) ? $fees->amount : 0; ?></td>
			</tr>
			<tr>
				<th><?php _e('Fees Payer', 'cqpim'); ?></th>
				<td><?php echo isset($fees->payer_customer) ? $fees->payer_customer : 0; ?></td>
			</tr>
			<tr>
				<th><?php _e('Currency', 'cqpim'); ?></th>
				<td><?php echo isset($escrow_transaction->currency) ? $escrow_transaction->currency : 0; ?></td>
			</tr>	
			<tr>
				<th><?php _e('Inspection Period', 'cqpim'); ?></th>
				<td><?php echo isset($items->inspection_period) ? $items->inspection_period : 0; ?></td>
			</tr>
			<tr>
				<th><?php _e('Status', 'cqpim'); ?></th>
				<td>
					<?php foreach($items->status as $key => $value) { 
						$yes = '<span class="font-green">' . __('Yes', 'cqpim') . '</span>';
						$no = '<span class="font-red">' . __('No', 'cqpim') . '</span>';
						$key = str_replace('_', ' ', $key); ?>
						<strong><?php echo ucwords($key); ?>:</strong> <?php echo !empty($value) ? $yes : $no; ?><br />
					<?php } ?>
				</td>
			</tr>			
		</table>
	<?php } else { ?>
		<p><?php _e('There are no Escrow Transactions available.', 'cqpim'); ?></p>
	<?php } ?>
	<div class="clear"></div>
	<?php if(current_user_can('cqpim_create_escrow') && empty($escrow_transaction->id)) { ?>
		<a id="create_escrow_trigger" class="cqpim_button font-blue border-blue op right mt-20" href="#"><?php _e('Create Escrow Transaction', 'cqpim'); ?></a>
	<?php } ?>
	<div class="clear"></div>
	<div id="escrow_return_messages"></div>
<?php }
add_action( 'save_post', 'save_pto_invoice_escrow_metabox_data' );
function save_pto_invoice_escrow_metabox_data( $post_id ){
	if ( ! isset( $_POST['invoice_escrow_metabox_nonce'] ) )
	    return $post_id;
	$nonce = $_POST['invoice_escrow_metabox_nonce'];
	if ( ! wp_verify_nonce( $nonce, 'invoice_escrow_metabox' ) )
	    return $post_id;
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
	    return $post_id;
	if ( 'page' == $_POST['post_type'] ) {
	    if ( ! current_user_can( 'edit_page', $post_id ) )
	        return $post_id;
	  	} else {
	    if ( ! current_user_can( 'edit_post', $post_id ) )
	        return $post_id;
	}
}