<?php
function pto_quote_elements_metabox_callback( $post ) {
 	wp_nonce_field( 
	'quote_elements_metabox', 
	'quote_elements_metabox_nonce' );
	$quote_elements = get_post_meta($post->ID, 'quote_elements', true);
	//echo '<pre>';
	//print_r($quote_elements);
	//echo '</pre>';
	$quote_details = get_post_meta($post->ID, 'quote_details', true);
	$type = isset($quote_details['quote_type']) ? $quote_details['quote_type'] : ''; 
	if($type) {
		if(empty($quote_elements)) {
			echo '<div id="dd-container">';
			echo '<p id="no_ms_nag">' . __('You have not added any milestones to this quote / estimate, please do so below', 'cqpim') . '</p>';
			echo '</div>';
		} else {
			$currency = get_option('currency_symbol');
			if($type == 'estimate') { 
				$cost_title = __('Estimated Cost', 'cqpim');
			} else {
				$cost_title = __('Cost', 'cqpim');
			}
			$ordered = array();
			foreach($quote_elements as $element) {
				//If milestone is orphan then avoid it.
				if ( ! empty($element['id'] ) && ! empty( $element['weight'] ) ) {
					$weight = $element['weight'];
					$ordered[$weight] = $element;
				}
			}
			ksort($ordered);
			?>
			<div id="dd-container">
				<?php foreach($ordered as $key => $element) { ?>
					<div class="dd-milestone" id="milestone-<?php echo $element['id']; ?>">
						<input type="hidden" class="element_weight" name="element_weight[<?php echo $element['id']; ?>]" id="element_weight[<?php echo $element['id']; ?>]" data-msid="<?php echo $element['id']; ?>" value="<?php echo $element['weight']; ?>" />
						<div class="dd-milestone-title">
							<span class="cqpim_button cqpim_small_button font-white bg-blue-madison nolink op rounded_2"><?php _e('Milestone', 'cqpim'); ?></span>  <span class="ms-title" id="ms_title_<?php echo $element['id']; ?>"><?php echo $element['title']; ?></span>
							<?php if(current_user_can('publish_cqpim_quotes')) { ?>
								<div class="dd-milestone-actions">
									<?php if(empty($quote_details['confirmed'])) { ?>
										<button class="edit-milestone cqpim_button cqpim_small_button font-white bg-amber op rounded_2 cqpim_tooltip" value="<?php echo $element['id']; ?>" title="<?php _e('Edit Milestone', 'cqpim'); ?>"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></button><button class="delete_stage_conf cqpim_button cqpim_small_button font-white bg-red op rounded_2 cqpim_tooltip" data-id="<?php echo $element['id']; ?>" value="<?php echo $element['id']; ?>"  title="<?php _e('Delete Milestone', 'cqpim'); ?>"><i class="fa fa-trash" aria-hidden="true"></i></button><button class="add_task cqpim_button cqpim_small_button font-white bg-green op rounded_2 cqpim_tooltip" data-ms="<?php echo $element['id']; ?>" data-project="<?php echo $post->ID; ?>" value="<?php echo $element['id']; ?>" title="<?php _e('Add Task to Milestone', 'cqpim'); ?>"><i class="fa fa-plus" aria-hidden="true"></i></button><button class="dd-reorder cqpim_button cqpim_small_button font-white bg-blue op rounded_2 cqpim_tooltip" value="<?php echo $element['id']; ?>" title="<?php _e('Reorder Milestone', 'cqpim'); ?>"><i class="fa fa-sort" aria-hidden="true"></i></button>
									<?php } else { ?>
										<span class="cqpim_button cqpim_small_button font-white bg-red op rounded_2 cqpim_tooltip nolink"><?php _e('LOCKED', 'cqpim'); ?></span>
									<?php } ?>							
								</div>
							<?php } ?>
							<div class="dd-milestone-info">
								<?php if(!empty($element['cost'])) { ?>
									<span id="ms_cost_<?php echo $element['id']; ?>"><?php echo pto_calculate_currency($post->ID, $element['cost']); ?></span>
								<?php } ?>
								<?php if(!empty($element['start'])) { ?>
									<i class="fa fa-circle dd-circle"></i> <strong><?php _e('Start Date:', 'cqpim'); ?></strong> <span id="ms_start_<?php echo $element['id']; ?>"><?php echo wp_date(get_option('cqpim_date_format'), $element['start']); ?></span>
								<?php } ?>
								<?php if(!empty($element['deadline'])) { ?>
									<i class="fa fa-circle dd-circle"></i> <strong><?php _e('Deadline:', 'cqpim'); ?></strong> <span id="ms_deadline_<?php echo $element['id']; ?>"><?php echo wp_date(get_option('cqpim_date_format'), $element['deadline']); ?></span>
								<?php } ?>
							</div>
							<div class="clear"></div>
						</div>
						<div class="dd-tasks" data-ms="<?php echo $element['id']; ?>">
							<?php 
							$args = array(
								'post_type' => 'cqpim_tasks',
								'posts_per_page' => -1,
								'meta_key' => 'milestone_id',
								'meta_value' => $element['id'],
								'orderby' => 'date',
								'order' => 'ASC'
							);
							$tasks = get_posts($args);
							$ordered = array();
							foreach($tasks as $task) {
								$task_details = get_post_meta($task->ID, 'task_details', true);
								$weight = isset($task_details['weight']) ? $task_details['weight'] : 0;
								if(empty($task->post_parent)) {
									$ordered[$weight] = $task;
								}
							}
							ksort($ordered);
							foreach($ordered as $task) {
								$task_details = get_post_meta($task->ID, 'task_details', true);
								$task_deadline = isset($task_details['deadline']) ? $task_details['deadline'] : '';
								$start = isset($task_details['task_start']) ? $task_details['task_start'] : '';
								$description = isset($task_details['task_description']) ? $task_details['task_description'] : '';
								$weight = isset($task_details['weight']) ? $task_details['weight'] : 0;
								$task_est_time = isset($task_details['task_est_time']) ? $task_details['task_est_time'] : '';
								?>	
								<div class="dd-task" id="task-<?php echo $task->ID; ?>">
									<input class="task_weight" type="hidden" name="task_weight_<?php echo $task->ID; ?>" id="task_weight_<?php echo $task->ID; ?>" value="<?php echo $weight; ?>" />
									<input class="task_id" type="hidden" name="task_id_<?php echo $task->ID; ?>" id="task_id_<?php echo $task->ID; ?>" value="<?php echo $task->ID; ?>" />
									<input class="task_msid" type="hidden" name="task_msid_<?php echo $task->ID; ?>" id="task_msid_<?php echo $task->ID; ?>" value="<?php echo $element['id']; ?>" />
									<span class="table-task cqpim_button cqpim_small_button font-white bg-grey-cascade op nolink rounded_2"><?php _e('Task', 'cqpim'); ?></span> <span class="ms-title" id="task_title_<?php echo $task->ID; ?>"><?php echo $task->post_title; ?></span>
									<?php if(current_user_can('publish_cqpim_quotes')) { ?>
										<div class="dd-task-actions">
											<?php if(empty($quote_details['confirmed'])) { ?>
												<button class="edit-task cqpim_button cqpim_small_button font-white bg-amber op rounded_2 cqpim_tooltip" value="<?php echo $task->ID; ?>" title="<?php _e('Edit Task', 'cqpim'); ?>"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></button><button class="delete_task_trigger cqpim_button cqpim_small_button font-white bg-red op rounded_2 cqpim_tooltip" data-id="<?php echo $task->ID; ?>" value="<?php echo $task->ID; ?>" title="<?php _e('Delete Task', 'cqpim'); ?>"><i class="fa fa-trash" aria-hidden="true"></i></button><button class="add_subtask cqpim_button cqpim_small_button font-white bg-green op rounded_2 cqpim_tooltip" data-ms="<?php echo $element['id']; ?>" data-project="<?php echo $post->ID; ?>" value="<?php echo $task->ID; ?>" title="<?php _e('Add Subtask', 'cqpim'); ?>"><i class="fa fa-plus" aria-hidden="true"></i></button><button class="dd-reorder cqpim_button cqpim_small_button font-white bg-blue op rounded_2 cqpim_tooltip" value="<?php echo $element['id']; ?>" title="<?php _e('Reorder Task', 'cqpim'); ?>"><i class="fa fa-sort" aria-hidden="true"></i></button>
											<?php } else { ?>
												<span class="cqpim_button cqpim_small_button font-white bg-red op rounded_2 cqpim_tooltip nolink"><?php _e('LOCKED', 'cqpim'); ?></span>
											<?php } ?>
										</div>
									<?php } ?>
									<div class="dd-task-info">
										<?php if(!empty($start)) { ?>
											<strong><?php _e('Start Date:', 'cqpim') ?></strong> <span id="task_start_<?php echo $task->ID; ?>"><?php echo wp_date(get_option('cqpim_date_format'), $start); ?></span>
										<?php } ?>
										<?php if(!empty($task_deadline)) { ?>
											<i class="fa fa-circle dd-circle"></i> <strong><?php _e('Deadline:', 'cqpim') ?></strong> <span id="task_deadline_<?php echo $task->ID; ?>"><?php echo wp_date(get_option('cqpim_date_format'), $task_deadline); ?></span>
										<?php } ?>	
										<?php if(!empty($task_est_time)) { ?>
											<i class="fa fa-circle dd-circle"></i> <strong><?php _e('Est. Time:', 'cqpim') ?></strong> <span id="task_time_<?php echo $task->ID; ?>"><?php echo $task_est_time; ?></span>
										<?php } ?>										
									</div>
									<div class="clear"></div>
									<div class="dd-subtasks">
										<?php 
										$args = array(
											'post_type' => 'cqpim_tasks',
											'posts_per_page' => -1,
											'meta_key' => 'milestone_id',
											'meta_value' => $element['id'],
											'post_parent' => $task->ID,
											'orderby' => 'date',
											'order' => 'ASC'
										);
										$subtasks = get_posts($args);
										$ordered = array();
										foreach($subtasks as $subtask) {
											$task_details = get_post_meta($subtask->ID, 'task_details', true);
											$weight = isset($task_details['weight']) ? $task_details['weight'] : 0;
											$ordered[$weight] = $subtask;
										}
										ksort($ordered);
										if(!empty($ordered)) {
											foreach($ordered as $subtask) {
												$task_details = get_post_meta($subtask->ID, 'task_details', true);
												$task_deadline = isset($task_details['deadline']) ? $task_details['deadline'] : '';
												$start = isset($task_details['task_start']) ? $task_details['task_start'] : '';
												$description = isset($task_details['task_description']) ? $task_details['task_description'] : '';
												$sweight = isset($task_details['weight']) ? $task_details['weight'] : 0;
												$task_est_time = isset($task_details['task_est_time']) ? $task_details['task_est_time'] : '';
												?>	
												<div class="dd-subtask" id="task-<?php echo $subtask->ID; ?>">
													<input class="task_weight" type="hidden" name="task_weight_<?php echo $subtask->ID; ?>" id="task_weight_<?php echo $subtask->ID; ?>" value="<?php echo $sweight; ?>" />
													<input class="task_id" type="hidden" name="task_weight_<?php echo $subtask->ID; ?>" id="task_weight_<?php echo $subtask->ID; ?>" value="<?php echo $subtask->ID; ?>" />
													<span class="table-task cqpim_button cqpim_small_button font-white bg-grey-cascade op nolink rounded_2"><?php _e('Subtask', 'cqpim'); ?></span> <span class="ms-title" id="task_title_<?php echo $subtask->ID; ?>"><?php echo $subtask->post_title; ?></span>
													<?php if(current_user_can('publish_cqpim_quotes')) { ?>
														<div class="dd-task-actions">
															<?php if(empty($quote_details['confirmed'])) { ?>
																<button class="edit-task cqpim_button cqpim_small_button font-white bg-amber op rounded_2 cqpim_tooltip" value="<?php echo $subtask->ID; ?>" title="<?php _e('Edit Subtask', 'cqpim'); ?>"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></button><button class="delete_subtask_trigger cqpim_button cqpim_small_button font-white bg-red op rounded_2 cqpim_tooltip" data-id="<?php echo $subtask->ID; ?>" value="<?php echo $subtask->ID; ?>"><i class="fa fa-trash" aria-hidden="true" title="<?php _e('Delete Task', 'cqpim'); ?>"></i></button><button class="dd-reorder cqpim_button cqpim_small_button font-white bg-blue op rounded_2 cqpim_tooltip" value="<?php echo $element['id']; ?>" title="<?php _e('Reorder Task', 'cqpim'); ?>"><i class="fa fa-sort" aria-hidden="true"></i></button>
															<?php } else { ?>
																<span class="cqpim_button cqpim_small_button font-white bg-red op rounded_2 nolink"><?php _e('LOCKED', 'cqpim'); ?></span>
															<?php } ?>
														</div>
														<br />
													<?php } ?>
													<div class="dd-task-info">
														<?php if(!empty($start)) { ?>
															<strong><?php _e('Start Date:', 'cqpim') ?></strong> <span id="task_start_<?php echo $subtask->ID; ?>"><?php echo wp_date(get_option('cqpim_date_format'), $start); ?></span>
														<?php } ?>
														<?php if(!empty($task_deadline)) { ?>
															<i class="fa fa-circle dd-circle"></i> <strong><?php _e('Deadline:', 'cqpim') ?></strong> <span id="task_deadline_<?php echo $subtask->ID; ?>"><?php echo wp_date(get_option('cqpim_date_format'), $task_deadline); ?></span>
														<?php } ?>	
														<?php if(!empty($task_est_time)) { ?>
															<i class="fa fa-circle dd-circle"></i> <strong><?php _e('Est. Time:', 'cqpim') ?></strong> <span id="task_time_<?php echo $subtask->ID; ?>"><?php echo $task_est_time; ?></span>
														<?php } ?>											
													</div>
													<div class="clear"></div>
												</div>
											<?php } ?>
										<?php } ?>
									</div>
								</div>
							<?php } ?>
						</div>
					</div>
				<?php } ?>
			</div>
		<?php }
	} else {
		_e('Please update this post before adding milestones', 'cqpim');
	}
	if(current_user_can('publish_cqpim_quotes')) { ?>	
	
		<!-- Action Buttons -->
	
		<?php if(empty($quote_details['confirmed_details']['date'])) { ?>
			<?php if(current_user_can('cqpim_apply_project_templates')) { ?>
				<a href="#apply-template" id="apply-template" class="mt-20 cqpim_button bg-blue font-white rounded_2 right colorbox"><?php _e('Apply Milestone Template', 'cqpim'); ?></a>
			<?php } ?>
			<a href="#add-milestone-div" id="add-milestone" class="mt-20 cqpim_button bg-blue font-white rounded_2 right colorbox"><?php _e('Add Milestone', 'cqpim'); ?></a>
			<a href="#clear-all" id="clear-all" class="mt-20 cqpim_button bg-blue font-white rounded_2 right colorbox"><?php _e('Clear All Milestones / Tasks', 'cqpim'); ?></a>
			<div class="clear"></div>
		<?php } ?>
		
		<!-- Apply Template Colorbox -->
		
		<div id="apply-template-div-container" style="display:none">
			<div id="apply-template-div">
				<div style="padding:12px">
					<h3><?php _e('Apply Milestone / Task Template', 'cqpim'); ?></h3>
					<?php
					$elements = get_post_meta($post->ID, 'quote_elements', true);
					if(empty($elements)) {
						echo '<p>' . _e('Choose a template to apply Milestones and Tasks from.', 'cqpim') . '</p>';
					} else {
						echo '<p>' . _e('You already have Milestones and Tasks on this quote, applying a template will overwrite them with the contents of the template.', 'cqpim') . '</p>';						
					}
					$args = array(
						'post_type' => 'cqpim_templates',
						'posts_per_page' => -1,
						'post_status' => 'private'
					);
					$templates = get_posts($args);
					?>
					<select id="template_choice">
						<option value=""><?php _e('Choose a template...', 'cqpim'); ?></option>
						<?php foreach($templates as $template) { ?>
							<option value="<?php echo $template->ID; ?>"><?php echo $template->post_title; ?></option>
						<?php } ?>
					</select>
					<br /><br />
					<button class="cancel-colorbox cqpim_button op font-white bg-red rounded_2"><?php _e('Cancel', 'cqpim'); ?></button>
					<button id="apply-template-action" class="metabox-add-button cqpim_button font-white bg-green rounded_2 right op" data-type="quote" value="<?php echo $post->ID; ?>"><?php _e('Apply Template', 'cqpim'); ?></button>
					<div class="clear"></div>
					<br />
					<div id="apply-template-messages"></div>
				</div>
			</div>
		</div>
		
		<!-- Clear All Colorbox -->
		
		<div id="clear-all-div-container" style="display:none">
			<div id="clear-all-div">
				<div style="padding:12px">
					<h3><?php _e('Clear All', 'cqpim'); ?></h3>
					<p><?php _e('Are you sure you want to clear all Milestones and Tasks? This cannot be undone.', 'cqpim'); ?></p>
					<br /><br />
					<button class="cancel-colorbox cqpim_button op font-white bg-red rounded_2"><?php _e('Cancel', 'cqpim'); ?></button>
					<button id="clear-all-action" class="metabox-add-button cqpim_button font-white bg-green rounded_2 right op" data-type="quote" value="<?php echo $post->ID; ?>"><?php _e('Clear All', 'cqpim'); ?></button> <div id="clear_spinner" class="ajax_spinner" style="display:none"></div>
					<div class="clear"></div>
					<br />
					<div id="clear-all-messages"></div>
				</div>
			</div>
		</div>
		
		<!-- Add Milestone Colorbox -->
		
		<div id="add-milestone-div-container" style="display:none">
			<div id="add-milestone-div">
				<div style="padding:12px">
					<h3><?php _e('Add Milestone', 'cqpim'); ?></h3>
					<div id="add_milestone_form">
						<input style="width:100%" type="text" name="quote_element_title" id="quote_element_title" placeholder="<?php _e('Milestone title, eg. \'Design Phase\'', 'cqpim'); ?>"/>
						<input style="width:100%" class="datepicker" type="text" name="quote_element_start" id="quote_element_start" placeholder="<?php _e('Start', 'cqpim'); ?>"/>
						<input style="width:100%" class="datepicker" type="text" name="quote_element_finish" id="quote_element_finish" placeholder="<?php _e('Deadline', 'cqpim'); ?>"/>
						<?php if($type == 'estimate') { ?>
							<input style="width:100%" type="text" name="quote_element_cost" id="quote_element_cost" placeholder="<?php _e('Estimated Cost', 'cqpim'); ?>"/>
						<?php } else { ?>
							<input style="width:100%" type="text" name="quote_element_cost" id="quote_element_cost" placeholder="<?php _e('Cost', 'cqpim'); ?>"/>
						<?php } ?>
						<br /><br />
						<button class="cancel-colorbox cqpim_button op font-white bg-red rounded_2"><?php _e('Cancel', 'cqpim'); ?></button>
						<input type="submit" id="add_quote_element" class="metabox-add-button cqpim_button font-white bg-green rounded_2 right op" value="<?php _e('Add Milestone', 'cqpim'); ?>">
					</div>
				</div>
			</div>	
		</div>
		
		<!-- Edit Milestone Colorbox -->
		
		<div id="edit-milestone-container" style="display:none">
			<div id="edit-milestone" class="edit_milestone">
				<div style="padding:12px">
					<h3><?php _e('Edit Milestone', 'cqpim'); ?></h3>
					<input type="hidden" class="element_id" id="edit_milestone_id" value="" />
					<span class="label"><strong><?php _e('Title:', 'cqpim'); ?></strong></span>
					<input type="text" id="edit_milestone_title" value="" />
					<br />
					<span class="label"><strong><?php _e('Start Date:', 'cqpim'); ?></strong></span>
					<input class="datepicker" type="text" id="edit_milestone_start" value="" />
					<br />
					<span class="label"><strong><?php _e('Deadline:', 'cqpim'); ?></strong></span>
					<input class="datepicker" type="text" id="edit_milestone_end" value="" />
					<br />
					<?php if($type == 'estimate') { ?>
						<span class="label"><strong><?php _e('Estimated Cost:', 'cqpim'); ?></strong></span>
					<?php } else { ?>
						<span class="label"><strong><?php _e('Cost:', 'cqpim'); ?></strong></span>
					<?php } ?>
					<input type="text" id="edit_milestone_cost" value="" />
					<br /><br />
					<button class="cancel-colorbox cqpim_button op font-white bg-red rounded_2"><?php _e('Cancel', 'cqpim'); ?></button>
					<button class="save-milestone metabox-add-button cqpim_button font-white bg-green rounded_2 right op" value=""><?php _e('Save', 'cqpim'); ?></button>
					<div class="clear"></div>
					<div id="edit-milestone-messages"></div>
				</div>
			</div>
		</div>
		
		<!-- Delete Milestone Colorbox -->
		
		<div id="delete-milestone-div-container" style="display:none">
			<div id="delete-milestone" class="delete-milestone-div">
				<div style="padding:12px">
					<h3><?php _e('Are you sure?', 'cqpim'); ?></h3>
					<p><?php _e('Deleting this milestone will also delete related tasks. Are you sure you want to do this?', 'cqpim'); ?></p>
					<br />
					<button class="cancel_delete_stage cqpim_button op font-white bg-red rounded_2"><?php _e('Cancel', 'cqpim'); ?></button>
					<button id="delete-milestone-button" class="delete_stage metabox-add-button cqpim_button font-white bg-green rounded_2 right op" value=""><?php _e('Delete', 'cqpim'); ?></button>
					<div class="clear"></div>
					<div id="delete-milestone-messages"></div>
				</div>
			</div>
		</div>
		
		<!-- Add Task Colorbox -->
		
		<div id="add-task-div-container" style="display:none">
			<div id="add-task-div" class="add-task-div">
				<div style="padding:12px">
					<h3><?php _e('Add Task', 'cqpim'); ?></h3>
					<input type="hidden" id="add_task_milestone_id" value="" />
					<input type="hidden" id="add_task_project_id" value="<?php echo $post->ID; ?>" />
					<input style="width:100%" type="text" id="add_task_title" placeholder="<?php _e('Task title', 'cqpim'); ?>"/><br /><br />					
					<textarea style="width:100%;height:100px" id="add_task_description" placeholder="<?php _e('Task description', 'cqpim'); ?>"></textarea><br /><br />
					<input style="width:100%"class="datepicker" type="text" id="add_task_start" placeholder="<?php _e('Start Date', 'cqpim'); ?>"/><br /><br />
					<input style="width:100%"class="datepicker" type="text" id="add_task_finish" placeholder="<?php _e('Deadline', 'cqpim'); ?>"/><br /><br />
					<input style="width:100%" type="text" id="add_task_time" placeholder="<?php _e('Estimated Time (in decimal format, eg. 4.5 hours)', 'cqpim'); ?>"/>																		
					<div class="clear"></div>
					<br /><br />
					<button class="cancel-colorbox cqpim_button op font-white bg-red rounded_2"><?php _e('Cancel', 'cqpim'); ?></button>
					<button class="save-task metabox-add-button cqpim_button font-white bg-green rounded_2 right op"><?php _e('Add Task', 'cqpim'); ?></button>
					<div class="clear"></div>
					<div id="add-task-messages"></div>
				</div>
			</div>	
		</div>
		
		<!-- Delete Task Colorbox -->
		
		<div id="delete-task-div-container" style="display:none">
			<div id="delete-task" class="delete-task-div">
				<div style="padding:12px">
					<h3><?php _e('Are you sure?', 'cqpim'); ?></h3>
					<p><?php _e('Deleting this task will also delete the attached subtasks. This action cannot be undone.', 'cqpim'); ?></p>
					<br />
					<button class="cancel_delete_task cqpim_button op font-white bg-red rounded_2"><?php _e('Cancel', 'cqpim'); ?></button>
					<button id="delete-task-button" class="delete_stage metabox-add-button cqpim_button font-white bg-green rounded_2 right op" value=""><?php _e('Delete', 'cqpim'); ?></button>
					<div class="clear"></div>
					<div id="delete-task-messages"></div>
				</div>
			</div>
		</div>
		
		<!-- Add SubTask Colorbox -->
		
		<div id="add-subtask-div-container" style="display:none">
			<div id="add-subtask-div" class="add-subtask-div">
				<div style="padding:12px">
					<h3><?php _e('Add Subtask', 'cqpim'); ?></h3>
					<input type="hidden" id="add_subtask_milestone_id" value="" />
					<input type="hidden" id="add_subtask_parent_id" value="" />
					<input type="hidden" id="add_subtask_project_id" value="<?php echo $post->ID; ?>" />
					<input style="width:100%" type="text" id="add_subtask_title" placeholder="<?php _e('Task title', 'cqpim'); ?>"/><br /><br />					
					<textarea style="width:100%;height:100px" id="add_subtask_description" placeholder="<?php _e('Task description', 'cqpim'); ?>"></textarea><br /><br />
					<input style="width:100%"class="datepicker" type="text" id="add_subtask_start" placeholder="<?php _e('Start Date', 'cqpim'); ?>"/><br /><br />
					<input style="width:100%"class="datepicker" type="text" id="add_subtask_finish" placeholder="<?php _e('Deadline', 'cqpim'); ?>"/><br /><br />
					<input style="width:100%" type="text" id="add_subtask_time" placeholder="<?php _e('Estimated Time (in decimal format, eg. 4.5 hours)', 'cqpim'); ?>"/>																		
					<div class="clear"></div>
					<br /><br />
					<button class="cancel-colorbox cqpim_button op font-white bg-red rounded_2"><?php _e('Cancel', 'cqpim'); ?></button>
					<button class="save-subtask metabox-add-button cqpim_button font-white bg-green rounded_2 right op"><?php _e('Add Subtask', 'cqpim'); ?></button>
					<div class="clear"></div>
					<div id="add-subtask-messages"></div>
				</div>
			</div>	
		</div>
		
		<!-- Delete SubTask Colorbox -->
		
		<div id="delete-subtask-div-container" style="display:none">
			<div id="delete-subtask" class="delete-subtask-div">
				<div style="padding:12px">
					<h3><?php _e('Are you sure?', 'cqpim'); ?></h3>
					<p><?php _e('Are you sure you want to delete this subtask? This action cannot be undone.', 'cqpim'); ?></p>
					<br />
					<button class="cancel_delete_task cqpim_button op font-white bg-red rounded_2"><?php _e('Cancel', 'cqpim'); ?></button>
					<button id="delete-subtask-button" class="delete_stage metabox-add-button cqpim_button font-white bg-green rounded_2 right op" value=""><?php _e('Delete', 'cqpim'); ?></button>
					<div class="clear"></div>
					<div id="delete-subtask-messages"></div>
				</div>
			</div>
		</div>
		
		<!-- Edit Task Colorbox -->
		
		<div id="edit-task-div-container" style="display:none">
			<div id="edit-task" class="edit-task-div">
				<div style="padding:12px">
					<h3><?php _e('Edit Task', 'cqpim'); ?></h3>
					<input type="hidden" name="edit_task_id" id="edit_task_id" value="" />
					<span class="label"><strong><?php _e('Title:', 'cqpim'); ?></strong></span>
					<input type="text" name="edit_task_title" id="edit_task_title" value="" placeholder="<?php _e('Task title', 'cqpim'); ?>"/>							
					<span class="label"><strong><?php _e('Description:', 'cqpim'); ?></strong></span>
					<textarea style="width:100%;height:100px" name="edit_task_description" id="edit_task_description" placeholder="<?php _e('Task description', 'cqpim'); ?>"></textarea>
					<span class="label"><strong><?php _e('Start:', 'cqpim'); ?></strong></span>
					<input class="datepicker" type="text" name="edit_task_start" id="edit_task_start" value="" placeholder="<?php _e('Start Date', 'cqpim'); ?>"/>														
					<span class="label"><strong><?php _e('Deadline:', 'cqpim'); ?></strong></span>
					<input class="datepicker" type="text" name="edit_task_finish" id="edit_task_finish" value="" placeholder="<?php _e('Deadline', 'cqpim'); ?>"/>	
					<span class="label"><strong><?php _e('Est Time:', 'cqpim'); ?></strong></span>
					<input type="text" name="edit_task_time" id="edit_task_time" value="" placeholder="<?php _e('Estimated Time (in decimal format, eg. 4.5 hours)', 'cqpim'); ?>"/>	
					<br /><br />
					<button class="cancel-colorbox cqpim_button op font-white bg-red rounded_2"><?php _e('Cancel', 'cqpim'); ?></button>
					<button class="update-task metabox-add-button cqpim_button font-white bg-green rounded_2 right op" value=""><?php _e('Save', 'cqpim'); ?></button>
					<div class="clear"></div>
					<div id="edit_task_messages"></div>
				</div>
			</div>	
		</div>
		
	<?php }
}