<?php
/**
 * Initial Settings Wizard.
 */

/**
* Install PTO and setup initial wizard.
*/
function pto_install() {
	if ( 1 == get_option( 'pto_run_setup_wizard' ) ) {
		global $pagenow;
		if ( 'plugins.php'  == $pagenow ) {
			$url = admin_url() . 'admin.php?page=pto-settings&sub-page=pto-welcome';
			exit( wp_redirect( $url ) );
		}
	}
}
add_action( 'admin_init', 'pto_install', 99999 );

add_action( 'admin_body_class' , 'initial_register_pto_settings_page',5 ); 
function initial_register_pto_settings_page() {
    if ( 1 == get_option( 'pto_run_setup_wizard' )  && ! empty( $_GET['page'] ) && 'pto-settings'  === $_GET['page'] && ! empty( $_GET['sub-page'] ) && 'pto-initial-settings'  === $_GET['sub-page'] ) {
		pto_open_initial_settings_wizard();
	}

	if ( 1 == get_option( 'pto_run_setup_wizard' ) && ! empty( $_GET['page'] ) && 'pto-settings'  === $_GET['page'] && ! empty( $_GET['sub-page'] ) && 'pto-welcome'  === $_GET['sub-page'] ) {
		pto_open_initial_settings_popup();
	}
}

function pto_open_initial_settings_wizard() {
	update_option( 'pto_run_setup_wizard', 2 );
    ?>
    <div class="pto-modal-wrapper">
		 <form method="post" id="initial-settings-form" class="initial-settings-popup">
			<figure class="pto-logo-container">
				<img src="<?php echo PTO_PLUGIN_URL . '/img/pto-logo.png' ?>" alt="projectopia" class="pto-logo"/>
			</figure>
			<div id="wizard">
			   <!-- SECTION 1 -->
			   <h4></h4>
			   <section>
				  <div class="input-group">
					 <label for="company_name"> Company Name </label>
					 <input type="text" class="form-input" name="company_name" value="<?php echo esc_attr( get_option( 'company_name' ) ); ?>"/>
				  </div>
				  <div class="input-group">
					 <label for="company_address"> Company Address </label>
					 <textarea name="company_address" class="form-input" style="min-height: 80px"><?php echo trim( esc_attr( get_option( 'company_address' ) ) ); ?></textarea>
				  </div>
				  <div class="input-group">
					 <label for="company_postcode">Company Postcode:</label>
					 <input type="text" class="form-input" name="company_postcode" value="<?php echo esc_attr( get_option( 'company_postcode' ) ); ?>" />
				  </div>
				  <div class="input-group">
					 <label for="company_telephone">Company Telephone:</label>
					 <input type="text" class="form-input"  name="company_telephone" value="<?php echo esc_attr( get_option( 'company_telephone' ) ); ?>" />
				  </div>
			   </section>
			   <!-- SECTION 2 -->
			   <h4></h4>
			   <section>
				  <div class="input-group">
					 <label for="company_sales_email"> Sales Email <span class="required-star">*</span> </label>
					 <input type="email" class="form-input required" name="company_sales_email" value="<?php echo esc_attr( get_option( 'company_sales_email' ) ); ?>"/>
				  </div>
				  <div class="input-group">
					 <label for="company_accounts_email">Accounts Email <span class="required-star">*</span></label>
					 <input type="email" class="form-input required" name="company_accounts_email" value="<?php echo esc_attr( get_option( 'company_accounts_email' ) ); ?>"/>
				  </div>
				  <div class="input-group">
					 <label for="company_support_email">Support Email (For Support Tickets)<span class="required-star">*</span> </label>
					 <input type="email" class="form-input required" name="company_support_email" value="<?php echo esc_attr( get_option( 'company_support_email' ) ); ?>"/>
				  </div>
			   </section>
			   <!-- SECTION 3 -->
			   <h4></h4>
			   <section>
				  <div class="input-group">
					 <label for="currency_symbol">Currency Symbol:</label>
					 <input type="text" class="form-input" name="currency_symbol" value="<?php echo esc_attr( get_option( 'currency_symbol' ) ); ?>"/>
				  </div>
				  <div class="input-group">
					 <label for="currency_symbol_position">Currency Symbol Position:</label>
					 <?php
						$symbol_position = get_option( 'currency_symbol_position' );
						$selectedl = '';
						$selectedr = '';
						if ( 'l' == $symbol_position ) {
							$selectedl = 'selected="selected"';
						} elseif( 'r' == $symbol_position ) {
							$selectedr = 'selected="selected"';
						}
					?>
					 <select name="currency_symbol_position">
						<option value="l" <?php echo $selectedl; ?>> <?php echo ('Before Amount cqpim'); ?></option>
						<option value="r" <?php echo $selectedr; ?>> <?php echo ('After Amount cqpim'); ?></option>
					 </select>
				  </div>
				  <div class="input-group">
					 <label for="currency_code">Currency Code (Used for Payment Gateways):</label>
					<select name="currency_code" >
						<option value="0"><?php echo ('Choose a currency cqpim'); ?></option>
						<?php
						$stored_code = get_option( 'currency_code' );
						if ( function_exists('pto_return_currency_select') ) {
							$codes = pto_return_currency_select();
						}
						if ( ! empty( $codes ) ) {
							foreach($codes as $key => $code) {
								$checked = '';
								if ( $key == $stored_code) {
									 $checked = 'selected="selected"'; 
								}
								echo '<option value="' . $key . '" ' . $checked . '>' . $code . '</option>';
							}
						}
						?>
					</select>
				  </div>
			   </section>
			   <!-- SECTION 4 -->
			   <h4></h4>
			   <section>
					<p class="sub-header">These settings apply to sales tax, such as VAT. If you do not charge sales tax, then leave these fields blank.</p>
				  	<div class="input-group">
					 	<label for="sales_tax_rate">Tax Percentage (eg. 20): </label>
					 	<input type="text" class="form-input" name="sales_tax_rate" value="<?php echo esc_attr( get_option( 'sales_tax_rate' ) ); ?>"/>
					</div>
				  	<div class="input-group">
						<label for="sales_tax_name">Tax Name (eg. VAT):</label>
						<input type="text" class="form-input" name="sales_tax_name" value="<?php echo esc_attr( get_option( 'sales_tax_name' ) ); ?>"/>
				  	</div>
				  	<div class="input-group">
					 	<label for="sales_tax_reg">Tax Reg Number:</label>
					 	<input type="text" class="form-input" name="sales_tax_reg" value="<?php echo esc_attr( get_option( 'sales_tax_reg' ) ); ?>"/>
				  	</div>
			   </section>
			   <!-- SECTION 5 -->
			   <h4></h4>
			   <section>
					<div class="switch-field">
						<input type="radio" id="pto-stripe" name="pto-payment" value="yes" checked/>
						<label for="pto-stripe">Stripe</label>
						<input type="radio" id="pto-paypal" name="pto-payment" value="no" />
						<label for="pto-paypal">Paypal</label>
					</div>
					<div class="pto-payment-gateway-stripe">
						<p class="sub-header">To allow clients to pay invoices and set up subscriptions via Stripe, enter your Stripe Publishable Key below.</p>
						<div class="input-group">
							<label for="client_invoice_stripe_key">Stripe Public Key </label>
							<input type="text" class="form-input" name="client_invoice_stripe_key" value="<?php echo esc_attr( get_option( 'client_invoice_stripe_key' ) ); ?>"/>
						</div>
						<div class="input-group">
							<label for="client_invoice_stripe_secret">Stripe Secret Key</label>
							<input type="text" class="form-input" name="client_invoice_stripe_secret" value="<?php echo esc_attr( get_option( 'client_invoice_stripe_secret' ) ); ?>"/>
						</div>
						<div>
							<label for="company_support_email">
								<input type="checkbox" value="1" name="client_invoice_stripe_ideal" <?php checked(1, get_option('client_invoice_stripe_ideal')); ?> />
								If you have iDEAL activated on your Stripe account, check this box to enable it as a payment gateway.
								<span class="checkmark"></span>
							</label>
						</div>
					</div>
					<div class="pto-payment-gateway-paypal">
						<p class="sub-header">To allow clients to pay invoices via Paypal, enter your Paypal email address below.</p>
						<div class="input-group">
							<label for="client_invoice_paypal_address">Paypal Email Address </label>
							<input type="text" class="form-input" name="client_invoice_paypal_address" value="<?php echo esc_attr( get_option( 'client_invoice_paypal_address' ) ); ?>"/>
						</div>
						<p class="sub-header">To allow clients to set up subscriptions via Paypal, enter your Paypal API credentials below.</p>
						<div class="input-group">
							<label for="cqpim_paypal_api_username">Paypal API Username</label>
							<input type="text" class="form-input"  name="cqpim_paypal_api_username" value="<?php echo esc_attr( get_option( 'cqpim_paypal_api_username' ) ); ?>"/>
						</div>
						<div class="input-group">
							<label for="cqpim_paypal_api_password">Paypal API Password</label>
							<input type="text" class="form-input" name="cqpim_paypal_api_password" value="<?php echo esc_attr( get_option( 'cqpim_paypal_api_password' ) ); ?>"/>
						</div>
						<div class="input-group">
							<label for="cqpim_paypal_api_signature">Paypal API Signature</label>
							<input type="text" class="form-input" name="cqpim_paypal_api_signature" value="<?php echo esc_attr( get_option( 'cqpim_paypal_api_signature' ) ); ?>"/>
						</div>
					</div>
			   </section>
			   <p class="sub-header">A link to our documentation <a  href="https://projectopia.io/docs41/" target="_blank">Click here</a></p>
			   <p class="sub-header" style="text-align:center;"><a href="<?php echo esc_url( admin_url() ); ?>">Return to WordPress Dashboard</a></p>
			</div>
		 </form>
	  </div>
    <?php
}

add_action( "wp_ajax_pto_save_initial_settings_options", "pto_save_initial_settings_options");
/**
 * Function to update the initial setting options in installation process.
 */
function pto_save_initial_settings_options() {
	// Company details.
	$company_name = filter_input( INPUT_POST, "company_name", FILTER_SANITIZE_STRING );
	if ( ! empty( $company_name ) ) {
		update_option( 'company_name', $company_name );
	}

	$company_address = filter_input( INPUT_POST, "company_address", FILTER_SANITIZE_STRING );
	if ( ! empty( $company_address ) ) {
		update_option( 'company_address', $company_address );
	}

	$company_postcode = filter_input( INPUT_POST, "company_postcode", FILTER_SANITIZE_STRING );
	if ( ! empty( $company_postcode ) ) {
		update_option( 'company_postcode', $company_postcode );
	}

	$company_telephone = filter_input( INPUT_POST, "company_telephone", FILTER_SANITIZE_NUMBER_INT );
	if ( ! empty( $company_telephone ) ) {
		update_option( 'company_telephone', $company_telephone );
	}

	// Company emails.
	$company_sales_email = filter_input( INPUT_POST, "company_sales_email", FILTER_SANITIZE_EMAIL );
	if ( ! empty( $company_sales_email ) ) {
		update_option( 'company_sales_email', $company_sales_email );
	}

	$company_accounts_email = filter_input( INPUT_POST, "company_accounts_email", FILTER_SANITIZE_EMAIL );
	if ( ! empty( $company_accounts_email ) ) {
		update_option( 'company_accounts_email', $company_accounts_email );
	}

	$company_support_email  = filter_input( INPUT_POST, "company_support_email", FILTER_SANITIZE_EMAIL );
	if ( ! empty( $company_support_email ) ) {
		update_option( 'company_support_email', $company_support_email );
	}

	// Finance details
	$currency_symbol = filter_input( INPUT_POST, "currency_symbol", FILTER_SANITIZE_STRING );
	if ( ! empty( $currency_symbol ) ) {
		update_option( 'currency_symbol', $currency_symbol );
	}

	$currency_symbol_position = filter_input( INPUT_POST, "currency_symbol_position", FILTER_SANITIZE_STRING );
	if ( ! empty( $currency_symbol_position ) ) {
		update_option( 'currency_symbol_position', $currency_symbol_position );
	}

	$currency_code = filter_input( INPUT_POST, "currency_code", FILTER_SANITIZE_STRING );
	if ( ! empty( $currency_code ) ) {
		update_option( 'currency_code', $currency_code );
	}

	//Sales tax details
	$sales_tax_rate = filter_input( INPUT_POST, "sales_tax_rate", FILTER_SANITIZE_NUMBER_INT );
	if ( ! empty( $sales_tax_rate ) ) {
		update_option( 'sales_tax_rate', $sales_tax_rate );
	}

	$sales_tax_name = filter_input( INPUT_POST, "sales_tax_name", FILTER_SANITIZE_STRING );
	if ( ! empty( $sales_tax_name ) ) {
		update_option( 'sales_tax_name', $sales_tax_name );
	}

	$sales_tax_reg  = filter_input( INPUT_POST, "sales_tax_reg", FILTER_SANITIZE_STRING );
	if ( ! empty( $sales_tax_reg ) ) {
		update_option( 'sales_tax_reg', $sales_tax_reg );
	}

	//Payment gateway details
	// Stripe details
	$client_invoice_stripe_key = filter_input( INPUT_POST, "client_invoice_stripe_key", FILTER_SANITIZE_STRING );
	if ( ! empty( $client_invoice_stripe_key ) ) {
		update_option( 'client_invoice_stripe_key', $client_invoice_stripe_key );
	}

	$client_invoice_stripe_secret = filter_input( INPUT_POST, "client_invoice_stripe_secret", FILTER_SANITIZE_STRING );
	if ( ! empty( $client_invoice_stripe_secret ) ) {
		update_option( 'client_invoice_stripe_secret', $client_invoice_stripe_secret );
	}

	$client_invoice_stripe_ideal = filter_input( INPUT_POST, "client_invoice_stripe_ideal", FILTER_SANITIZE_NUMBER_INT );;
	if ( isset( $client_invoice_stripe_ideal ) ) {
		update_option( 'client_invoice_stripe_ideal', $client_invoice_stripe_ideal );
	}

	//Paypal details.
	$client_invoice_paypal_address = filter_input( INPUT_POST, "client_invoice_paypal_address", FILTER_SANITIZE_EMAIL );
	if ( ! empty( $client_invoice_paypal_address ) ) {
		update_option( 'client_invoice_paypal_address', $client_invoice_paypal_address );
	}

	$cqpim_paypal_api_username = filter_input( INPUT_POST, "cqpim_paypal_api_username", FILTER_SANITIZE_STRING );
	if ( ! empty( $cqpim_paypal_api_username ) ) {
		update_option( 'cqpim_paypal_api_username', $cqpim_paypal_api_username );
	}

	$cqpim_paypal_api_password = filter_input( INPUT_POST, "cqpim_paypal_api_password", FILTER_SANITIZE_STRING );
	if ( ! empty( $cqpim_paypal_api_password ) ) {
		update_option( 'cqpim_paypal_api_password', $cqpim_paypal_api_password );
	}

	$cqpim_paypal_api_signature = filter_input( INPUT_POST, "cqpim_paypal_api_signature", FILTER_SANITIZE_STRING );
	if ( ! empty( $cqpim_paypal_api_signature ) ) {
		update_option( 'cqpim_paypal_api_signature', $cqpim_paypal_api_signature );
	}

	$cqpim_paypal_enable_sandbox = filter_input( INPUT_POST, "cqpim_paypal_enable_sandbox", FILTER_SANITIZE_STRING );
	if ( ! empty( $cqpim_paypal_enable_sandbox ) ) {
		update_option( 'cqpim_paypal_enable_sandbox', $cqpim_paypal_enable_sandbox );
	}

	$status = array(
		'error'    => false,
		'redirect' => admin_url() . 'admin.php?page=pto-dashboard',
 		'message'  => 'Settings updated successfully'
	);
	update_option( 'pto_run_setup_wizard', 2 );
	header('Content-type: application/json');
	echo json_encode($status);	
	exit();	
}

/**
 * Function to show welcome popup.
 */
function pto_open_initial_settings_popup() {
?>
	<div class="pto-modal-wrapper">
		<div class="initial-settings-popup initial-notification">
			<div id="pre-wizard">
				<p>Thank you for installing Projectopia. Do you want to run the wizard to configure the basic plugin settings ?</p>
				<a class="cqpim_button cqpim_small_button font-white bg-green op" href="<?php echo admin_url(); ?>admin.php?page=pto-settings&sub-page=pto-initial-settings">Yes</a>
				<a id="close-intial-popup" class="cqpim_button cqpim_small_button bg-red font-white op" href="#">No</a>
			</div>
		</div>
	</div>		
<?php
}

add_action( "wp_ajax_pto_initial_setup_popup_cancel", "pto_initial_setup_popup_cancel");
function pto_initial_setup_popup_cancel() {
	update_option( 'pto_run_setup_wizard', 2 );
	$url = admin_url() . 'admin.php?page=pto-dashboard';
	$status =  array( 
		'error' 	=> false,
		'redirect' 	=> $url,
	);
	header('Content-type: application/json');
	echo json_encode($status);
	exit();	
}
