<?php
/**
* Plugin Name: Projectopia - 2Checkout Add-On
* Description: The Projectopia 2Checkout Add-On is a simple plugin allows 2Checkout as a payment option in Projectopia.
* Version: 2.0.1
* Author: Projectopia
* Author URI: http://projectopia.io
* Text Domain: cqpim-2ckeckout
* Domain Path: /languages
*/
define('PTO_2CHECKOUT_VERSION', '2.0.1');
// Paths
define('PTO_2CHECKOUT_PATH', plugin_dir_path( __FILE__ ));
define('PTO_2CHECKOUT_DIRNAME', basename( plugin_basename( PTO_2CHECKOUT_PATH ) ));
define('PTO_2CHECKOUT_PLUGIN_URL', plugins_url() . '/' . PTO_2CHECKOUT_DIRNAME);
// Languages
function pto_twocheck_plugin_setup() {
	load_plugin_textdomain('cqpim-2checkout', false, dirname(plugin_basename(__FILE__)) . '/languages/');
} 
add_action('plugins_loaded', 'pto_twocheck_plugin_setup');
// Script Enqueing
register_activation_hook( __FILE__, 'pto_twocheck_activation' );
function pto_twocheck_activation() {
	if(is_plugin_active(PTO_DIRNAME . '/projectopia.php')) {
	} else {
		$message = __('You need to have the core Projectopia plugin active to activate this Add-On', 'cqpim-2checkout');
		wp_die($message, 'Projectopia Core Plugin Missing');
	}
	if(is_plugin_active('cqpim-2checkout/cqpim-2checkout.php')) {
		$message = __('You must deactivate and remove the old version of CQPIM 2Checkout before installing this one. Make sure you make a backup of any language translation files so that you can reinstate them.', 'cqpim-2checkout');
		wp_die($message, 'Projectopia Core Plugin Version Problem');
	}
}
function pto_twocheck_return_sid() {
	return get_option('client_invoice_twocheck_sid');
}
function pto_twocheck_return_settings() {
	$settings = '<p><strong>' . __('2Checkout', 'cqpim-2checkout') . '</strong></p>';	
	$settings .= '<p>' . __('To allow clients to pay via 2Checkout, enter your 2Checkout account number below', 'cqpim-2checkout') . '</p>';
	$settings .= '<input type="text" name="client_invoice_twocheck_sid" id="client_invoice_twocheck_sid" value="' . get_option('client_invoice_twocheck_sid') . '" />';
	if(pto_check_addon_status('subscriptions')) {
		$settings .= '<p>' . __('To allow clients to set up subscriptions via 2Checkout, enter your 2Checkout API details below.', 'cqpim-2checkout') . '</p>';
		$settings .= '<p>' . __('Publishable Key', 'cqpim-2checkout') . '</p>';
		$settings .= '<input type="text" name="cqpim_twocheck_pub_key" id="cqpim_twocheck_pub_key" value="' . get_option('cqpim_twocheck_pub_key') . '" />';
		$settings .= '<p>' . __('Private Key', 'cqpim-2checkout') . '</p>';
		$settings .= '<input type="text" name="cqpim_twocheck_priv_key" id="cqpim_twocheck_priv_key" value="' . get_option('cqpim_twocheck_priv_key') . '" />';
	}	
	return $settings;
}
function pto_twocheck_return_button($post_id, $name, $price, $return, $email) {
	$form = '<form action="https://sandbox.2checkout.com/checkout/purchase" method="post">
	  <input type="hidden" name="sid" value="' . get_option('client_invoice_twocheck_sid') . '" />
	  <input type="hidden" name="mode" value="2CO" />
	  <input type="hidden" name="li_0_type" value="product" />
	  <input type="hidden" name="li_0_name" value="' . $name . '" />
	  <input type="hidden" name="li_0_price" value="' . $price . '" />
	  <input type="hidden" name="x_receipt_link_url" value="' . $return . '" />
	  <input type="hidden" name="email" value="' . $email . '" />
	  <input type="hidden" name="currency_code" value="' . get_post_meta($post_id, 'currency_code', true) . '" />
	  <input style="max-width:100%" name="submit" type="image" src="' . PTO_2CHECKOUT_PLUGIN_URL . '/img/2co.png" alt="' . __('Pay with 2Checkout', 'cqpim-2checkout') . '" />
	</form>';
	return $form;
}