<?php
// Bug Detils Metabox
function pto_bug_details_metabox_callback( $post ) {
 	wp_nonce_field( 
 	 	'bug_details_metabox', 
 	 	'bug_details_metabox_nonce' );
		$project = get_post_meta($post->ID, 'bug_project', true); 
		$status = get_post_meta($post->ID, 'bug_status', true);
		$assignee = get_post_meta($post->ID, 'bug_assignee', true);
		$updated = get_post_meta($post->ID, 'bug_updated', true);
		$team_details = get_post_meta($assignee, 'team_details', true);
		$team_name = isset($team_details['team_name']) ? $team_details['team_name'] : '';
		$statuses = pto_get_bug_status();
		$project_obj = get_post($project); ?>
		<table class="cqpim_table">
			<tr>
				<td><?php _e('Bug ID', 'cqpim-bugs'); ?></td>
				<td><?php echo $post->ID; ?></td>
			</tr>
			<tr>
				<td><?php _e('Project', 'cqpim-bugs'); ?></td>
				<td><a href="<?php echo get_edit_post_link($project); ?>"><?php echo $project_obj->post_title; ?></a></td>
			</tr>
			<tr>
				<td><?php _e('Status', 'cqpim-bugs'); ?></td>
				<td><span class="<?php echo $statuses[$status]['class']; ?>"><?php echo $statuses[$status]['name']; ?></span></td>
			</tr>
			<tr>
				<td><?php _e('Assignee', 'cqpim-bugs'); ?></td>
				<td><?php echo $team_name; ?></td>
			</tr>
			<tr>
				<td><?php _e('Created', 'cqpim-bugs'); ?></td>
				<td><?php echo get_the_date(get_option('cqpim_date_format') . ' H:i:s', $post->ID); ?></td>
			</tr>
			<tr>
				<td><?php _e('Updated', 'cqpim-bugs'); ?></td>
				<td><?php echo date(get_option('cqpim_date_format') . ' H:i:s', $updated); ?></td>
			</tr>
		</table>
		<?php if(current_user_can('publish_cqpim_bugs')) { ?>
			<a id="save_bug" class="cqpim_button_link cqpim_button font-white bg-blue block mt-10 rounded_2 block" href="#"><?php _e('Update Bug', 'cqpim'); ?></a>
		<?php } ?>
		<?php if(current_user_can('delete_cqpim_bugs')) { ?>
			<a id="delete_bug" class="cqpim_button_link cqpim_button font-white bg-red block mt-10 rounded_2 block" href="#" data-id="<?php echo $post->ID; ?>"><?php _e('Delete Bug', 'cqpim'); ?></a>
		<?php } ?>
		<?php if(!empty($project)) { ?>
			<a class="cqpim_button_link cqpim_button font-white bg-blue block mt-10 rounded_2 block" href="<?php echo get_edit_post_link($project); ?>"><?php _e('Back to Project', 'cqpim'); ?></a>
		<?php }		
}
add_action( 'save_post', 'save_pto_bug_details_metabox_data' );
function save_pto_bug_details_metabox_data( $post_id ){
	//  verify this came from the our screen and with proper authorization
	// Check if our nonce is set.
	if ( ! isset( $_POST['bug_details_metabox_nonce'] ) )
	    return $post_id;
	// Verify that the nonce is valid.
	$nonce = $_POST['bug_details_metabox_nonce'];
	if ( ! wp_verify_nonce( $nonce, 'bug_details_metabox' ) )
	    return $post_id;
	// If this is an autosave, our form has not been submitted, so we don't want to do anything.
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
	    return $post_id;
	// Check the user's permissions.
	if ( 'page' == $_POST['post_type'] ) {
	    if ( ! current_user_can( 'edit_page', $post_id ) )
	        return $post_id;
	  	} else {
	    if ( ! current_user_can( 'edit_post', $post_id ) )
	        return $post_id;
	}
	update_post_meta($post_id, 'bug_updated', current_time('timestamp'));
}