<?php
function pto_bug_files_metabox_callback( $post ) {
 	wp_nonce_field( 
 	 	'bug_files_metabox', 
 	 	'bug_files_metabox_nonce' );
		$all_attached_files = get_attached_media( '', $post->ID );
		if(!$all_attached_files) {
			echo '<p>' . __('There are no files uploaded to this bug.', 'cqpim') . '</p>';
		} else {
			echo '<table class="datatable_style bdataTable"><thead><tr>';
			echo '<th>' . __('File Name', 'cqpim') . '</th><th>' . __('File Type', 'cqpim') . '</th><th>' . __('Uploaded', 'cqpim') . '</th><th>' . __('Uploaded By', 'cqpim') . '</th><th>' . __('Actions', 'cqpim') . '</th>';
			echo '</tr></thead><tbody>';
			foreach($all_attached_files as $file) {
				$file_object = get_post($file->ID);
				$url = get_the_permalink($file->ID);
				$parent = $file->post_parent;
				$parent_title = get_the_title($parent);
				$parent_title = str_replace('Protected: ', '', $parent_title);
				$parent_url = get_edit_post_link($parent);
				$user = get_user_by( 'id', $file->post_author );
				echo '<tr>';
				echo '<td><span class="cqpim_mobile">' . __('File Name:', 'cqpim') . '</span> <a class="cqpim-link" href="' . $file->guid . '">' . $file->post_title . '</a></td>';
				echo '<td><span class="cqpim_mobile">' . __('Type:', 'cqpim') . '</span> ' . $file->post_mime_type . '</td>';
				echo '<td><span class="cqpim_mobile">' . __('Uploaded:', 'cqpim') . '</span> ' . $file->post_date . '</td>';
				echo '<td><span class="cqpim_mobile">' . __('User:', 'cqpim') . '</span> ' . $user->display_name . '</td>';
				echo '<td><a href="' . $file->guid . '" download="' . $file->post_title . '" class="cqpim_button cqpim_small_button border-green font-green op" value="' . $file->ID . '"><i class="fa fa-download" aria-hidden="true"></i></a> <button class="delete_file cqpim_button cqpim_small_button border-red font-red op" data-id="' . $file->ID . '" value=""><i class="fa fa-trash" aria-hidden="true"></i></button></td>';
				echo '</tr>';
			}
			echo '</tbody></table>'; ?>
			<div class="clear"></div>	
		<?php } ?>
		<?php
}
add_action( 'save_post', 'save_pto_bug_files_metabox_data' );
function save_pto_bug_files_metabox_data( $post_id ){
	//  verify this came from the our screen and with proper authorization
	// Check if our nonce is set.
	if ( ! isset( $_POST['bug_files_metabox_nonce'] ) )
	    return $post_id;
	// Verify that the nonce is valid.
	$nonce = $_POST['bug_files_metabox_nonce'];
	if ( ! wp_verify_nonce( $nonce, 'bug_files_metabox' ) )
	    return $post_id;
	// If this is an autosave, our form has not been submitted, so we don't want to do anything.
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
	    return $post_id;
	// Check the user's permissions.
	if ( 'page' == $_POST['post_type'] ) {
	    if ( ! current_user_can( 'edit_page', $post_id ) )
	        return $post_id;
	  	} else {
	    if ( ! current_user_can( 'edit_post', $post_id ) )
	        return $post_id;
	}
	if( isset( $_POST['delete_file'] ) ){
		$att_to_delete = $_POST['delete_file'];
		foreach ( $att_to_delete as $key => $attID ) {
			$file = get_post($attID);
			$current_user = wp_get_current_user();
			$project_progress = get_post_meta($post_id, 'project_progress', true);
			$project_progress[] = array(
				'update' => 'File Deleted - ' . $file->post_title,
				'date' => current_time('timestamp'),
				'by' => $current_user->display_name
			);
			update_post_meta($post_id, 'project_progress', $project_progress );
			//wp_delete_attachment( $attID, TRUE );
			global $wpdb;
			$wpdb->query(
				"
				UPDATE $wpdb->posts 
				SET post_parent = ''
				WHERE ID = $attID
				AND post_type = 'attachment'
				"
			);
		}
	}
}