<?php
function pto_bug_update_metabox_callback( $post ) {
 	wp_nonce_field( 
 	 	'bug_update_metabox', 
 	 	'bug_update_metabox_nonce' );
		$project = get_post_meta($post->ID, 'bug_project', true);
		$bstatus = get_post_meta($post->ID, 'bug_status', true);
		$assignee = get_post_meta($post->ID, 'bug_assignee', true);
		$desc = get_post_meta($post->ID, 'bug_desc', true);
		?>
			<p class="underline"><?php _e('Bug Description', 'cqpim-bugs'); ?></p>
			<textarea name="bug_desc"><?php echo $desc; ?></textarea>
			<div class="clear"></div>
			<br />
			<div class="cqpim-meta-left">
				<p class="underline"><?php _e('Assignee', 'cqpim-bugs'); ?></p>
				<select style="margin-right:20px" id="bug_assignee" name="bug_assignee">
					<option value="0"><?php _e('Choose an Assignee', 'cqpim-bugs'); ?></option>
					<?php
					$members = pto_bugs_get_bug_assignees($project); 
					if(!empty($members)) {
						foreach($members as $member) {
							$member_details = get_post_meta($member['team_id'], 'team_details', true);
							if(!empty($member_details['user_id']) && !empty($member_details['team_name'])) {
								echo '<option value="' . $member['team_id'] . '" ' . selected($member['team_id'], $assignee) . '>' . $member_details['team_name'] . '</option>';
							}
						}
					}
					?>
				</select>				
			</div>
			<div class="cqpim-meta-right">
				<p class="underline"><?php _e('Status', 'cqpim-bugs'); ?></p>
				<select id="bug_status" name="bug_status">
					<option value=""><?php _e('Choose a Status', 'cqpim-bugs'); ?></option>
					<?php
					$statuses = pto_get_bug_status();
					if(!empty($statuses)) {
						foreach($statuses as $key => $status) {
							echo '<option class="' . $status['class'] . '" value="' . $key . '" ' . selected($key, $bstatus) . '>' . $status['name'] . '</option>';
						}
					}
					?>
				</select>			
			</div>
			<div class="clear"></div>
			<p class="underline"><?php _e('New Update', 'cqpim-bugs'); ?></p>
			<textarea name="bug_update"></textarea>
			<div class="clear"></div>
			<p class="underline"><?php _e('Add Files', 'cqpim-bugs'); ?></p>
			<input type="file" class="cqpim-file-upload" name="async-upload" id="attachments" multiple />
			<div id="upload_attachments"></div>
			<div class="clear"></div>
			<input type="hidden" name="image_id" id="upload_attachment_ids">			
		<?php
}
add_action( 'save_post', 'save_pto_bug_update_metabox_data' );
function save_pto_bug_update_metabox_data( $post_id ){
	//  verify this came from the our screen and with proper authorization
	// Check if our nonce is set.
	if ( ! isset( $_POST['bug_update_metabox_nonce'] ) )
	    return $post_id;
	// Verify that the nonce is valid.
	$nonce = $_POST['bug_update_metabox_nonce'];
	if ( ! wp_verify_nonce( $nonce, 'bug_update_metabox' ) )
	    return $post_id;
	// If this is an autosave, our form has not been submitted, so we don't want to do anything.
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
	    return $post_id;
	// Check the user's permissions.
	if ( 'page' == $_POST['post_type'] ) {
	    if ( ! current_user_can( 'edit_page', $post_id ) )
	        return $post_id;
	  	} else {
	    if ( ! current_user_can( 'edit_post', $post_id ) )
	        return $post_id;
	}
	$duplicate = get_post_meta($post_id, 'duplicate', true);
	$now = time();
	$diff = $now - $duplicate;
	if($diff > 3) {
		$project = get_post_meta($post_id, 'bug_project', true);
		$title = isset($_POST['post_title']) ? $_POST['post_title'] : '';
		$files = isset($_POST['image_id']) ? $_POST['image_id'] : array();
		$bug_pid = isset($_POST['post_ID']) ? $_POST['post_ID'] : '';
		$assignee = isset($_POST['bug_assignee']) ? $_POST['bug_assignee'] : '';
		$status = isset($_POST['bug_status']) ? $_POST['bug_status'] : '';
		$update = isset($_POST['bug_update']) ? $_POST['bug_update'] : '';
		$desc = isset($_POST['bug_desc']) ? $_POST['bug_desc'] : '';
		pto_update_bug($bug_pid, $title, $project, $desc, $assignee, $status, $update, $files);
		update_post_meta($post_id, 'duplicate', time());
	}
}