<?php
function pto_show_project_bugs($project_id) {
	$user = wp_get_current_user();
	$args = array(
		'post_type' => 'cqpim_bug',
		'posts_per_page' => -1,
		'post_status' => 'private',
		'meta_key' => 'bug_project',
		'meta_value' => $project_id,
	);
	$bugs = get_posts($args);
	if(empty($bugs)) { ?>
		<div class="cqpim_block">
			<div class="cqpim_block_title">
				<div class="caption">
					<span class="caption-subject font-green-sharp sbold"><?php _e('Project Bugs', 'cqpim-bugs'); ?></span>
				</div>	
				<div class="actions">
					<a class="cqpim_button cqpim_small_button border-green-sharp font-green-sharp rounded_2 sbold" href="<?php echo get_the_permalink($project_id) . '?page=summary&sub=addbug'; ?>"><?php _e('Add New Bug', 'cqpim'); ?></a>
				</div>
			</div>
			<?php echo '<p>' . __('There are no bugs raised for this project', 'cqpim-bugs') . '</p>'; ?>
		</div>
		<?php
	} else { ?>
		<div class="cqpim_block">
			<div class="cqpim_block_title">
				<div class="caption">
					<span class="caption-subject font-green-sharp sbold"><?php _e('Project Bugs', 'cqpim-bugs'); ?></span>
				</div>	
				<div class="actions">
					<a class="cqpim_button cqpim_small_button border-green-sharp font-green-sharp rounded_2 sbold" href="<?php echo get_the_permalink($project_id) . '?page=summary&sub=addbug'; ?>"><?php _e('Add New Bug', 'cqpim'); ?></a>
				</div>
			</div>
			<table id="project_bugs_table" class="datatable_style">
				<thead>
					<tr>
						<th style="display:none"><?php _e('Updated Stamp', 'cqpim-bugs'); ?></th>
						<th><?php _e('Bug ID', 'cqpim-bugs'); ?></th>
						<th><?php _e('Bug Title', 'cqpim-bugs'); ?></th>
						<th><?php _e('Assignee', 'cqpim-bugs'); ?></th>
						<th><?php _e('Updated', 'cqpim-bugs'); ?></th>
						<th><?php _e('Status', 'cqpim-bugs'); ?></th>
					</tr>
				</thead>
				<tbody>
					<?php foreach($bugs as $bug) { 
						$assignee = get_post_meta($bug->ID, 'bug_assignee', true);
						$updated = get_post_meta($bug->ID, 'bug_updated', true);
						$team_details = get_post_meta($assignee, 'team_details', true);
						$team_name = isset($team_details['team_name']) ? $team_details['team_name'] : '';
						$status = get_post_meta($bug->ID, 'bug_status', true);
						$statuses = pto_get_bug_status();
						?>
						<tr>
							<td style="display:none"><?php echo $updated; ?></td>
							<td><a href="<?php echo get_the_permalink($bug->ID); ?>"><?php echo $bug->ID; ?></a></td>
							<td><a href="<?php echo get_the_permalink($bug->ID); ?>"><?php echo $bug->post_title; ?></a></td>
							<td><?php echo $team_name; ?></td>
							<td><?php echo date(get_option('cqpim_date_format') . ' H:i:s', $updated); ?></td>
							<td><span class="<?php echo $statuses[$status]['class']; ?>"><?php echo $statuses[$status]['name']; ?></span></td>
						</tr>
					<?php } ?>
				</tbody>
			</table>
		</div>
	<?php }		
}
function pto_render_bug_cd_metaboxes($post_id) {
	$project = get_post_meta($post_id, 'bug_project', true); 
	$status = get_post_meta($post_id, 'bug_status', true);
	$assignee = get_post_meta($post_id, 'bug_assignee', true);
	$updated = get_post_meta($post_id, 'bug_updated', true);
	$team_details = get_post_meta($assignee, 'team_details', true);
	$team_name = isset($team_details['team_name']) ? $team_details['team_name'] : '';
	$statuses = pto_get_bug_status();
	$project_obj = get_post($project); 
	$bug_obj = get_post($post_id);
	update_post_meta($post_id, 'updated', false); ?>
	<div class="masonry-grid">
		<div class="grid-sizer"></div>
		<div class="cqpim-dash-item-double grid-item">
			<div class="cqpim_block">
				<div class="cqpim_block_title">
					<div class="caption">
						<span class="caption-subject font-green-sharp sbold"><?php _e('Bug Details', 'cqpim-bugs'); ?> </span>
					</div>
				</div>
				<br />
				<table class="cqpim_table">
					<tr>
						<td><?php _e('Bug ID', 'cqpim-bugs'); ?></td>
						<td><?php echo $post_id; ?></td>
					</tr>
					<tr>
						<td><?php _e('Bug Title', 'cqpim-bugs'); ?></td>
						<td><?php echo $bug_obj->post_title; ?></td>
					</tr>
					<tr>
						<td><?php _e('Project', 'cqpim-bugs'); ?></td>
						<td><a href="<?php echo get_edit_post_link($project); ?>"><?php echo $project_obj->post_title; ?></a></td>
					</tr>
					<tr>
						<td><?php _e('Status', 'cqpim-bugs'); ?></td>
						<td><span class="<?php echo $statuses[$status]['class']; ?>"><?php echo $statuses[$status]['name']; ?></span></td>
					</tr>
					<tr>
						<td><?php _e('Assignee', 'cqpim-bugs'); ?></td>
						<td><?php echo $team_name; ?></td>
					</tr>
					<tr>
						<td><?php _e('Created', 'cqpim-bugs'); ?></td>
						<td><?php echo get_the_date(get_option('cqpim_date_format') . ' H:i:s', $post_id); ?></td>
					</tr>
					<tr>
						<td><?php _e('Updated', 'cqpim-bugs'); ?></td>
						<td><?php echo date(get_option('cqpim_date_format') . ' H:i:s', $updated); ?></td>
					</tr>
				</table>
				<div class="clear"></div>
			</div>
		</div>
		<?php
		$bug_updates = get_post_meta($post_id, 'bug_updates', true);
		$bug_updates = array_reverse($bug_updates);
		$updates = count($bug_updates);
		$statuses = pto_get_bug_status();
		$avatar = get_option('cqpim_disable_avatars');
		$i = 0; ?>
		<div class="cqpim-dash-item-triple grid-item">
			<div class="cqpim_block">
				<div class="cqpim_block_title">
					<div class="caption">
						<span class="caption-subject font-green-sharp sbold"><?php _e('Bug Log', 'cqpim-bugs'); ?></span>
					</div>
				</div>
				<br />
				<div style="max-height:700px; overflow:auto">
					<?php foreach($bug_updates as $update) { 
						$updater = get_user_by('id', $update['user']); ?>
						<div class="bug_update<?php if(++$i === $updates) { echo ' last'; } ?>">
							<div class="update_title">
								<?php if(empty($avatar)) { ?>
									<div class="update_av">
										<?php echo get_avatar( $update['user'], 80, '', false, array('force_display' => true) ); ?>
									</div>
								<?php } ?>
								<div <?php if(!empty($avatar)) { ?>style="width:100%; float:none"<?php } ?> class="update_info">
									<p class="underline nobottom"><?php echo $updater->display_name; ?> - <?php echo date(get_option('cqpim_date_format') . ' H:i:s', $update['stamp']); ?></p>
									<?php if(!empty($update['changes'])) {
										foreach($update['changes'] as $change) {
											if($change['type'] == 's') {
												echo '<p class="bug_changes">';
												printf(__('Status changed from %1$s to %2$s', 'cqpim-bugs'), $statuses[$change['from']]['name'], $statuses[$change['to']]['name']);
												echo '</p>';
											} else {
												$from = get_post_meta($change['from'], 'team_details', true);
												$from = isset($from['team_name']) ? $from['team_name'] : '';
												$to = get_post_meta($change['to'], 'team_details', true);
												$to = isset($to['team_name']) ? $to['team_name'] : '';
												echo '<p class="bug_changes">';
												printf(__('Assignee changed from %1$s to %2$s', 'cqpim-bugs'), $from, $to);
												echo '</p>';
											}
										}
									}
									if(!empty($update['files'][0])) {
										echo '<p class="bug_changes">';
										_e('File Uploaded:', 'cqpim-bugs');
										$files = count($update['files']);
										$i = 0;
										foreach($update['files'] as $file) {
											if(!empty($file)) {
												$file_object = get_post($file);
												echo ' <a class="cqpim-link" href="' . $file_object->guid . '">' . $file_object->post_title . '</a>';
												if(++$i != $files) {
													echo ' | ';
												}
											}
										}
										echo '</p>';
									}
									?>
									<?php if(!empty($update['status'])) { ?>
										<div class="update_status">
											<span class="<?php echo $statuses[$update['status']]['class']; ?>"><?php echo $statuses[$update['status']]['name']; ?></span>
										</div>
									<?php } ?>
								</div>
								<div class="clear"></div>
							</div>
							<?php if(!empty($update['update'])) { ?>
								<div class="update_update">
									<?php echo wpautop($update['update']); ?>
								</div>
							<?php } ?>
						</div>
					<?php } ?>	
				</div>
				<br />
				<div class="clear"></div>					
				<div class="cqpim_block_title">
					<div class="caption">
						<span class="caption-subject font-green-sharp sbold"><?php _e('Update Bug', 'cqpim-bugs'); ?></span>
					</div>
				</div>
				<?php
				$project = get_post_meta($post_id, 'bug_project', true);
				$bstatus = get_post_meta($post_id, 'bug_status', true);
				$assignee = get_post_meta($post_id, 'bug_assignee', true);
				$desc = get_post_meta($post_id, 'bug_desc', true);
				$bug_obj = get_post($post_id);
				?>
				<input type="hidden" id="bug_title" value="<?php echo $bug_obj->post_title; ?>" />
				<p class="underline"><?php _e('Bug Description', 'cqpim-bugs'); ?></p>
				<textarea id="bug_desc"><?php echo $desc; ?></textarea>
				<div class="clear"></div>
				<br />
				<input type="hidden" id="bug_assignee" value="<?php echo $assignee; ?>" />
				<p class="underline"><?php _e('Status', 'cqpim-bugs'); ?></p>
				<select id="bug_status" name="bug_status">
					<option value=""><?php _e('Choose a Status', 'cqpim-bugs'); ?></option>
					<?php
					$statuses = pto_get_bug_status();
					if(!empty($statuses)) {
						foreach($statuses as $key => $status) {
							echo '<option class="' . $status['class'] . '" value="' . $key . '" ' . selected($key, $bstatus) . '>' . $status['name'] . '</option>';
						}
					}
					?>
				</select>
				<div class="clear"></div>
				<p class="underline"><?php _e('New Update', 'cqpim-bugs'); ?></p>
				<textarea id="bug_update"></textarea>
				<div class="clear"></div>
				<p class="underline"><?php _e('Add Files', 'cqpim-bugs'); ?></p>
				<input type="file" class="cqpim-file-upload" name="async-upload" id="attachments" multiple />
				<div id="upload_attachments"></div>
				<div class="clear"></div>
				<input type="hidden" name="image_id" id="upload_attachment_ids">
				<a href="#" data-id="<?php echo $post_id; ?>" id="update_bug_btn" class="cqpim_button bg-blue font-white op right mt-20 rounded_2"><?php _e('Update Bug', 'cqpim-bugs'); ?></a>
				<div class="clear"></div>	
				<div id="password_messages" class="mt-20"></div>
			</div>
		</div>
		<div class="cqpim-dash-item-double grid-item">
			<div class="cqpim_block">
				<div class="cqpim_block_title">
					<div class="caption">
						<span class="caption-subject font-green-sharp sbold"><?php _e('Bug Files', 'cqpim-bugs'); ?></span>
					</div>
				</div>
				<div id="uploaded_files">
				<?php 
				$all_attached_files = get_attached_media( '', $post_id );
				if(!$all_attached_files) {
					echo '<div class="cqpim-alert cqpim-alert-info alert-display">' . __('There are no files uploaded to this bug.', 'cqpim-bugs') . '</div>';
				} else {
					echo '<br /><table class="cqpim_table"><thead><tr>';
					echo '<th>' . __('File Name', 'cqpim-bugs') . '</th><th>' . __('Actions', 'cqpim-bugs') . '</th>';
					echo '</tr></thead><tbody>';
					foreach($all_attached_files as $file) {
						$file_object = get_post($file->ID);
						$link = get_the_permalink($file->ID);
						$user = get_user_by( 'id', $file->post_author );
						echo '<tr>';
						echo '<td><a class="cqpim-link" href="' . $file->guid . '" download="' . $file->post_title . '">' . $file->post_title . '</a><p>' . __('Uploaded on', 'cqpim-bugs') . ' ' . $file->post_date . ' ' . __('by', 'cqpim-bugs') . ' ' . $user->display_name . '</p></td>';
						echo '<td><a href="' . $file->guid . '" download="' . $file->post_title . '" class="cqpim_button cqpim_small_button border-green font-green op" value="' . $file->ID . '"><i class="fa fa-download" aria-hidden="true"></i></a></td>';
						echo '</tr>';
					}
					echo '</tbody></table>';
				}
				?>
				</div>
			</div>
		</div>					
	</div>
<?php }
function pto_add_project_bug($ppid) { ?>
	<div class="cqpim_block">
		<div class="cqpim_block_title">
			<div class="caption">
				<span class="caption-subject font-green-sharp sbold"><?php _e('Add Bug', 'cqpim-bugs'); ?></span>
			</div>
		</div>
		<?php
		$project = get_post_meta($ppid, 'bug_project', true);
		$bstatus = get_post_meta($ppid, 'bug_status', true);
		$assignee = get_post_meta($ppid, 'bug_assignee', true);
		$desc = get_post_meta($ppid, 'bug_desc', true);
		$bug_obj = get_post($ppid);
		?>
		<input type="hidden" id="bug_project" value="<?php echo $ppid; ?>" />
		<p class="underline"><?php _e('Bug Title', 'cqpim-bugs'); ?></p>
		<input type="text" id="bug_title" value="" />
		<p class="underline"><?php _e('Bug Description', 'cqpim-bugs'); ?></p>
		<textarea id="bug_desc"><?php echo $desc; ?></textarea>
		<div class="clear"></div>
		<br />
		<div class="cqpim-meta-left">
			<p class="underline"><?php _e('Assignee', 'cqpim-bugs'); ?></p>
			<select style="margin-right:20px" id="bug_assignee" name="bug_assignee">
				<option value="0"><?php _e('Choose an Assignee', 'cqpim-bugs'); ?></option>
				<?php
				$members = pto_bugs_get_bug_assignees($ppid); 
				if(!empty($members)) {
					foreach($members as $member) {
						$member_details = get_post_meta($member['team_id'], 'team_details', true);
						if(!empty($member_details['user_id']) && !empty($member_details['team_name'])) {
							echo '<option value="' . $member['team_id'] . '" ' . selected($member['team_id'], $assignee) . '>' . $member_details['team_name'] . '</option>';
						}
					}
				}
				?>
			</select>				
		</div>
		<div class="cqpim-meta-right">
			<p class="underline"><?php _e('Status', 'cqpim-bugs'); ?></p>
			<select id="bug_status" name="bug_status">
				<option value=""><?php _e('Choose a Status', 'cqpim-bugs'); ?></option>
				<?php
				$statuses = pto_get_bug_status();
				if(!empty($statuses)) {
					foreach($statuses as $key => $status) {
						echo '<option class="' . $status['class'] . '" value="' . $key . '" ' . selected($key, $bstatus) . '>' . $status['name'] . '</option>';
					}
				}
				?>
			</select>			
		</div>
		<div class="clear"></div>
		<p class="underline"><?php _e('Add Files', 'cqpim-bugs'); ?></p>
		<input type="file" class="cqpim-file-upload" name="async-upload" id="attachments" multiple />
		<div id="upload_attachments"></div>
		<div class="clear"></div>
		<input type="hidden" name="image_id" id="upload_attachment_ids">
		<a href="#" data-id="<?php echo $ppid; ?>" id="add_bug_btn" class="cqpim_button bg-blue font-white op right mt-20 rounded_2"><?php _e('Add Bug', 'cqpim-bugs'); ?></a>
		<div class="clear"></div>	
		<div id="password_messages" class="mt-20"></div>
	</div>
<?php }