<?php
/**
 *  Suppliers CPT
 */
if ( ! function_exists('pto_suppliers_cpt') ) {
	function pto_suppliers_cpt() {
		if(current_user_can('cqpim_create_new_supplier') && current_user_can('publish_cqpim_suppliers')) {
			$form_caps = array();
		} else {
			$form_caps = array('create_posts' => false);
		}	
		$labels = array(
			'name'                => _x( 'Suppliers', 'Post Type General Name', 'cqpim-expenses' ),
			'singular_name'       => _x( 'Supplier', 'Post Type Singular Name', 'cqpim-expenses' ),
			'menu_name'           => __( 'Suppliers', 'cqpim-expenses' ),
			'parent_item_colon'   => __( 'Parent Supplier:', 'cqpim-expenses' ),
			'all_items'           => __( 'Suppliers', 'cqpim-expenses' ),
			'view_item'           => __( 'View Supplier', 'cqpim-expenses' ),
			'add_new_item'        => __( 'Add New Supplier', 'cqpim-expenses' ),
			'add_new'             => __( 'New Supplier', 'cqpim-expenses' ),
			'edit_item'           => __( 'Edit Supplier', 'cqpim-expenses' ),
			'update_item'         => __( 'Update Supplier', 'cqpim-expenses' ),
			'search_items'        => __( 'Search Suppliers', 'cqpim-expenses' ),
			'not_found'           => __( 'No Suppliers found', 'cqpim-expenses' ),
			'not_found_in_trash'  => __( 'No Suppliers found in trash', 'cqpim-expenses' ),
		);
		$args = array(
			'label'               => __( 'supplier', 'cqpim-expenses' ),
			'description'         => __( 'Suppliers', 'cqpim-expenses' ),
			'labels'              => $labels,
			'supports'            => array( 'title' ),
			'hierarchical'        => false,
			'capabilities'        => $form_caps,
			'public'              => false,
			'show_ui'             => true,
			'show_in_nav_menus'   => true,
			'show_in_menu'		  => 'pto-dashboard',	
			'show_in_admin_bar'   => true,
			'menu_position'       => 5,
			'menu_icon'           => plugins_url() . "/img/contact.png",
			'can_export'          => true,
			'has_archive'         => true,
			'exclude_from_search' => true,
			'publicly_queryable'  => false,
			'capability_type'     => array('cqpim_supplier', 'cqpim_suppliers'),
			'map_meta_cap'        => true,
			'query_var'			  => true,
		);
		register_post_type( 'cqpim_supplier', $args );
	}
	add_action( 'init', 'pto_suppliers_cpt', 16 );
}
	add_action( 'init', 'pto_supplier_cats', 0 );
	function pto_supplier_cats() {
		$labels = array(
			'name'              => __( 'Supplier Type', 'cqpim-expenses' ),
			'singular_name'     => __( 'Supplier Type', 'cqpim-expenses' ),
			'search_items'      => __( 'Search Supplier Types', 'cqpim-expenses' ),
			'all_items'         => __( 'All Supplier Types', 'cqpim-expenses' ),
			'parent_item'       => __( 'Parent Supplier Type', 'cqpim-expenses' ),
			'parent_item_colon' => __( 'Parent Supplier Type:', 'cqpim-expenses' ),
			'edit_item'         => __( 'Edit Supplier Type', 'cqpim-expenses' ),
			'update_item'       => __( 'Update Supplier Type', 'cqpim-expenses' ),
			'add_new_item'      => __( 'Add New Supplier Type', 'cqpim-expenses' ),
			'new_item_name'     => __( 'New Genre Supplier Type', 'cqpim-expenses' ),
			'menu_name'         => __( 'Supplier Types', 'cqpim-expenses' ),
		);
		$args = array(
			'hierarchical'      => true,
			'labels'            => $labels,
			'show_ui'           => true,
			'show_admin_column' => true,
			'query_var'         => true,
			'rewrite'           => false,
		);
		register_taxonomy( 'cqpim_supplier_cat', array( 'cqpim_supplier' ), $args );
	}