<?php
// Contact notes Metabox
function pto_expenses_notes_metabox_callback( $post ) {
	// Add an nonce field so we can check for it later.
 	wp_nonce_field( 
 	 	'expenses_notes_metabox', 
 	 	'expenses_notes_metabox_nonce' );
		$supplier_notes = get_post_meta($post->ID, 'supplier_notes', true);
		$editor_id = 'supplier_notes';
		$settings  = array(
			'textarea_name' => 'supplier_notes',
			'textarea_rows' => 10,
			'media_buttons' => false,
			'wpautop' => false,
		);
		wp_editor( $supplier_notes, $editor_id, $settings );
}
// Save Contact notes Fields
add_action( 'save_post', 'save_pto_expenses_notes_metabox_data' );
function save_pto_expenses_notes_metabox_data( $post_id ){
	//  verify this came from the our screen and with proper authorization
	// Check if our nonce is set.
	if ( ! isset( $_POST['expenses_notes_metabox_nonce'] ) )
	    return $post_id;
	// Verify that the nonce is valid.
	$nonce = $_POST['expenses_notes_metabox_nonce'];
	if ( ! wp_verify_nonce( $nonce, 'expenses_notes_metabox' ) )
	    return $post_id;
	// If this is an autosave, our form has not been submitted, so we don't want to do anything.
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
	    return $post_id;
	// Check the user's permissions.
	if ( 'page' == $_POST['post_type'] ) {
	    if ( ! current_user_can( 'edit_page', $post_id ) )
	        return $post_id;
	  	} else {
	    if ( ! current_user_can( 'edit_post', $post_id ) )
	        return $post_id;
	}
	if(isset($_POST['supplier_notes'])) {
		update_post_meta($post_id, 'supplier_notes', $_POST['supplier_notes']);
	}	
}