<?php
// Contact Details Metabox
function supplier_pto_details_metabox_callback( $post ) {
	// Add an nonce field so we can check for it later.
 	wp_nonce_field( 
 	 	'supplier_details_metabox', 
 	 	'supplier_details_metabox_nonce' );
		$supplier_details = get_post_meta($post->ID, 'supplier_details', true);
		$supplier_name = isset($supplier_details['supplier_name']) ? $supplier_details['supplier_name'] : '';
		$supplier_address = isset($supplier_details['supplier_address']) ? $supplier_details['supplier_address'] : '';
		$supplier_contact = isset($supplier_details['supplier_contact']) ? $supplier_details['supplier_contact'] : '';
		$supplier_telephone = isset($supplier_details['supplier_telephone']) ? $supplier_details['supplier_telephone'] : '';
		$supplier_email = isset($supplier_details['supplier_email']) ? $supplier_details['supplier_email'] : '';
		$supplier_id = isset($supplier_details['supplier_id']) ? $supplier_details['supplier_id'] : $post->ID;
		$supplier_tax_pc = isset($supplier_details['supplier_tax_pc']) ? $supplier_details['supplier_tax_pc']: '';
		$supplier_stax_pc = isset($supplier_details['supplier_stax_pc']) ? $supplier_details['supplier_stax_pc']: '';
		$supplier_tax_reg = isset($supplier_details['supplier_tax_reg']) ? $supplier_details['supplier_tax_reg']: '';
		$supplier_stax_reg = isset($supplier_details['supplier_stax_reg']) ? $supplier_details['supplier_stax_reg']: '';
		$supplier_tax_name = isset($supplier_details['supplier_tax_name']) ? $supplier_details['supplier_tax_name']: '';
		$supplier_stax_name = isset($supplier_details['supplier_stax_name']) ? $supplier_details['supplier_stax_name']: '';
		$supplier_notes = isset($supplier_details['supplier_notes']) ? $supplier_details['supplier_notes']: ''; ?>
		<div class="cqpim-meta-left">
			<p><?php _e('Supplier Name', 'cqpim-expenses'); ?></p>
			<input type="text" name="supplier_name" value="<?php echo $supplier_name; ?>" />
			<p><?php _e('Supplier Address', 'cqpim-expenses'); ?></p>
			<textarea name="supplier_address" style="height:130px"><?php echo $supplier_address; ?></textarea>
		</div>
		<div class="cqpim-meta-right">
			<p><?php _e('Supplier Contact Name', 'cqpim-expenses'); ?></p>
			<input type="text" name="supplier_contact" value="<?php echo $supplier_contact; ?>" />
			<p><?php _e('Supplier Telephone', 'cqpim-expenses'); ?></p>
			<input type="text" name="supplier_telephone" value="<?php echo $supplier_telephone; ?>" />
			<p><?php _e('Supplier Email', 'cqpim-expenses'); ?></p>
			<input type="text" name="supplier_email" value="<?php echo $supplier_email; ?>" />
			<p><?php _e('Supplier ID', 'cqpim-expenses'); ?></p>
			<input type="text" name="supplier_id" value="<?php echo $supplier_id; ?>" />
		</div>
		<div class="clear"></div>
		<?php do_action('pto_after_supplier_details_fields', $supplier_details, $post);?>
		<div class="clear"></div>
		<h4><?php _e('Supplier Tax Details', 'cqpim-expenses'); ?></h4>
		<p><?php _e('If this supplier charges sales tax such as VAT, then enter the details here. This will reflect in expenses raised for this supplier.', 'cqpim-expenses'); ?></p>
		<div class="cqpim-meta-left">
			<p><?php _e('Tax 1 Name / Reg Number / Percentage: ', 'cqpim-expenses'); ?> </p>
			<input type="text" name="supplier_tax_name" value="<?php echo $supplier_tax_name; ?>" placeholder="<?php _e('Tax name', 'cqpim-expenses'); ?>" /><br />
			<input style="border-top:0" type="text" name="supplier_tax_reg" value="<?php echo $supplier_tax_reg; ?>" placeholder="<?php _e('Reg number', 'cqpim-expenses'); ?>" /><br />
			<input style="border-top:0" type="text" name="supplier_tax_pc" value="<?php echo $supplier_tax_pc; ?>" placeholder="<?php _e('Percentage', 'cqpim-expenses'); ?>" /><br />	
		</div>
		<div class="cqpim-meta-right">
			<p><?php _e('Tax 2 Name / Reg Number / Percentage: ', 'cqpim-expenses'); ?> </p>
			<input type="text" name="supplier_stax_name" value="<?php echo $supplier_stax_name; ?>" placeholder="<?php _e('Tax name', 'cqpim-expenses'); ?>" /><br />
			<input style="border-top:0" type="text" name="supplier_stax_reg" value="<?php echo $supplier_stax_reg; ?>" placeholder="<?php _e('Reg number', 'cqpim-expenses'); ?>" /><br />
			<input style="border-top:0" type="text" name="supplier_stax_pc" value="<?php echo $supplier_stax_pc; ?>" placeholder="<?php _e('Percentage', 'cqpim-expenses'); ?>" /><br />		
		</div>
		<div class="clear"></div>
		<h4><?php _e('Supplier Notes', 'cqpim-expenses'); ?></h4>
		<?php $editor_id = 'supplier_notes';
		$settings  = array(
			'textarea_name' => 'supplier_notes',
			'textarea_rows' => 10,
			'media_buttons' => false,
			'wpautop' => false,
		);
		wp_editor( $supplier_notes, $editor_id, $settings );
}
// Save Contact Details Fields
add_action( 'save_post', 'save_pto_supplier_details_metabox_data' );
function save_pto_supplier_details_metabox_data( $post_id ){
	//  verify this came from the our screen and with proper authorization
	// Check if our nonce is set.
	if ( ! isset( $_POST['supplier_details_metabox_nonce'] ) )
	    return $post_id;
	// Verify that the nonce is valid.
	$nonce = $_POST['supplier_details_metabox_nonce'];
	if ( ! wp_verify_nonce( $nonce, 'supplier_details_metabox' ) )
	    return $post_id;
	// If this is an autosave, our form has not been submitted, so we don't want to do anything.
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
	    return $post_id;
	// Check the user's permissions.
	if ( 'page' == $_POST['post_type'] ) {
	    if ( ! current_user_can( 'edit_page', $post_id ) )
	        return $post_id;
	  	} else {
	    if ( ! current_user_can( 'edit_post', $post_id ) )
	        return $post_id;
	}
	$supplier_details = array();
	$supplier_details['supplier_name'] = isset($_POST['supplier_name']) ? $_POST['supplier_name'] : '';
	$supplier_details['supplier_address'] = isset($_POST['supplier_address']) ? $_POST['supplier_address'] : '';
	$supplier_details['supplier_contact'] = isset($_POST['supplier_contact']) ? $_POST['supplier_contact'] : '';
	$supplier_details['supplier_telephone'] = isset($_POST['supplier_telephone']) ? $_POST['supplier_telephone'] : '';
	$supplier_details['supplier_email'] = isset($_POST['supplier_email']) ? $_POST['supplier_email'] : '';
	$supplier_details['supplier_id'] = isset($_POST['supplier_id']) ? $_POST['supplier_id'] : '';
	$supplier_details['supplier_tax_reg'] = isset($_POST['supplier_tax_reg']) ? $_POST['supplier_tax_reg']: '';
	$supplier_details['supplier_stax_reg'] = isset($_POST['supplier_stax_reg']) ? $_POST['supplier_stax_reg']: '';
	$supplier_details['supplier_tax_pc'] = isset($_POST['supplier_tax_pc']) ? $_POST['supplier_tax_pc']: '';
	$supplier_details['supplier_stax_pc'] = isset($_POST['supplier_stax_pc']) ? $_POST['supplier_stax_pc']: '';
	$supplier_details['supplier_tax_name'] = isset($_POST['supplier_tax_name']) ? $_POST['supplier_tax_name']: '';
	$supplier_details['supplier_stax_name'] = isset($_POST['supplier_stax_name']) ? $_POST['supplier_stax_name']: '';
	$supplier_details['supplier_notes'] = isset($_POST['supplier_notes']) ? $_POST['supplier_notes']: '';
	$supplier_details = apply_filters('pto_save_supplier_details_fields', $supplier_details, $post_id);
	update_post_meta($post_id, 'supplier_details', $supplier_details);
}