<?php
/**
* Plugin Name: Projectopia - Expenses Add-On
* Description: The Projectopia Expenses Plugin is ad add-on for Projectopia Core that allows admins and Team Members to log expenses for projects and add suppliers to the core plugin
* Version: 2.0.4
* Author: Projectopia
* Author URI: http://projectopia.io
* Text Domain: cqpim-expenses
* Domain Path: /languages
*/
define('PTO_EXPENSES_VERSION', '2.0.4');
// Paths
define('PTO_EXPENSES_PATH', plugin_dir_path( __FILE__ ));
define('PTO_EXPENSES_DIRNAME', basename( plugin_basename( PTO_EXPENSES_PATH ) ));
define('PTO_EXPENSES_PLUGIN_URL', plugins_url() . '/' . PTO_EXPENSES_DIRNAME);
// Languages
function pto_expenses_plugin_setup() {
	load_plugin_textdomain('cqpim-expenses', false, dirname(plugin_basename(__FILE__)) . '/languages/');
} 
add_action('plugins_loaded', 'pto_expenses_plugin_setup');
register_activation_hook( __FILE__, 'pto_expenses_activation' );
function pto_expenses_activation() {
	if(is_plugin_active(PTO_DIRNAME . '/projectopia.php')) {
		$cqpim_version = PTO_VERSION;
		if($cqpim_version < '3.2.1') {
			$message = __('You need to have at least version 3.2.1 of the Projectopia Core plugin installed to use this add-on', 'cqpim-expenses');
			wp_die($message, 'Projectopia Core Plugin Version Problem');				
		} else {
			if(is_plugin_active('cqpim-expenses/cqpim-expenses.php')) {
				$message = __('You must deactivate and remove the old version of CQPIM Expenses before installing this one. Make sure you make a backup of any language translation files so that you can reinstate them.', 'cqpim-expenses');
				wp_die($message, 'Projectopia Core Plugin Version Problem');
			}
			update_option('cqpim_auth_email_subject', 'Expenses Authorisation Request');
			update_option('cqpim_authorised_email_subject', 'Expense Authorisation Request %%DECISION%%');
			$text = 'Dear %%NAME%%
%%CURRENT_USER%% has raised a new expense request. Please log in to your dashboard to action this request.
%%REQUEST_URL%%
Best Regards
%%CURRENT_USER%%
%%COMPANY_NAME%%
Tel: %%COMPANY_TELEPHONE%%
Email: %%COMPANY_SALES_EMAIL%%';
			update_option('cqpim_auth_email_content', $text);
			$text = 'Dear %%NAME%%
%%CURRENT_USER%% has %%DECISION%% your expense request.
%%DECISION_MESSAGE%%
Please log in to your dashboard to view the expense request.
%%REQUEST_URL%%
Best Regards
%%CURRENT_USER%%
%%COMPANY_NAME%%
Tel: %%COMPANY_TELEPHONE%%
Email: %%COMPANY_SALES_EMAIL%%';			
			update_option('cqpim_authorised_email_content', $text);
		}
	} else {
		$message = __('You need to have the core CQPIM Plugin active to activate this Add-On', 'cqpim-expenses');
		wp_die($message, 'CQPIM Core Plugin Missing');
	}
}
// Includes
require_once( 'pto_expenses_functions.php' );
// CPT
require_once( 'cpt/suppliers.php' );
require_once( 'cpt/expenses.php' );
// Pages
require_once( 'expenses.php' );
require_once( 'expenses-admin.php' );
// Metaboxes
require_once('metaboxes/main.php');