<?php
/**
* Plugin Name: Projectopia - Reporting Add-On
* Description: The Projectopia Reporting Plugin extends Projectopia Core by adding reporting features on financials, projects, team members and suppliers
* Version: 2.0.1
* Author: Projectopia
* Author URI: http://projectopia.io
* Text Domain: cqpim-reporting
* Domain Path: /languages
*/
define('PTO_REPORTING_VERSION', '2.0');
// Paths
define('PTO_REPORTING_PATH', plugin_dir_path( __FILE__ ));
define('PTO_REPORTING_DIRNAME', basename( plugin_basename( PTO_REPORTING_PATH ) ));
define('PTO_REPORTING_PLUGIN_URL', plugins_url() . '/' . PTO_REPORTING_DIRNAME);
// Languages
function pto_reporting_plugin_setup() {
	load_plugin_textdomain('cqpim-reporting', false, dirname(plugin_basename(__FILE__)) . '/languages/');
} 
add_action('plugins_loaded', 'pto_reporting_plugin_setup');
register_activation_hook( __FILE__, 'pto_reporting_activation' );
function pto_reporting_activation() {
	if(is_plugin_active(PTO_DIRNAME . '/projectopia.php')) {
		$cqpim_version = PTO_VERSION;
		if($cqpim_version < '3.2.2') {
			$message = __('You need to have at least version 3.2.2 of the Projectopia Core plugin installed to use this add-on', 'cqpim-reporting');
			wp_die($message, 'Projectopia Core Plugin Version Problem');				
		} else {
		}
		if(is_plugin_active('cqpim-reporting/cqpim-reporting.php')) {
			$message = __('You must deactivate and remove the old version of CQPIM Reporting before installing this one. Make sure you make a backup of any language translation files so that you can reinstate them.', 'cqpim-reporting');
			wp_die($message, 'Projectopia Core Plugin Version Problem');
		}
	} else {
		$message = __('You need to have the core Projectopia Plugin active to activate this Add-On', 'cqpim-reporting');
		wp_die($message, 'Projectopia Core Plugin Missing');
	}
}
// Includes
require_once( 'pto_reporting_functions.php' );
require_once( 'script_enqueing.php' );
// Pages
require_once( 'reporting.php' );