<?php
add_action( "wp_ajax_nopriv_pto_reporting_populate_item", 
		"pto_reporting_populate_item");
add_action( "wp_ajax_pto_reporting_populate_item", 
		"pto_reporting_populate_item");
function pto_reporting_populate_item() {
	$type = isset($_POST['type']) ? $_POST['type'] : '';
	if(empty($type)) {
		$return =  array( 
			'error' 	=> true,
			'messages' 	=> '<div class="cqpim-alert cqpim-alert-danger alert-display">' . __('There is some missing data. The report has failed.', 'cqpim-reporting') . '</div>',
		);
		header('Content-type: application/json');
		echo json_encode($return);
		exit();				
	} else {
		if($type == 'pt' || $type == 'pi' || $type == 'pie') {
			$items = pto_get_items('project');
			if(!empty($items)) {
				$options = '<option value="0">' . __('Choose a project', 'cqpim-reporting') . '</option>';
				foreach($items as $item) {
					$options .= '<option value="' . $item->ID . '">' . $item->post_title . '</option>';
				}
			} else {
				$options = '<option value="0">' . __('No Projects Found', 'cqpim-reporting') . '</option>';
			}
			$return =  array( 
				'error' 	=> false,
				'item_cont' => true,
				'heading' => __('Choose a Project', 'cqpim-reporting'),
				'options' 	=> $options,
			);
			header('Content-type: application/json');
			echo json_encode($return);
			exit();	
		} else if($type == 'tt' || $type == 'te') {
			$items = pto_get_items('teams');
			if(!empty($items)) {
				$options = '<option value="0">' . __('Choose a Team Member', 'cqpim-reporting') . '</option>';
				foreach($items as $item) {
					$options .= '<option value="' . $item->ID . '">' . $item->post_title . '</option>';
				}
			} else {
				$options = '<option value="0">' . __('No Team Members Found', 'cqpim-reporting') . '</option>';
			}
			$return =  array( 
				'error' 	=> false,
				'item_cont' => true,
				'heading' => __('Choose a Team Member', 'cqpim-reporting'),
				'options' 	=> $options,
			);
			header('Content-type: application/json');
			echo json_encode($return);
			exit();	
		} else if($type == 'in' || $type == 'ex' || $type == 'inex' || $type == 'tax' || $type == 'stax') {
			$items = pto_get_items('invoice');
			$return =  array( 
				'error' 	=> false,
				'item_cont' => false,
			);
			header('Content-type: application/json');
			echo json_encode($return);
			exit();	
		} else if($type == 'ss') {
			$items = pto_get_items('supplier');
			if(!empty($items)) {
				$options = '<option value="0">' . __('Choose a Supplier', 'cqpim-reporting') . '</option>';
				foreach($items as $item) {
					$options .= '<option value="' . $item->ID . '">' . $item->post_title . '</option>';
				}
			} else {
				$options = '<option value="0">' . __('No Suppliers Found', 'cqpim-reporting') . '</option>';
			}
			$return =  array( 
				'error' 	=> false,
				'item_cont' => true,
				'heading' => __('Choose a Supplier', 'cqpim-reporting'),
				'options' 	=> $options,
			);
			header('Content-type: application/json');
			echo json_encode($return);
			exit();	
		} else if($type == 'ic') {
			$items = pto_get_items('client');
			if(!empty($items)) {
				$options = '<option value="0">' . __('Choose a Client', 'cqpim-reporting') . '</option>';
				foreach($items as $item) {
					$options .= '<option value="' . $item->ID . '">' . $item->post_title . '</option>';
				}
			} else {
				$options = '<option value="0">' . __('No Clients Found', 'cqpim-reporting') . '</option>';
			}
			$return =  array( 
				'error' 	=> false,
				'item_cont' => true,
				'heading' => __('Choose a Client', 'cqpim-reporting'),
				'options' 	=> $options,
			);
			header('Content-type: application/json');
			echo json_encode($return);
			exit();				
		}
		$return =  array( 
			'error' 	=> true,
			'messages' 	=> '<div class="cqpim-alert cqpim-alert-danger alert-display">' . __('There is some missing data. The report has failed.', 'cqpim-reporting') . '</div>',
		);
		header('Content-type: application/json');
		echo json_encode($return);
		exit();			
	}
	exit;
}
add_action( "wp_ajax_nopriv_pto_reporting_run_report", 
		"pto_reporting_run_report");
add_action( "wp_ajax_pto_reporting_run_report", 
		"pto_reporting_run_report");
function pto_reporting_run_report() {
	$type = isset($_POST['type']) ? $_POST['type'] : '';
	$item = isset($_POST['item']) ? $_POST['item'] : '';
	$start = isset($_POST['start']) ? $_POST['start'] : '';
	$end = isset($_POST['end']) ? $_POST['end'] : '';
	$rows = isset($_POST['rows']) ? $_POST['rows'] : '';
	$types = array("pt","pi","pie","tt","te","ss","ic");
	if(empty($type)) {
		$return =  array( 
			'error' 	=> true,
			'messages' 	=> '<div class="cqpim-alert cqpim-alert-danger alert-display">' . __('You must select a report type from the list.', 'cqpim-reporting') . '</div>',
		);
		header('Content-type: application/json');
		echo json_encode($return);
		exit();	
	}
	if(in_array($type, $types) && empty($item)) {
		$return =  array( 
			'error' 	=> true,
			'messages' 	=> '<div class="cqpim-alert cqpim-alert-danger alert-display">' . __('You must select an item in the item list for this report.', 'cqpim-reporting') . '</div>',
		);
		header('Content-type: application/json');
		echo json_encode($return);
		exit();	
	}
	if($type == 'in') {
		$data = pto_run_in_report($type, $start, $end, $rows);
	}
	if($type == 'ex') {
		$data = pto_run_ex_report($type, $start, $end, $rows);
	}
	if($type == 'ic') {
		$data = pto_run_ic_report($type, $start, $end, $rows, $item);
	}
	if($type == 'inex') {
		$data = pto_run_inex_report($type, $start, $end, $rows);
	}
	if($type == 'tax') {
		$data = pto_run_tax_report($type, $start, $end, $rows);
	}
	if($type == 'stax') {
		$data = pto_run_stax_report($type, $start, $end, $rows);
	}
	if($type == 'ss') {
		$data = pto_run_ss_report($type, $start, $end, $rows, $item);
	}
	if($type == 'te') {
		$data = pto_run_te_report($type, $start, $end, $rows, $item);
	}
	if($type == 'pi') {
		$data = pto_run_pi_report($type, $start, $end, $rows, $item);
	}
	if($type == 'pie') {
		$data = pto_run_pie_report($type, $start, $end, $rows, $item);
	}
	if($type == 'pt') {
		$data = pto_run_pt_report($type, $start, $end, $rows, $item);
	}
	if($type == 'tt') {
		$data = pto_run_tt_report($type, $start, $end, $rows, $item);
	}
	$return =  array( 
		'error' => false,
		'data' => $data,
	);
	header('Content-type: application/json');
	echo json_encode($return);
	exit();	
}
// Income Report
function pto_run_in_report($type, $start = NULL, $end = NULL, $rows = 10, $item = NULL) {
	$items = pto_get_items('invoice');
	$data = array();
	$data['headers'] = '<th>' . __('Timestamp', 'cqpim-reporting') . '</th><th>' . __('Invoice ID', 'cqpim-reporting') . '</th><th>' . __('Invoice Date', 'cqpim-reporting') . '</th><th>' . __('Client', 'cqpim-reporting') . '</th><th>' . __('Total', 'cqpim-reporting') . '</th>';
	$data['footer'] = '<th colspan="4"></th><th></th>';
	$data['sort'] = 0;
	$data['order'] = 'desc';
	$data['content'] = '';
	$data['rows'] = $rows;
	$data['totals'] = 4;
	$data['currency'] = get_option('currency_symbol');
	if(!empty($start)) {
		$start = pto_convert_date($start . ' 00:00:00', get_option('cqpim_date_format') . ' H:i:s');	
	}
	if(!empty($end)) {
		$end = pto_convert_date($end . ' 23:59:59', get_option('cqpim_date_format') . ' H:i:s');
	}
	foreach($items as $item) {
		$invoice_details = get_post_meta($item->ID, 'invoice_details', true);
		$invoice_id = get_post_meta($item->ID, 'invoice_id', true);
		$invoice_date_stamp = isset($invoice_details['invoice_date']) ? $invoice_details['invoice_date'] : '';
		$invoice_date = date(get_option('cqpim_date_format'), $invoice_date_stamp);
		$totals = get_post_meta($item->ID, 'invoice_totals', true);
		$total = isset($totals['total']) ? $totals['total'] : '';
		$client_id = isset($invoice_details['client_id']) ? $invoice_details['client_id'] : '';
		$client_details = get_post_meta($client_id, 'client_details', true);
		$client_company = isset($client_details['client_company']) ? $client_details['client_company'] : '';
		if(!empty($start) || !empty($end)) {
			if(!empty($start) && !empty($end)) {
				if($invoice_date_stamp >= $start && $invoice_date_stamp <= $end) {
					$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
				}
			} else {
				if(!empty($start)) {
					if($invoice_date_stamp > $start) {
						$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
					}						
				}
				if(!empty($end)) {
					if($invoice_date_stamp < $end) {
						$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
					}						
				}
			}
		} else {
			$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
		}
	}
	return $data;
}
// Expenses Report
function pto_run_ex_report($type, $start = NULL, $end = NULL, $rows = 10, $item = NULL) {
	$items = pto_get_items('expense');
	$data = array();
	$data['headers'] = '<th>' . __('Timestamp', 'cqpim-reporting') . '</th><th>' . __('Expense ID', 'cqpim-reporting') . '</th><th>' . __('Expense Date', 'cqpim-reporting') . '</th><th>' . __('Title', 'cqpim-reporting') . '</th><th>' . __('Supplier', 'cqpim-reporting') . '</th><th>' . __('Total', 'cqpim-reporting') . '</th>';
	$data['footer'] = '<th colspan="5"></th><th></th>';
	$data['sort'] = 0;
	$data['order'] = 'desc';
	$data['content'] = '';
	$data['rows'] = $rows;
	$data['totals'] = 5;
	$data['currency'] = get_option('currency_symbol');
	if(!empty($start)) {
		$start = pto_convert_date($start . ' 00:00:00', get_option('cqpim_date_format') . ' H:i:s');	
	}
	if(!empty($end)) {
		$end = pto_convert_date($end . ' 23:59:59', get_option('cqpim_date_format') . ' H:i:s');
	}
	foreach($items as $item) {
		$supplier_id = get_post_meta($item->ID, 'supplier_id', true); 
		$project_id = get_post_meta($item->ID, 'project_id', true);
		$expense_date = get_post_meta($item->ID, 'expense_date', true);
		$invoice_date_stamp = get_post_meta($item->ID, 'expense_date', true);	
		$invoice_id = $item->ID;
		$invoice_date = date(get_option('cqpim_date_format'), $expense_date);
		$supplier_details = get_post_meta($supplier_id, 'supplier_details', true);
		$client_company = get_post($supplier_id);
		$client_company = $client_company->post_title;
		$totals = get_post_meta($item->ID, 'invoice_totals', true);
		$total = isset($totals['total']) ? $totals['total'] : '';
		if(!empty($start) || !empty($end)) {
			if(!empty($start) && !empty($end)) {
				if($invoice_date_stamp >= $start && $invoice_date_stamp <= $end) {
					$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $item->post_title . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
				}
			} else {
				if(!empty($start)) {
					if($invoice_date_stamp > $start) {
						$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $item->post_title . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
					}						
				}
				if(!empty($end)) {
					if($invoice_date_stamp < $end) {
						$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $item->post_title . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
					}						
				}
			}
		} else {
			$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $item->post_title . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
		}
	}
	return $data;
}
// Income / Expenses Report
function pto_run_inex_report($type, $start = NULL, $end = NULL, $rows = 10, $item = NULL) {
	$items = pto_get_items('expense');
	$data = array();
	$data['headers'] = '<th>' . __('Timestamp', 'cqpim-reporting') . '</th><th>' . __('Type', 'cqpim-reporting') . '</th><th>' . __('Item ID', 'cqpim-reporting') . '</th><th>' . __('Income / Expense Date', 'cqpim-reporting') . '</th><th>' . __('Title', 'cqpim-reporting') . '</th><th>' . __('Supplier / Client', 'cqpim-reporting') . '</th><th>' . __('Total Income', 'cqpim-reporting') . '</th><th>' . __('Total Expense', 'cqpim-reporting') . '</th>';
	$data['footer'] = '<th colspan="6"></th><th></th><th></th>';
	$data['sort'] = 0;
	$data['order'] = 'desc';
	$data['content'] = '';
	$data['rows'] = $rows;
	$data['totals'] = 7;
	$data['totals2'] = 6;
	$data['currency'] = get_option('currency_symbol');
	if(!empty($start)) {
		$start = pto_convert_date($start . ' 00:00:00', get_option('cqpim_date_format') . ' H:i:s');	
	}
	if(!empty($end)) {
		$end = pto_convert_date($end . ' 23:59:59', get_option('cqpim_date_format') . ' H:i:s');
	}
	$data['content'] = array();
	$i = 1;
	foreach($items as $item) {
		$supplier_id = get_post_meta($item->ID, 'supplier_id', true); 
		$project_id = get_post_meta($item->ID, 'project_id', true);
		$expense_date = get_post_meta($item->ID, 'expense_date', true);
		$invoice_date_stamp = get_post_meta($item->ID, 'expense_date', true);	
		$invoice_id = $item->ID;
		$invoice_date = date(get_option('cqpim_date_format'), $expense_date);
		$supplier_details = get_post_meta($supplier_id, 'supplier_details', true);
		$client_company = get_post($supplier_id);
		$client_company = $client_company->post_title;
		$totals = get_post_meta($item->ID, 'invoice_totals', true);
		$total = isset($totals['total']) ? $totals['total'] : '';
		if(!empty($start) || !empty($end)) {
			if(!empty($start) && !empty($end)) {
				if($invoice_date_stamp >= $start && $invoice_date_stamp <= $end) {
					$data['content'][$invoice_date_stamp + $i] = '<tr><td>' . $invoice_date_stamp . '</td><td>' . __('Expense', 'cqpim-reporting') . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $item->post_title . '</td><td>' . $client_company . '</td><td></td><td>' . cqpim_calculate_currency($item->ID, $total) . '</td></tr>';
				}
			} else {
				if(!empty($start)) {
					if($invoice_date_stamp > $start) {
						$data['content'][$invoice_date_stamp + $i] = '<tr><td>' . $invoice_date_stamp . '</td><td>' . __('Expense', 'cqpim-reporting') . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $item->post_title . '</td><td>' . $client_company . '</td><td></td><td>' . cqpim_calculate_currency($item->ID, $total) . '</td></tr>';
					}						
				}
				if(!empty($end)) {
					if($invoice_date_stamp < $end) {
						$data['content'][$invoice_date_stamp + $i] = '<tr><td>' . $invoice_date_stamp . '</td><td>' . __('Expense', 'cqpim-reporting') . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $item->post_title . '</td><td>' . $client_company . '</td><td></td><td>' . cqpim_calculate_currency($item->ID, $total) . '</td></tr>';
					}						
				}
			}
		} else {
			$data['content'][$invoice_date_stamp + $i] = '<tr><td>' . $invoice_date_stamp . '</td><td>' . __('Expense', 'cqpim-reporting') . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $item->post_title . '</td><td>' . $client_company . '</td><td></td><td>' . cqpim_calculate_currency($item->ID, $total) . '</td></tr>';
		}
		$i++;
	}
	$items = pto_get_items('invoice');
	$i2 = 1;
	foreach($items as $item) {
		$invoice_details = get_post_meta($item->ID, 'invoice_details', true);
		$invoice_id = get_post_meta($item->ID, 'invoice_id', true);
		$invoice_date_stamp = isset($invoice_details['invoice_date']) ? $invoice_details['invoice_date'] : '';
		$invoice_date = date(get_option('cqpim_date_format'), $invoice_date_stamp);
		$totals = get_post_meta($item->ID, 'invoice_totals', true);
		$total = isset($totals['total']) ? $totals['total'] : '';
		$client_id = isset($invoice_details['client_id']) ? $invoice_details['client_id'] : '';
		$client_details = get_post_meta($client_id, 'client_details', true);
		$client_company = isset($client_details['client_company']) ? $client_details['client_company'] : '';
		if(!empty($start) || !empty($end)) {
			if(!empty($start) && !empty($end)) {
				if($invoice_date_stamp >= $start && $invoice_date_stamp <= $end) {
					$data['content'][$invoice_date_stamp + $i2] = '<tr><td>' . $invoice_date_stamp . '</td><td>' . __('Income', 'cqpim-reporting') . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $item->post_title . '</td><td>' . $client_company . '</td><td>' . cqpim_calculate_currency($item->ID, $total) . '</td><td></td></tr>';
				}
			} else {
				if(!empty($start)) {
					if($invoice_date_stamp > $start) {
						$data['content'][$invoice_date_stamp + $i2] = '<tr><td>' . $invoice_date_stamp . '</td><td>' . __('Income', 'cqpim-reporting') . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $item->post_title . '</td><td>' . $client_company . '</td><td>' . cqpim_calculate_currency($item->ID, $total) . '</td><td></td></tr>';
					}						
				}
				if(!empty($end)) {
					if($invoice_date_stamp < $end) {
						$data['content'][$invoice_date_stamp + $i2] = '<tr><td>' . $invoice_date_stamp . '</td><td>' . __('Income', 'cqpim-reporting') . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $item->post_title . '</td><td>' . $client_company . '</td><td>' . cqpim_calculate_currency($item->ID, $total) . '</td><td></td></tr>';
					}						
				}
			}
		} else {
			$data['content'][$invoice_date_stamp + $i2] = '<tr><td>' . $invoice_date_stamp . '</td><td>' . __('Income', 'cqpim-reporting') . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $item->post_title . '</td><td>' . $client_company . '</td><td>' . cqpim_calculate_currency($item->ID, $total) . '</td><td></td></tr>';
		}	
		$i2++;
	}
	krsort($data['content']);
	$sorted = array();
	foreach($data['content'] as $item) {
		$sorted[] = $item;
	}
	$data['content'] = $sorted;
	return $data;
}
// Client Income Report
function pto_run_ic_report($type, $start = NULL, $end = NULL, $rows = 10, $object = NULL) {
	$items = pto_get_items('invoice');
	$data = array();
	$data['headers'] = '<th>' . __('Timestamp', 'cqpim-reporting') . '</th><th>' . __('Invoice ID', 'cqpim-reporting') . '</th><th>' . __('Invoice Date', 'cqpim-reporting') . '</th><th>' . __('Client', 'cqpim-reporting') . '</th><th>' . __('Total', 'cqpim-reporting') . '</th>';
	$data['footer'] = '<th colspan="4"></th><th></th>';
	$data['sort'] = 0;
	$data['order'] = 'desc';
	$data['content'] = '';
	$data['rows'] = $rows;
	$data['totals'] = 4;
	$data['currency'] = get_option('currency_symbol');
	if(!empty($start)) {
		$start = pto_convert_date($start . ' 00:00:00', get_option('cqpim_date_format') . ' H:i:s');	
	}
	if(!empty($end)) {
		$end = pto_convert_date($end . ' 23:59:59', get_option('cqpim_date_format') . ' H:i:s');
	}
	foreach($items as $item) {
		$invoice_details = get_post_meta($item->ID, 'invoice_details', true);
		$invoice_id = get_post_meta($item->ID, 'invoice_id', true);
		$invoice_date_stamp = isset($invoice_details['invoice_date']) ? $invoice_details['invoice_date'] : '';
		$invoice_date = date(get_option('cqpim_date_format'), $invoice_date_stamp);
		$totals = get_post_meta($item->ID, 'invoice_totals', true);
		$total = isset($totals['total']) ? $totals['total'] : '';
		$client_id = isset($invoice_details['client_id']) ? $invoice_details['client_id'] : '';
		$client_details = get_post_meta($client_id, 'client_details', true);
		$client_company = isset($client_details['client_company']) ? $client_details['client_company'] : '';
		if(!empty($object) && $object == $client_id) {
			if(!empty($start) || !empty($end)) {
				if(!empty($start) && !empty($end)) {
					if($invoice_date_stamp >= $start && $invoice_date_stamp <= $end) {
						$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
					}
				} else {
					if(!empty($start)) {
						if($invoice_date_stamp > $start) {
							$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
						}						
					}
					if(!empty($end)) {
						if($invoice_date_stamp < $end) {
							$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
						}						
					}
				}
			} else {
				$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
			}
		}
	}
	return $data;
}
function pto_run_tax_report($type, $start = NULL, $end = NULL, $rows = 10, $item = NULL) {
	$items = pto_get_items('invoice');
	$data = array();
	$data['headers'] = '<th>' . __('Timestamp', 'cqpim-reporting') . '</th><th>' . __('Invoice ID', 'cqpim-reporting') . '</th><th>' . __('Invoice Date', 'cqpim-reporting') . '</th><th>' . __('Client', 'cqpim-reporting') . '</th><th>' . __('Total', 'cqpim-reporting') . '</th>';
	$data['footer'] = '<th colspan="4"></th><th></th>';
	$data['sort'] = 0;
	$data['order'] = 'desc';
	$data['content'] = '';
	$data['rows'] = $rows;
	$data['totals'] = 4;
	$data['currency'] = get_option('currency_symbol');
	if(!empty($start)) {
		$start = pto_convert_date($start . ' 00:00:00', get_option('cqpim_date_format') . ' H:i:s');	
	}
	if(!empty($end)) {
		$end = pto_convert_date($end . ' 23:59:59', get_option('cqpim_date_format') . ' H:i:s');
	}
	foreach($items as $item) {
		$invoice_details = get_post_meta($item->ID, 'invoice_details', true);
		$invoice_id = get_post_meta($item->ID, 'invoice_id', true);
		$invoice_date_stamp = isset($invoice_details['invoice_date']) ? $invoice_details['invoice_date'] : '';
		$invoice_date = date(get_option('cqpim_date_format'), $invoice_date_stamp);
		$totals = get_post_meta($item->ID, 'invoice_totals', true);
		$total = isset($totals['tax']) ? $totals['tax'] : '';
		$client_id = isset($invoice_details['client_id']) ? $invoice_details['client_id'] : '';
		$client_details = get_post_meta($client_id, 'client_details', true);
		$client_company = isset($client_details['client_company']) ? $client_details['client_company'] : '';
		if(!empty($start) || !empty($end)) {
			if(!empty($start) && !empty($end)) {
				if($invoice_date_stamp >= $start && $invoice_date_stamp <= $end) {
					$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
				}
			} else {
				if(!empty($start)) {
					if($invoice_date_stamp > $start) {
						$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
					}						
				}
				if(!empty($end)) {
					if($invoice_date_stamp < $end) {
						$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
					}						
				}
			}
		} else {
			$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
		}
	}
	return $data;
}
function pto_run_stax_report($type, $start = NULL, $end = NULL, $rows = 10, $item = NULL) {
	$items = pto_get_items('invoice');
	$data = array();
	$data['headers'] = '<th>' . __('Timestamp', 'cqpim-reporting') . '</th><th>' . __('Invoice ID', 'cqpim-reporting') . '</th><th>' . __('Invoice Date', 'cqpim-reporting') . '</th><th>' . __('Client', 'cqpim-reporting') . '</th><th>' . __('Total', 'cqpim-reporting') . '</th>';
	$data['footer'] = '<th colspan="4"></th><th></th>';
	$data['sort'] = 0;
	$data['order'] = 'desc';
	$data['content'] = '';
	$data['rows'] = $rows;
	$data['totals'] = 4;
	$data['currency'] = get_option('currency_symbol');
	if(!empty($start)) {
		$start = pto_convert_date($start . ' 00:00:00', get_option('cqpim_date_format') . ' H:i:s');	
	}
	if(!empty($end)) {
		$end = pto_convert_date($end . ' 23:59:59', get_option('cqpim_date_format') . ' H:i:s');
	}
	foreach($items as $item) {
		$invoice_details = get_post_meta($item->ID, 'invoice_details', true);
		$invoice_id = get_post_meta($item->ID, 'invoice_id', true);
		$invoice_date_stamp = isset($invoice_details['invoice_date']) ? $invoice_details['invoice_date'] : '';
		$invoice_date = date(get_option('cqpim_date_format'), $invoice_date_stamp);
		$totals = get_post_meta($item->ID, 'invoice_totals', true);
		$total = isset($totals['stax']) ? $totals['stax'] : '';
		$client_id = isset($invoice_details['client_id']) ? $invoice_details['client_id'] : '';
		$client_details = get_post_meta($client_id, 'client_details', true);
		$client_company = isset($client_details['client_company']) ? $client_details['client_company'] : '';
		if(!empty($start) || !empty($end)) {
			if(!empty($start) && !empty($end)) {
				if($invoice_date_stamp >= $start && $invoice_date_stamp <= $end) {
					$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
				}
			} else {
				if(!empty($start)) {
					if($invoice_date_stamp > $start) {
						$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
					}						
				}
				if(!empty($end)) {
					if($invoice_date_stamp < $end) {
						$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
					}						
				}
			}
		} else {
			$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
		}
	}
	return $data;
}
function pto_run_ss_report($type, $start = NULL, $end = NULL, $rows = 10, $object = NULL) {
	$args = array(
		'post_type' => 'cqpim_expense',
		'posts_per_page' => -1,
		'post_status' => 'private',
		'orderby' => 'date',
		'order' => 'DESC',
		'meta_key' => 'supplier_id',
		'meta_value' => $object,
	);	
	$items = get_posts($args);
	$data = array();
	$data['headers'] = '<th>' . __('Timestamp', 'cqpim-reporting') . '</th><th>' . __('Expense ID', 'cqpim-reporting') . '</th><th>' . __('Expense Date', 'cqpim-reporting') . '</th><th>' . __('Title', 'cqpim-reporting') . '</th><th>' . __('Supplier', 'cqpim-reporting') . '</th><th>' . __('Total', 'cqpim-reporting') . '</th>';
	$data['footer'] = '<th colspan="5"></th><th></th>';
	$data['sort'] = 0;
	$data['order'] = 'desc';
	$data['content'] = '';
	$data['rows'] = $rows;
	$data['totals'] = 5;
	$data['currency'] = get_option('currency_symbol');
	if(!empty($start)) {
		$start = pto_convert_date($start . ' 00:00:00', get_option('cqpim_date_format') . ' H:i:s');	
	}
	if(!empty($end)) {
		$end = pto_convert_date($end . ' 23:59:59', get_option('cqpim_date_format') . ' H:i:s');
	}
	foreach($items as $item) {
		$supplier_id = get_post_meta($item->ID, 'supplier_id', true); 
		$project_id = get_post_meta($item->ID, 'project_id', true);
		$expense_date = get_post_meta($item->ID, 'expense_date', true);
		$invoice_date_stamp = get_post_meta($item->ID, 'expense_date', true);	
		$invoice_id = $item->ID;
		$invoice_date = date(get_option('cqpim_date_format'), $expense_date);
		$supplier_details = get_post_meta($supplier_id, 'supplier_details', true);
		$client_company = get_post($supplier_id);
		$client_company = $client_company->post_title;
		$totals = get_post_meta($item->ID, 'invoice_totals', true);
		$total = isset($totals['total']) ? $totals['total'] : '';
		if(!empty($start) || !empty($end)) {
			if(!empty($start) && !empty($end)) {
				if($invoice_date_stamp >= $start && $invoice_date_stamp <= $end) {
					$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $item->post_title . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
				}
			} else {
				if(!empty($start)) {
					if($invoice_date_stamp > $start) {
						$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $item->post_title . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
					}						
				}
				if(!empty($end)) {
					if($invoice_date_stamp < $end) {
						$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $item->post_title . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
					}						
				}
			}
		} else {
			$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $item->post_title . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
		}
	}
	return $data;		
}
function pto_run_te_report($type, $start = NULL, $end = NULL, $rows = 10, $object = NULL) {
	$team_details = get_post_meta($object, 'team_details', true);
	$user_id = isset($team_details['user_id']) ? $team_details['user_id'] : '';
	$args = array(
		'post_type' => 'cqpim_expense',
		'posts_per_page' => -1,
		'post_status' => 'private',
		'orderby' => 'date',
		'order' => 'DESC',
		'author' => $user_id,
	);	
	$items = get_posts($args);
	$data = array();
	$data['headers'] = '<th>' . __('Timestamp', 'cqpim-reporting') . '</th><th>' . __('Expense ID', 'cqpim-reporting') . '</th><th>' . __('Expense Date', 'cqpim-reporting') . '</th><th>' . __('Title', 'cqpim-reporting') . '</th><th>' . __('Supplier', 'cqpim-reporting') . '</th><th>' . __('Total', 'cqpim-reporting') . '</th>';
	$data['footer'] = '<th colspan="5"></th><th></th>';
	$data['sort'] = 0;
	$data['order'] = 'desc';
	$data['content'] = '';
	$data['rows'] = $rows;
	$data['totals'] = 5;
	$data['currency'] = get_option('currency_symbol');
	if(!empty($start)) {
		$start = pto_convert_date($start . ' 00:00:00', get_option('cqpim_date_format') . ' H:i:s');	
	}
	if(!empty($end)) {
		$end = pto_convert_date($end . ' 23:59:59', get_option('cqpim_date_format') . ' H:i:s');
	}
	foreach($items as $item) {
		$supplier_id = get_post_meta($item->ID, 'supplier_id', true); 
		$project_id = get_post_meta($item->ID, 'project_id', true);
		$expense_date = get_post_meta($item->ID, 'expense_date', true);
		$invoice_date_stamp = get_post_meta($item->ID, 'expense_date', true);	
		$invoice_id = $item->ID;
		$invoice_date = date(get_option('cqpim_date_format'), $expense_date);
		$supplier_details = get_post_meta($supplier_id, 'supplier_details', true);
		$client_company = get_post($supplier_id);
		$client_company = $client_company->post_title;
		$totals = get_post_meta($item->ID, 'invoice_totals', true);
		$total = isset($totals['total']) ? $totals['total'] : '';
		if(!empty($start) || !empty($end)) {
			if(!empty($start) && !empty($end)) {
				if($invoice_date_stamp >= $start && $invoice_date_stamp <= $end) {
					$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $item->post_title . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
				}
			} else {
				if(!empty($start)) {
					if($invoice_date_stamp > $start) {
						$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $item->post_title . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
					}						
				}
				if(!empty($end)) {
					if($invoice_date_stamp < $end) {
						$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $item->post_title . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
					}						
				}
			}
		} else {
			$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $item->post_title . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
		}
	}
	return $data;		
}
function pto_run_pi_report($type, $start = NULL, $end = NULL, $rows = 10, $object = NULL) {
	$items = pto_get_items('invoice');
	$data = array();
	$data['headers'] = '<th>' . __('Timestamp', 'cqpim-reporting') . '</th><th>' . __('Invoice ID', 'cqpim-reporting') . '</th><th>' . __('Invoice Date', 'cqpim-reporting') . '</th><th>' . __('Client', 'cqpim-reporting') . '</th><th>' . __('Total', 'cqpim-reporting') . '</th>';
	$data['footer'] = '<th colspan="4"></th><th></th>';
	$data['sort'] = 0;
	$data['order'] = 'desc';
	$data['content'] = '';
	$data['rows'] = $rows;
	$data['totals'] = 4;
	$data['currency'] = get_option('currency_symbol');
	if(!empty($start)) {
		$start = pto_convert_date($start . ' 00:00:00', get_option('cqpim_date_format') . ' H:i:s');	
	}
	if(!empty($end)) {
		$end = pto_convert_date($end . ' 23:59:59', get_option('cqpim_date_format') . ' H:i:s');
	}
	foreach($items as $item) {
		$invoice_details = get_post_meta($item->ID, 'invoice_details', true);
		$invoice_id = get_post_meta($item->ID, 'invoice_id', true);
		$invoice_date_stamp = isset($invoice_details['invoice_date']) ? $invoice_details['invoice_date'] : '';
		$invoice_project = isset($invoice_details['project_id']) ? $invoice_details['project_id'] : '';
		$invoice_date = date(get_option('cqpim_date_format'), $invoice_date_stamp);
		$totals = get_post_meta($item->ID, 'invoice_totals', true);
		$total = isset($totals['total']) ? $totals['total'] : '';
		$client_id = isset($invoice_details['client_id']) ? $invoice_details['client_id'] : '';
		$client_details = get_post_meta($client_id, 'client_details', true);
		$client_company = isset($client_details['client_company']) ? $client_details['client_company'] : '';
		if(!empty($object) && $object == $invoice_project) {
			if(!empty($start) || !empty($end)) {
				if(!empty($start) && !empty($end)) {
					if($invoice_date_stamp >= $start && $invoice_date_stamp <= $end) {
						$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
					}
				} else {
					if(!empty($start)) {
						if($invoice_date_stamp > $start) {
							$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
						}						
					}
					if(!empty($end)) {
						if($invoice_date_stamp < $end) {
							$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
						}						
					}
				}
			} else {
				$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
			}
		}
	}
	return $data;		
}
function pto_run_pie_report($type, $start = NULL, $end = NULL, $rows = 10, $object = NULL) {
	$items = pto_get_items('expense');
	$data = array();
	$data['headers'] = '<th>' . __('Timestamp', 'cqpim-reporting') . '</th><th>' . __('Type', 'cqpim-reporting') . '</th><th>' . __('Item ID', 'cqpim-reporting') . '</th><th>' . __('Income / Expense Date', 'cqpim-reporting') . '</th><th>' . __('Title', 'cqpim-reporting') . '</th><th>' . __('Supplier / Client', 'cqpim-reporting') . '</th><th>' . __('Total Income', 'cqpim-reporting') . '</th><th>' . __('Total Expense', 'cqpim-reporting') . '</th>';
	$data['footer'] = '<th colspan="6"></th><th></th><th></th>';
	$data['sort'] = 0;
	$data['order'] = 'desc';
	$data['content'] = '';
	$data['rows'] = $rows;
	$data['totals'] = 7;
	$data['totals2'] = 6;
	$data['currency'] = get_option('currency_symbol');
	if(!empty($start)) {
		$start = pto_convert_date($start . ' 00:00:00', get_option('cqpim_date_format') . ' H:i:s');	
	}
	if(!empty($end)) {
		$end = pto_convert_date($end . ' 23:59:59', get_option('cqpim_date_format') . ' H:i:s');
	}
	$data['content'] = array();
	foreach($items as $item) {
		$supplier_id = get_post_meta($item->ID, 'supplier_id', true); 
		$project_id = get_post_meta($item->ID, 'project_id', true);
		$expense_date = get_post_meta($item->ID, 'expense_date', true);
		$invoice_date_stamp = get_post_meta($item->ID, 'expense_date', true);	
		$invoice_id = $item->ID;
		$invoice_date = date(get_option('cqpim_date_format'), $expense_date);
		$supplier_details = get_post_meta($supplier_id, 'supplier_details', true);
		$client_company = get_post($supplier_id);
		$client_company = $client_company->post_title;
		$totals = get_post_meta($item->ID, 'invoice_totals', true);
		$total = isset($totals['total']) ? $totals['total'] : '';
		if(!empty($object) && $object == $project_id) {
			if(!empty($start) || !empty($end)) {
				if(!empty($start) && !empty($end)) {
					if($invoice_date_stamp >= $start && $invoice_date_stamp <= $end) {
						$data['content'][$invoice_date_stamp] = '<tr><td>' . $invoice_date_stamp . '</td><td>' . __('Expense', 'cqpim-reporting') . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $item->post_title . '</td><td>' . $client_company . '</td><td></td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
					}
				} else {
					if(!empty($start)) {
						if($invoice_date_stamp > $start) {
							$data['content'][$invoice_date_stamp] = '<tr><td>' . $invoice_date_stamp . '</td><td>' . __('Expense', 'cqpim-reporting') . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $item->post_title . '</td><td>' . $client_company . '</td><td></td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
						}						
					}
					if(!empty($end)) {
						if($invoice_date_stamp < $end) {
							$data['content'][$invoice_date_stamp] = '<tr><td>' . $invoice_date_stamp . '</td><td>' . __('Expense', 'cqpim-reporting') . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $item->post_title . '</td><td>' . $client_company . '</td><td></td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
						}						
					}
				}
			} else {
				$data['content'][$invoice_date_stamp] = '<tr><td>' . $invoice_date_stamp . '</td><td>' . __('Expense', 'cqpim-reporting') . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $item->post_title . '</td><td>' . $client_company . '</td><td></td><td>' . pto_calculate_currency($item->ID, $total) . '</td></tr>';
			}
		}
	}
	$items = pto_get_items('invoice');
	foreach($items as $item) {
		$invoice_details = get_post_meta($item->ID, 'invoice_details', true);
		$invoice_id = get_post_meta($item->ID, 'invoice_id', true);
		$invoice_date_stamp = isset($invoice_details['invoice_date']) ? $invoice_details['invoice_date'] : '';
		$invoice_date = date(get_option('cqpim_date_format'), $invoice_date_stamp);
		$totals = get_post_meta($item->ID, 'invoice_totals', true);
		$total = isset($totals['total']) ? $totals['total'] : '';
		$client_id = isset($invoice_details['client_id']) ? $invoice_details['client_id'] : '';
		$client_details = get_post_meta($client_id, 'client_details', true);
		$client_company = isset($client_details['client_company']) ? $client_details['client_company'] : '';
		$invoice_project = isset($invoice_details['project_id']) ? $invoice_details['project_id'] : '';
		if(!empty($object) && $object == $invoice_project) {
			if(!empty($start) || !empty($end)) {
				if(!empty($start) && !empty($end)) {
					if($invoice_date_stamp >= $start && $invoice_date_stamp <= $end) {
						$data['content'][$invoice_date_stamp] = '<tr><td>' . $invoice_date_stamp . '</td><td>' . __('Income', 'cqpim-reporting') . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $item->post_title . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td><td></td></tr>';
					}
				} else {
					if(!empty($start)) {
						if($invoice_date_stamp > $start) {
							$data['content'][$invoice_date_stamp] = '<tr><td>' . $invoice_date_stamp . '</td><td>' . __('Income', 'cqpim-reporting') . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $item->post_title . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td><td></td></tr>';
						}						
					}
					if(!empty($end)) {
						if($invoice_date_stamp < $end) {
							$data['content'][$invoice_date_stamp] = '<tr><td>' . $invoice_date_stamp . '</td><td>' . __('Income', 'cqpim-reporting') . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $item->post_title . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td><td></td></tr>';
						}						
					}
				}
			} else {
				$data['content'][$invoice_date_stamp] = '<tr><td>' . $invoice_date_stamp . '</td><td>' . __('Income', 'cqpim-reporting') . '</td><td>' . $invoice_id . '</td><td>' . $invoice_date . '</td><td>' . $item->post_title . '</td><td>' . $client_company . '</td><td>' . pto_calculate_currency($item->ID, $total) . '</td><td></td></tr>';
			}	
		}
	}
	krsort($data['content']);
	$sorted = array();
	foreach($data['content'] as $item) {
		$sorted[] = $item;
	}
	$data['content'] = $sorted;
	return $data;		
}
function pto_run_pt_report($type, $start = NULL, $end = NULL, $rows = 10, $object = NULL) {
	$item = get_post($object);
	$data = array();
	$data['headers'] = '<th>' . __('Timestamp', 'cqpim-reporting') . '</th><th>' . __('Task ID', 'cqpim-reporting') . '</th><th>' . __('Entry Time', 'cqpim-reporting') . '</th><th>' . __('Task Title', 'cqpim-reporting') . '</th><th>' . __('Team Member', 'cqpim-reporting') . '</th><th>' . __('Time (Hours)', 'cqpim-reporting') . '</th>';
	$data['footer'] = '<th colspan="5"></th><th></th>';
	$data['sort'] = 0;
	$data['order'] = 'desc';
	$data['content'] = '';
	$data['rows'] = $rows;
	$data['totals'] = 5;
	$data['currency'] = '';
	if(!empty($start)) {
		$start = pto_convert_date($start . ' 00:00:00', get_option('cqpim_date_format') . ' H:i:s');	
	}
	if(!empty($end)) {
		$end = pto_convert_date($end . ' 23:59:59', get_option('cqpim_date_format') . ' H:i:s');
	}
	$project_elements = get_post_meta($item->ID, 'project_elements', true);
	$task_array = array();
	if(empty($project_elements)) {
		$project_elements = array();
	}
	foreach($project_elements as $milestone) {
		$args = array(
			'post_type' => 'cqpim_tasks',
			'posts_per_page' => -1,
			'meta_key' => 'milestone_id',
			'meta_value' => $milestone['id'],
			'orderby' => 'date',
			'order' => 'ASC'
		);
		$tasks = get_posts($args);	
		foreach($tasks as $task) {
			$task_array[] = $task;
			$args = array(
				'post_type' => 'cqpim_tasks',
				'posts_per_page' => -1,
				'meta_key' => 'milestone_id',
				'meta_value' => $milestone['id'],
				'post_parent' => $task->ID,
				'orderby' => 'date',
				'order' => 'ASC'
			);
			$subtasks = get_posts($args);
			foreach($subtasks as $subtask) {
				$task_array[] = $subtask;
			}
		}
	}
	foreach($task_array as $task) {
		$task_object = get_post($task->ID);
		$time_spent = get_post_meta($task_object->ID, 'task_time_spent', true);
		if(!empty($time_spent)) {
			foreach($time_spent as $time) {	
				$invoice_date_stamp = isset($time['stamp']) ? $time['stamp'] : '';
				$date = date(get_option('cqpim_date_format') . ' H:i:s', $invoice_date_stamp);
				$name = isset($time['team']) ? $time['team'] : '';
				$time = isset($time['time']) ? $time['time'] : '';
				$time = floatval($time);
				if(!empty($start) || !empty($end)) {
					if(!empty($start) && !empty($end)) {
						if($invoice_date_stamp >= $start && $invoice_date_stamp <= $end) {
							$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $task_object->ID . '</td><td>' . $date . '</td><td>' . $task_object->post_title . '</td><td>' . $name . '</td><td>' . $time . '</td></tr>';
						}
					} else {
						if(!empty($start)) {
							if($invoice_date_stamp > $start) {
								$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $task_object->ID . '</td><td>' . $date . '</td><td>' . $task_object->post_title . '</td><td>' . $name . '</td><td>' . $time . '</td></tr>';
							}						
						}
						if(!empty($end)) {
							if($invoice_date_stamp < $end) {
								$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $task_object->ID . '</td><td>' . $date . '</td><td>' . $task_object->post_title . '</td><td>' . $name . '</td><td>' . $time . '</td></tr>';
							}						
						}
					}
				} else {
					$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $task_object->ID . '</td><td>' . $date . '</td><td>' . $task_object->post_title . '</td><td>' . $name . '</td><td>' . $time . '</td></tr>';
				}
			}
		}
	}
	return $data;
}
function pto_run_tt_report($type, $start = NULL, $end = NULL, $rows = 10, $object = NULL) {
	$data = array();
	$data['headers'] = '<th>' . __('Timestamp', 'cqpim-reporting') . '</th><th>' . __('Task ID', 'cqpim-reporting') . '</th><th>' . __('Entry Time', 'cqpim-reporting') . '</th><th>' . __('Task Title', 'cqpim-reporting') . '</th><th>' . __('Team Member', 'cqpim-reporting') . '</th><th>' . __('Time (Hours)', 'cqpim-reporting') . '</th>';
	$data['footer'] = '<th colspan="5"></th><th></th>';
	$data['sort'] = 0;
	$data['order'] = 'desc';
	$data['content'] = '';
	$data['rows'] = $rows;
	$data['totals'] = 5;
	$data['currency'] = '';
	if(!empty($start)) {
		$start = pto_convert_date($start . ' 00:00:00', get_option('cqpim_date_format') . ' H:i:s');	
	}
	if(!empty($end)) {
		$end = pto_convert_date($end . ' 23:59:59', get_option('cqpim_date_format') . ' H:i:s');
	}			
	$args = array(
		'post_type' => 'cqpim_tasks',
		'posts_per_page' => -1,
		'orderby' => 'date',
		'order' => 'ASC'
	);
	$tasks = get_posts($args);	
	foreach($tasks as $task) {
		$task_array[] = $task;
		$args = array(
			'post_type' => 'cqpim_tasks',
			'posts_per_page' => -1,
			'post_parent' => $task->ID,
			'orderby' => 'date',
			'order' => 'ASC'
		);
		$subtasks = get_posts($args);
		foreach($subtasks as $subtask) {
			$task_array[] = $subtask;
		}
	}
	foreach($task_array as $task) {
		$task_object = get_post($task->ID);
		$time_spent = get_post_meta($task_object->ID, 'task_time_spent', true);
		if(!empty($time_spent)) {
			foreach($time_spent as $time) {	
				if(!empty($object) && $object == $time['team_id']) {
					$invoice_date_stamp = isset($time['stamp']) ? $time['stamp'] : '';
					$date = date(get_option('cqpim_date_format') . ' H:i:s', $invoice_date_stamp);
					$name = isset($time['team']) ? $time['team'] : '';
					$time = isset($time['time']) ? $time['time'] : '';
					$time = floatval($time);
					if(!empty($start) || !empty($end)) {
						if(!empty($start) && !empty($end)) {
							if($invoice_date_stamp >= $start && $invoice_date_stamp <= $end) {
								$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $task_object->ID . '</td><td>' . $date . '</td><td>' . $task_object->post_title . '</td><td>' . $name . '</td><td>' . $time . '</td></tr>';
							}
						} else {
							if(!empty($start)) {
								if($invoice_date_stamp > $start) {
									$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $task_object->ID . '</td><td>' . $date . '</td><td>' . $task_object->post_title . '</td><td>' . $name . '</td><td>' . $time . '</td></tr>';
								}						
							}
							if(!empty($end)) {
								if($invoice_date_stamp < $end) {
									$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $task_object->ID . '</td><td>' . $date . '</td><td>' . $task_object->post_title . '</td><td>' . $name . '</td><td>' . $time . '</td></tr>';
								}						
							}
						}
					} else {
						$data['content'] .= '<tr><td>' . $invoice_date_stamp . '</td><td>' . $task_object->ID . '</td><td>' . $date . '</td><td>' . $task_object->post_title . '</td><td>' . $name . '</td><td>' . $time . '</td></tr>';
					}
				}
			}
		}
	}
	return $data;
}
function pto_get_items($type, $subtype = '', $dates = array()) {
	if($type == 'project') {
		$args = array(
			'post_type' => 'cqpim_project',
			'posts_per_page' => -1,
			'post_status' => 'private',
			'orderby' => 'date',
			'order' => 'DESC',
		);
		$items = get_posts($args);
	}
	if($type == 'teams') {
		$args = array(
			'post_type' => 'cqpim_teams',
			'posts_per_page' => -1,
			'post_status' => 'private',
			'orderby' => 'name',
			'order' => 'ASC',
		);	
		$items = get_posts($args);	
	}
	if($type == 'invoice') {
		$args = array(
			'post_type' => 'cqpim_invoice',
			'posts_per_page' => -1,
			'post_status' => 'publish',
			'orderby' => 'date',
			'order' => 'DESC',
		);	
		$items = get_posts($args);			
	}
	if($type == 'supplier') {
		$args = array(
			'post_type' => 'cqpim_supplier',
			'posts_per_page' => -1,
			'post_status' => 'private',
			'orderby' => 'name',
			'order' => 'ASC',
		);	
		$items = get_posts($args);			
	}
	if($type == 'expense') {
		$args = array(
			'post_type' => 'cqpim_expense',
			'posts_per_page' => -1,
			'post_status' => 'private',
			'orderby' => 'date',
			'order' => 'DESC',
		);	
		$items = get_posts($args);			
	}
	if($type == 'client') {
		$args = array(
			'post_type' => 'cqpim_client',
			'posts_per_page' => -1,
			'post_status' => 'private',
			'orderby' => 'name',
			'order' => 'ASC',
		);	
		$items = get_posts($args);			
	}
	return $items;
}