<?php
	// Add CQPIM Support Tickets page
	add_action( 'admin_menu' , 'register_pto_reporting_page', 31 ); 
	function register_pto_reporting_page() {
		$mypage = add_submenu_page(	
					'pto-dashboard',
					__('Reporting', 'cqpim-reporting'), 			
					__('Reporting', 'cqpim-reporting'),  			
					'cqpim_access_reporting', 			
					'pto-reporting', 		
					'pto_reporting'
		);
		add_action( 'load-' . $mypage, 'pto_enqueue_plugin_reporting_scripts' );
	}
	function pto_reporting() { ?>
		<br />
		<style>
			.dataTables_filter {padding-bottom:25px}
			.dt-button {    
				display: inline-block;
				font-weight: 400;
				text-align: center;
				vertical-align: middle;
				touch-action: manipulation;
				cursor: pointer;
				border: 1px solid transparent;
				white-space: nowrap;
				text-decoration: none;
				padding: 5px 9px;
				opacity: 0.7;
				filter: alpha(opacity=70);
				background: #fff;
				color:#2ab4c0!important;
				border:1px solid #2ab4c0;
			}
		</style>
		<div class="cqpim-dash-item-full">
			<div class="cqpim_block">
				<div class="cqpim_block_title">
					<div class="caption">
						<i class="fa fa-database font-green-sharp" aria-hidden="true"></i>
						<span class="caption-subject font-green-sharp sbold"><?php _e('Run a Report', 'cqpim-reporting'); ?> </span>
					</div>
				</div>
				<form id="create_report" action="">
					<p class="underline" id="report_item_type"><?php _e('Report Type', 'cqpim-reporting'); ?></p>
					<select id="report_name" required>
						<option value=""><?php _e('Choose a Report', 'cqpim-reporting'); ?></option>						
						<option value="pt"><?php _e('Project Time', 'cqpim-reporting'); ?></option>
						<option value="pi"><?php _e('Project Income', 'cqpim-reporting'); ?></option>
						<?php if(pto_check_addon_status('expenses')) { ?>
							<option value="pie"><?php _e('Project Income / Expenses', 'cqpim-reporting'); ?></option>
						<?php } ?>
						<option value="tt"><?php _e('Team Member Time Entries', 'cqpim-reporting'); ?></option>
						<?php if(pto_check_addon_status('expenses')) { ?>
							<option value="te"><?php _e('Team Member Expenses', 'cqpim-reporting'); ?></option>
						<?php } ?>
						<option value="in"><?php _e('Income', 'cqpim-reporting'); ?></option>
						<option value="ic"><?php _e('Income by Client', 'cqpim-reporting'); ?></option>
						<?php if(pto_check_addon_status('expenses')) { ?>
							<option value="ex"><?php _e('Expenses', 'cqpim-reporting'); ?></option>
							<option value="inex"><?php _e('Income & Expenses', 'cqpim-reporting'); ?></option>
						<?php } ?>
						<?php $tax = get_option('sales_tax_rate'); if(!empty($tax)) { ?>
							<option value="tax"><?php _e('Sales Tax Total', 'cqpim-reporting'); ?></option>
						<?php } ?>
						<?php $tax = get_option('secondary_sales_tax_rate'); if(!empty($tax)) { ?>
							<option value="stax"><?php _e('Secondary Sales Tax Total', 'cqpim-reporting'); ?></option>
						<?php } ?>
						<?php if(pto_check_addon_status('expenses')) { ?>
							<option value="ss"><?php _e('Supplier Spending', 'cqpim-reporting'); ?></option>
						<?php } ?>
					</select>
					<p class="underline" id="report_item_heading" style="display:none"></p>
					<select id="report_item" style="display:none">
						<option value=""><?php _e('Choose a Report First', 'cqpim-reporting'); ?></option>
					</select>
					<p class="underline"><?php _e('Dates (optional)', 'cqpim-reporting'); ?></p>
					<input style="width:150px; margin-right:10px" type="text" class="datepicker" id="start_date" />
					<input style="width:150px; margin-right:10px" type="text" class="datepicker" id="end_date" />
					<p class="underline"><?php _e('Results Per Page', 'cqpim-reporting'); ?></p>
					<select style="width:100px" id="report_rows">
						<option value="10">10</option>
						<option value="20">20</option>
						<option value="30">30</option>
						<option value="50">50</option>
						<option value="75">75</option>
						<option value="100">100</option>
						<option value="100000"><?php _e('All', 'cqpim-reporting'); ?></option>
					</select>
					<br /><br />
					<input id="report-submit" type="submit" class="cqpim_button font-green-sharp border-green-sharp mt-20" value="<?php _e('Generate Report', 'cqpim-reporting'); ?>" />
				</form>
				<div id="report-messages"></div>
			</div>
		</div>
		<br />
		<div class="cqpim-dash-item-full">
			<div class="cqpim_block">
				<div class="cqpim_block_title">
					<div class="caption">
						<i class="fa fa-database font-green-sharp" aria-hidden="true"></i>
						<span class="caption-subject font-green-sharp sbold"><?php _e('Report Results', 'cqpim-reporting'); ?> </span>
					</div>
				</div>
				<br />
				<div id="results_wrapper">
					<table id="results_table" class="cqpim_table datatable_style">
						<thead>
							<tr>
								<th><?php _e('No Results.', 'cqpim-reporting'); ?></th>
							</tr>
						</thead>
						<tbody>
							<tr>
								<td><?php _e('Run a report to gather results.', 'cqpim-reporting'); ?></td>
							</tr>
						</tbody>
						<tfoot>
							<tr>
								<th></th>
							</tr>
						</tfoot>
					</table>
				</div>
				<div id="results_wrapper_sample" style="display:none">
					<table id="results_table_test" class="cqpim_table datatable_style">
						<thead>
							<tr>
								<th><?php __('No Results.', 'cqpim-reporting'); ?></th>
							</tr>
						</thead>
						<tbody>
							<tr>
								<td><?php __('Run a report to gather results.', 'cqpim-reporting'); ?></td>
							</tr>
						</tbody>
						<tfoot>
							<tr>
								<th></th>
							</tr>
						</tfoot>
					</table>
				</div>
			</div>
		</div>
	<?php } ?>