<?php
if ( ! function_exists('pto_plans_cpt') ) {
	function pto_plans_cpt() {
		if(current_user_can('cqpim_create_new_plan') && current_user_can('publish_cqpim_plans')) {
			$form_caps = array();
		} else {
			$form_caps = array('create_posts' => false);
		}	
		$labels = array(
			'name'                => _x( 'Subscription Plans', 'Post Type General Name', 'cqpim-subscriptions' ),
			'singular_name'       => _x( 'Subscription Plan', 'Post Type Singular Name', 'cqpim-subscriptions' ),
			'menu_name'           => __( 'Subscription Plans', 'cqpim-subscriptions' ),
			'parent_item_colon'   => __( 'Parent Subscription Plan:', 'cqpim-subscriptions' ),
			'all_items'           => __( 'Subscription Plans', 'cqpim-subscriptions' ),
			'view_item'           => __( 'View Subscription Plan', 'cqpim-subscriptions' ),
			'add_new_item'        => __( 'Add New Subscription Plan', 'cqpim-subscriptions' ),
			'add_new'             => __( 'New Subscription Plan', 'cqpim-subscriptions' ),
			'edit_item'           => __( 'Edit Subscription Plan', 'cqpim-subscriptions' ),
			'update_item'         => __( 'Update Subscription Plan', 'cqpim-subscriptions' ),
			'search_items'        => __( 'Search Subscription Plans', 'cqpim-subscriptions' ),
			'not_found'           => __( 'No Subscription Plans found', 'cqpim-subscriptions' ),
			'not_found_in_trash'  => __( 'No Subscription Plans found in trash', 'cqpim-subscriptions' ),
		);
		$args = array(
			'label'               => __( 'plans', 'cqpim-subscriptions' ),
			'description'         => __( 'Subscription Plans', 'cqpim-subscriptions' ),
			'labels'              => $labels,
			'supports'            => array( 'title' ),
			'hierarchical'        => false,
			'capabilities'        => $form_caps,
			'public'              => false,
			'show_ui'             => true,
			'show_in_nav_menus'   => false,
			'show_in_menu'		  => 'admin.php?page=cqpim-subscriptions',	
			'show_in_admin_bar'   => false,
			'menu_position'       => 5,
			'menu_icon'           => plugins_url() . "/img/contact.png",
			'can_export'          => true,
			'has_archive'         => true,
			'exclude_from_search' => true,
			'publicly_queryable'  => false,
			'capability_type'     => array('cqpim_plan', 'cqpim_plans'),
			'map_meta_cap'        => true,
			'query_var'			  => true,
		);
		register_post_type( 'cqpim_plan', $args );
	}
	add_action( 'init', 'pto_plans_cpt', 18 );
}
	add_action( 'init', 'pto_plan_cats', 0 );
	function pto_plan_cats() {
		$labels = array(
			'name'              => __( 'Subscription Plan Type', 'cqpim-subscriptions' ),
			'singular_name'     => __( 'Subscription Plan Type', 'cqpim-subscriptions' ),
			'search_items'      => __( 'Search Subscription Plan Types', 'cqpim-subscriptions' ),
			'all_items'         => __( 'All Subscription Plan Types', 'cqpim-subscriptions' ),
			'parent_item'       => __( 'Parent Subscription Plan Type', 'cqpim-subscriptions' ),
			'parent_item_colon' => __( 'Parent Subscription Plan Type:', 'cqpim-subscriptions' ),
			'edit_item'         => __( 'Edit Subscription Plan Type', 'cqpim-subscriptions' ),
			'update_item'       => __( 'Update Subscription Plan Type', 'cqpim-subscriptions' ),
			'add_new_item'      => __( 'Add New Subscription Plan Type', 'cqpim-subscriptions' ),
			'new_item_name'     => __( 'New Genre Subscription Plan Type', 'cqpim-subscriptions' ),
			'menu_name'         => __( 'Subscription Plan Types', 'cqpim-subscriptions' ),
		);
		$args = array(
			'hierarchical'      => true,
			'labels'            => $labels,
			'show_ui'           => true,
			'show_admin_column' => true,
			'query_var'         => true,
			'rewrite'           => false,
		);
		register_taxonomy( 'cqpim_plan_cat', array( 'cqpim_plan' ), $args );
	}
	
add_filter( 'bulk_actions-edit-cqpim_plan', 'pto_remove_plan_delete' );
function pto_remove_plan_delete( $actions ){
	unset( $actions[ 'trash' ] );
	unset( $actions[ 'edit' ] );
	return $actions;
}