<?php
add_action( "wp_ajax_pto_delete_plan_page", "pto_delete_plan_page");
function pto_delete_plan_page() {
	$task_id = isset($_POST['task_id']) ? $_POST['task_id'] : '';
	wp_delete_post($task_id, true);
	$return =  array( 
		'error' 	=> false,
		'redirect' 	=> admin_url() . 'edit.php?post_type=cqpim_plan'
	);
	header('Content-type: application/json');
	echo json_encode($return);	
	exit();
}
add_action( "wp_ajax_pto_delete_subscription_page", "pto_delete_subscription_page");
function pto_delete_subscription_page() {
	$task_id = isset($_POST['task_id']) ? $_POST['task_id'] : '';
	wp_delete_post($task_id, true);
	$return =  array( 
		'error' 	=> false,
		'redirect' 	=> admin_url() . 'admin.php?page=pto-subscriptions'
	);
	header('Content-type: application/json');
	echo json_encode($return);	
	exit();
}
function pto_get_subscription_id() {
	$args = array(
		'post_type' => 'cqpim_subscription',
		'posts_per_page' => 1,
		'orderby' => 'date',
		'order' => 'desc',
		'post_status' => 'private'
	);
	$invoices = get_posts($args);
	if(!empty($invoices)) {
		foreach($invoices as $invoice) {
			$invoice_id = get_post_meta($invoice->ID, 'subscription_id', true);
		}
		$invoice_id++;
	} else {
		$invoice_id = 1;
	}
	return $invoice_id;
}
function pto_check_gateway_config() {
	$gateways = array();
	$pp1 = get_option('cqpim_paypal_api_signature');
	$pp2 = get_option('cqpim_paypal_api_password');
	$pp3 = get_option('cqpim_paypal_api_username');
	if(!empty($pp1) && !empty($pp2) && !empty($pp3)) {
		$gateways[] = array(
			'name' => 'PayPal',
			'id' => 'paypal'
		);
	}	
	$str1 = get_option('client_invoice_stripe_key' );
	$str2 = get_option('client_invoice_stripe_secret' );
	if(!empty($str1) && !empty($str2)) {
		$gateways[] = array(
			'name' => 'Stripe',
			'id' => 'stripe'
		);
	}
	if(pto_check_addon_status('2checkout')) {
		$tc1 = get_option('cqpim_twocheck_pub_key');
		$tc2 = get_option('cqpim_twocheck_priv_key');
		$tc3 = get_option('client_invoice_twocheck_sid');
		if(!empty($tc1) && !empty($tc2) && !empty($tc3)) {
			$gateways[] = array(
				'name' => '2Checkout',
				'id' => '2checkout'
			);
		}
	}
	return $gateways;
}
add_action( "wp_ajax_pto_change_dash_sub_status", "pto_change_dash_sub_status");
function pto_change_dash_sub_status() {
	$status = isset($_POST['status']) ? $_POST['status'] : '';
	$_SESSION['sub_status_filter'] = isset($status) ? $status : '';
	$return =  array( 
		'error' 	=> false,
		'errors' 	=> ''
	);
	header('Content-type: application/json');
	echo json_encode($return);		
	exit;
}
add_action( "wp_ajax_pto_change_dash_sub_due", "pto_change_dash_sub_due");
function pto_change_dash_sub_due() {
	$status = isset($_POST['status']) ? $_POST['status'] : '';
	$_SESSION['renewals_in'] = isset($status) ? $status : '';
	$return =  array( 
		'error' 	=> false,
		'errors' 	=> ''
	);
	header('Content-type: application/json');
	echo json_encode($return);		
	exit;
}
function pto_return_subscription_status($subscription_status, $cd = false) {
	if(empty($cd)) {
		if(empty($subscription_status)) {
			echo '<div class="cqpim_button op nolink bg-blue font-white rounded_2" style="text-align:center; width:calc(100% - 26px)">';
				_e('INACTIVE', 'cqpim-subscriptions');
			echo '</div>';
		} else {
			if($subscription_status == 'sent') {
				echo '<div class="cqpim_button op nolink bg-amber font-white rounded_2" style="text-align:center; width:calc(100% - 26px)">';
					_e('AWAITING ACTIVATION', 'cqpim-subscriptions');
				echo '</div>';				
			}
			if($subscription_status == 'active') {
				echo '<div class="cqpim_button op nolink bg-green-sharp font-white rounded_2" style="text-align:center; width:calc(100% - 26px)">';
					_e('ACTIVE', 'cqpim-subscriptions');
				echo '</div>';				
			}
			if($subscription_status == 'cancelled') {
				echo '<div class="cqpim_button op nolink bg-grey-cascade font-white rounded_2" style="text-align:center; width:calc(100% - 26px)">';
					_e('CANCELLED', 'cqpim-subscriptions');
				echo '</div>';				
			}
			if($subscription_status == 'expired') {
				echo '<div class="cqpim_button op nolink bg-grey-cascade font-white rounded_2" style="text-align:center; width:calc(100% - 26px)">';
					_e('EXPIRED', 'cqpim-subscriptions');
				echo '</div>';				
			}
			if($subscription_status == 'late') {
				echo '<div class="cqpim_button op nolink bg-red font-white rounded_2" style="text-align:center; width:calc(100% - 26px)">';
					_e('OVERDUE', 'cqpim-subscriptions');
				echo '</div>';					
			}			
		}
	} else {
		if(empty($subscription_status)) {
			echo '<div class="cqpim_button cqpim_small_button op nolink bg-blue font-white rounded_2">';
				_e('INACTIVE', 'cqpim-subscriptions');
			echo '</div>';
		} else {
			if($subscription_status == 'sent') {
				echo '<div class="cqpim_button cqpim_small_button op nolink bg-amber font-white rounded_2">';
					_e('AWAITING ACTIVATION', 'cqpim-subscriptions');
				echo '</div>';				
			}
			if($subscription_status == 'active') {
				echo '<div class="cqpim_button cqpim_small_button op nolink bg-green-sharp font-white rounded_2">';
					_e('ACTIVE', 'cqpim-subscriptions');
				echo '</div>';				
			}
			if($subscription_status == 'cancelled') {
				echo '<div class="cqpim_button cqpim_small_button op nolink bg-grey-cascade font-white rounded_2">';
					_e('CANCELLED', 'cqpim-subscriptions');
				echo '</div>';				
			}
			if($subscription_status == 'expired') {
				echo '<div class="cqpim_button cqpim_small_button op nolink bg-grey-cascade font-white rounded_2">';
					_e('EXPIRED', 'cqpim-subscriptions');
				echo '</div>';				
			}
			if($subscription_status == 'late') {
				echo '<div class="cqpim_button cqpim_small_button op nolink bg-red font-white sbold rounded_2">';
					_e('OVERDUE', 'cqpim-subscriptions');
				echo '</div>';					
			}			
		}		
	}
}
function pto_calculate_next_charge($post) {
	$post = get_post($post);
	$activated = get_post_meta($post->ID, 'activated', true);
	if(empty($activated)) {
		$subscription_start = get_post_meta($post->ID, 'subscription_start', true);
		if(!empty($subscription_start)) {
			$now = $subscription_start;
		} else {
			$now = current_time('timestamp');
		}
	} else {
		$now = current_time('timestamp');
	}
	$subscription_frequency = get_post_meta($post->ID, 'subscription_frequency', true);
	if($subscription_frequency == 'day') {
		$timestamp = strtotime('+1 day', $now);
	} elseif($subscription_frequency == 'week') {
		$timestamp = strtotime('+1 week', $now);
	} elseif($subscription_frequency == 'biweek') {
		$timestamp = strtotime('+2 weeks', $now);
	} elseif($subscription_frequency == 'month') {
		$timestamp = strtotime('+1 month', $now);
	} elseif($subscription_frequency == 'bimonth') {
		$timestamp = strtotime('+2 months', $now);
	} elseif($subscription_frequency == 'trimonth') {
		$timestamp = strtotime('+3 months', $now);
	} elseif($subscription_frequency == 'sixmonth') {
		$timestamp = strtotime('+6 months', $now);
	} elseif($subscription_frequency == 'year') {
		$timestamp = strtotime('+1 year', $now);
	} elseif($subscription_frequency == 'biyear') {
		$timestamp = strtotime('+2 years', $now);
	}
	return $timestamp;
}
function pto_return_frequency_readable($interval) {
	if($interval == 'day') {
		return __('Daily', 'cqpim-subscriptions');
	} elseif($interval == 'week') {
		return __('Weekly', 'cqpim-subscriptions');
	} elseif($interval == 'biweek') {
		return __('Every Two Weeks', 'cqpim-subscriptions');
	} elseif($interval == 'month') {
		return __('Monthly', 'cqpim-subscriptions');
	} elseif($interval == 'bimonth') {
		return __('Every Two Months', 'cqpim-subscriptions');
	} elseif($interval == 'trimonth') {
		return __('Every 3 Months', 'cqpim-subscriptions');
	} elseif($interval == 'sixmonth') {
		return __('Every 6 Months', 'cqpim-subscriptions');
	} elseif($interval == 'year') {
		return __('Yearly', 'cqpim-subscriptions');
	} elseif($interval == 'biyear') {
		return __('Every Two Years', 'cqpim-subscriptions');
	}	
}
function pto_return_user_display($user) {
	$user = get_user_by('id', $user);
	return isset($user->display_name) ? $user->display_name : '';
}
function pto_return_sub_cancel($post) {
	echo '<button id="cancel_sub" data-id="' . $post . '" class="cqpim_button cqpim_button_link font-white bg-red block mt-10 rounded_2 block">' . __('Cancel Subscription', 'cqpim-subscriptions') . '</button>';
	?>
	<div id="invoice_payment_container" style="display:none">
		<div id="invoice_payment">
			<div style="padding:12px">
				<h3><?php _e('Cancel Subscription', 'cqpim-subscriptions'); ?></h3>
				<p><?php _e('Are you sure you want to cancel this subscription?', 'cqpim-subscriptions'); ?></p>
				<div class="clear"></div>
				<?php echo '<button class="cqpim_button font-green border-green mt-10 right op" id="cancel_sub_conf" data-id="' . $post . '">' . __('Confirm', 'cqpim-subscriptions') . '</button>'; ?>								
				<div class="clear"></div>
				<br />
			</div>
		</div>
	</div>	
<?php }
add_action( "wp_ajax_pto_send_subscription", "pto_send_subscription");
function pto_send_subscription() {
	$sub_id = isset($_POST['sub_id']) ? $_POST['sub_id'] : '';
	$user = wp_get_current_user();
	update_post_meta($sub_id, 'activated', '');
	update_post_meta($sub_id, 'activated_info', '');
	update_post_meta($sub_id, 'cancelled', '');
	update_post_meta($sub_id, 'cancelled_info', '');
	$subscription_client = get_post_meta($sub_id, 'subscription_client', true);
	$subscription_client_contact = get_post_meta($sub_id, 'subscription_client_contact', true);
	$client_contacts = get_post_meta($subscription_client, 'client_contacts', true);
	$client_details = get_post_meta($subscription_client, 'client_details', true);
	$client_main_id = isset($client_details['user_id']) ? $client_details['user_id'] : '';
	if(empty($client_contacts)) {
		$client_contacts = array();
	}
	if(!empty($subscription_client_contact)) {
		if($subscription_client_contact == $client_main_id) {
			$to = $client_details['client_email'];
			$name = isset($client_details['client_contact']) ? $client_details['client_contact'] : '';
		} else {
			$to = $client_contacts[$subscription_client_contact]['email'];
			$name = isset($client_contacts[$subscription_client_contact]['name']) ? $client_contacts[$subscription_client_contact]['name'] : '';
		}
	} else {
		$to = $client_details['client_email'];
		$name = isset($client_details['client_contact']) ? $client_details['client_contact'] : '';
	}
	$content = get_option('cqpim_new_subscription_content');
	$subject = get_option('cqpim_new_subscription_subject');
	$content = str_replace('%%CLIENT_NAME%%', $name, $content);
	$content = pto_replacement_patterns($content, $sub_id, 'subscription');
	$subject = pto_replacement_patterns($subject, $sub_id, 'subscription');
	pto_add_team_notification($subscription_client, $user->ID, $sub_id, 'subscription_sent', $ctype = 'subscription');
	if(pto_send_emails($to, $subject, $content, '', '', 'sales')) {
		update_post_meta($sub_id, 'sent', true);
		update_post_meta($sub_id, 'subscription_status', 'sent');
		$details = array(
			'to' => $to,
			'by' => $user->display_name,
			'on' => current_time('timestamp'),
		);
		update_post_meta($sub_id, 'sent_info', $details);
		$return =  array( 
			'error' 	=> false,
			'message' 	=> '<div class="cqpim-alert cqpim-alert-success alert-display">' . __('The email was sent successfully.', 'cqpim-subscriptions') . '</div>'
		);
		header('Content-type: application/json');
		echo json_encode($return);	
		exit();		
	} else {
		$return =  array( 
			'error' => true,
			'message' 	=> '<div class="cqpim-alert cqpim-alert-danger alert-display">' . __('The email could not be sent at this time.', 'cqpim-subscriptions') . '</div>'
		);
		header('Content-type: application/json');
		echo json_encode($return);	
		exit();
	}
}
function pto_send_activation_mail($post) {
	$post = get_post($post);
	$args = array(
		'post_type' => 'cqpim_teams',
		'posts_per_page' => -1,
		'post_status' => 'private'
	);
	$teams = get_posts($args);
	$to = array();
	foreach($teams as $team) {
		$team_details = get_post_meta($team->ID, 'team_details', true);
		$user_id = isset($team_details['user_id']) ? $team_details['user_id'] : '';
		$email = isset($team_details['team_email']) ? $team_details['team_email'] : '';
		$name = isset($team_details['team_name']) ? $team_details['team_name'] : '';
		if(!empty($user_id)) {
			$user = get_user_by('id', $user_id);
			if(user_can($user, 'edit_cqpim_subscriptions')) {
				$to[] = array(
					'mail' => $email,
					'name' => $name,
				);
			}
		}
	}
	foreach($to as $address) {
		$subject = get_option('cqpim_new_subscription_accept_subject');
		$content = get_option('cqpim_new_subscription_accept_content');
		$content = str_replace('%%TEAM_NAME%%', $address['name'], $content);
		$subject = pto_replacement_patterns($subject, $post->ID, 'subscription');
		$content = pto_replacement_patterns($content, $post->ID, 'subscription');
		pto_send_emails($address['mail'], $subject, $content, '', '', 'sales');
	}
	return;
}
function pto_subs_send_failed_mail($post) {
	$post = get_post($post);
	$args = array(
		'post_type' => 'cqpim_teams',
		'posts_per_page' => -1,
		'post_status' => 'private'
	);
	$teams = get_posts($args);
	$to = array();
	foreach($teams as $team) {
		$team_details = get_post_meta($team->ID, 'team_details', true);
		$user_id = isset($team_details['user_id']) ? $team_details['user_id'] : '';
		$email = isset($team_details['team_email']) ? $team_details['team_email'] : '';
		$name = isset($team_details['team_name']) ? $team_details['team_name'] : '';
		if(!empty($user_id)) {
			$user = get_user_by('id', $user_id);
			if(user_can($user, 'edit_cqpim_subscriptions')) {
				$to[] = array(
					'mail' => $email,
					'name' => $name,
				);
			}
		}
	}
	$subscription_client = get_post_meta($sub_id, 'subscription_client', true);
	$subscription_client_contact = get_post_meta($sub_id, 'subscription_client_contact', true);
	$client_contacts = get_post_meta($subscription_client, 'client_contacts', true);
	$client_details = get_post_meta($subscription_client, 'client_details', true);
	$client_main_id = isset($client_details['user_id']) ? $client_details['user_id'] : '';
	if(empty($client_contacts)) {
		$client_contacts = array();
	}
	if(!empty($subscription_client_contact)) {
		if($subscription_client_contact == $client_main_id) {
			$to[] = array(
				'mail' => $client_details['client_email'],
				'name' => isset($client_details['client_contact']) ? $client_details['client_contact'] : '',
			);
		} else {
			$to[] = array(
				'mail' => $client_contacts[$subscription_client_contact]['email'],
				'name' => isset($client_contacts[$subscription_client_contact]['name']) ? $client_contacts[$subscription_client_contact]['name'] : '',
			);
		}
	} else {
		$to[] = array(
			'mail' => $client_details['client_email'],
			'name' => isset($client_details['client_contact']) ? $client_details['client_contact'] : '',
		);
	}
	foreach($to as $address) {
		$subject = get_option('cqpim_subscription_failed_subject');
		$content = get_option('cqpim_subscription_failed_content');
		$content = str_replace('%%CLIENT_NAME%%', $address['name'], $content);
		$subject = pto_replacement_patterns($subject, $post->ID, 'subscription');
		$content = pto_replacement_patterns($content, $post->ID, 'subscription');
		pto_send_emails($address['mail'], $subject, $content, '', '', 'sales');
	}
	return;
}
add_action( "wp_ajax_nopriv_pto_cancel_subscription", "pto_cancel_subscription");
add_action( "wp_ajax_pto_cancel_subscription", "pto_cancel_subscription");
function pto_cancel_subscription() {
	$post = isset($_POST['post_id']) ? $_POST['post_id'] : '';
	$user = wp_get_current_user();
	if(empty($post)) {
		$return =  array( 
			'error' 	=> true,
			'message' 	=> __('The subscription could not be cancelled. Subscription ID missing', 'cqpim-subscriptions')
		);
		header('Content-type: application/json');
		echo json_encode($return);	
		exit();
	}
	update_post_meta($post, 'activated', '');
	update_post_meta($post, 'activated_info', '');
	update_post_meta($post, 'next_charge', '');
	update_post_meta($post, 'subscription_status', 'cancelled');
	update_post_meta($post, 'cancelled', true);
	update_post_meta($post, 'cancelled_info', array('by' => $user->ID, 'on' => current_time('timestamp')));
	$args = array(
		'post_type' => 'cqpim_teams',
		'posts_per_page' => -1,
		'post_status' => 'private'
	);
	$teams = get_posts($args);
	$to = array();
	$subscription_client = get_post_meta($post, 'subscription_client', true);
	$subscription_client_contact = get_post_meta($post, 'subscription_client_contact', true);
	$client_contacts = get_post_meta($subscription_client, 'client_contacts', true);
	$client_details = get_post_meta($subscription_client, 'client_details', true);
	$client_main_id = isset($client_details['user_id']) ? $client_details['user_id'] : '';
	if(empty($client_contacts)) {
		$client_contacts = array();
	}
	if(!empty($subscription_client_contact)) {
		if($subscription_client_contact == $client_main_id) {
			$to[] = array(
				'mail' => $client_details['client_email'],
				'name' => isset($client_details['client_contact']) ? $client_details['client_contact'] : '',
			);
		} else {
			$to[] = array(
				'mail' => $client_contacts[$subscription_client_contact]['email'],
				'name' => isset($client_contacts[$subscription_client_contact]['name']) ? $client_contacts[$subscription_client_contact]['name'] : '',
			);
		}
	} else {
		$to[] = array(
			'mail' => $client_details['client_email'],
			'name' => isset($client_details['client_contact']) ? $client_details['client_contact'] : '',
		);
	}
	foreach($teams as $team) {
		$team_details = get_post_meta($team->ID, 'team_details', true);
		$user_id = isset($team_details['user_id']) ? $team_details['user_id'] : '';
		$email = isset($team_details['team_email']) ? $team_details['team_email'] : '';
		$name = isset($team_details['team_name']) ? $team_details['team_name'] : '';
		if(!empty($user_id)) {
			$user_obj = get_user_by('id', $user_id);
			if(user_can($user_obj, 'edit_cqpim_subscriptions')) {
				$to[] = array(
					'mail' => $email,
					'name' => $name,
				);
				pto_add_team_notification($team->ID, $user->ID, $post, 'subscription_cancelled');
			}
		}
	}
	foreach($to as $address) {
		$subject = get_option('cqpim_subscription_cancelled_subject');
		$content = get_option('cqpim_subscription_cancelled_content');
		$content = str_replace('%%NAME%%', $address['name'], $content);
		$subject = pto_replacement_patterns($subject, $post, 'subscription');
		$content = pto_replacement_patterns($content, $post, 'subscription');
		pto_send_emails($address['mail'], $subject, $content, '', '', 'sales');
	}	
	$dash_page = get_option('cqpim_client_page');
	$return =  array( 
		'error' 	=> false,
		'redirect' 	=> get_the_permalink($post)
	);
	header('Content-type: application/json');
	echo json_encode($return);	
	exit();	
}
function pto_create_sub_invoice($sub_id) {
	$subscription_client = get_post_meta($sub_id, 'subscription_client', true);
	$subscription_client_contact = get_post_meta($sub_id, 'subscription_client_contact', true);	
	$sub_item_type = get_post_meta($sub_id, 'sub_item_type', true); 
	$sub_plan = get_post_meta($sub_id, 'sub_plan', true);
	$invoice_id = pto_get_invoice_id();
	$new_invoice = array(
		'post_type' => 'cqpim_invoice',
		'post_status' => 'publish',
		'post_content' => '',
		'post_title' =>  $invoice_id,
		'post_password' => pto_random_string(10),
	);
	$invoice_pid = wp_insert_post( $new_invoice, true );
	if( ! is_wp_error( $invoice_pid ) ){
		$client_details = get_post_meta($subscription_client, 'client_details', true);
		$invoice_terms = isset($client_details['invoice_terms']) ? $client_details['invoice_terms']: '';
		$system_invoice_terms = get_option('company_invoice_terms');
		if(!empty($invoice_terms)) {
			$terms = $invoice_terms;
		} else {
			$terms = $system_invoice_terms;
		}
		$date = current_time('timestamp');
		$terms_over = strtotime('+' . $terms . ' days', $date);
		$invoice_details = array(
			'client_id' => $subscription_client,
			'deposit' => false,
			'terms_over' => $terms_over,
			'invoice_date' => current_time('timestamp'),
			'allow_partial' => false,
		);
		update_post_meta($invoice_pid, 'invoice_client', $subscription_client);
		update_post_meta($invoice_pid, 'client_contact', $subscription_client_contact);
		update_post_meta($invoice_pid, 'invoice_id', $invoice_id);
		update_post_meta($invoice_pid, 'invoice_details', $invoice_details);
		update_post_meta($invoice_pid, 'subscription_id', $sub_id);
		if(!empty($sub_item_type) && $sub_item_type == 'plan') { 
			$line_items = get_post_meta($sub_plan, 'line_items', true);
			$totals = get_post_meta($sub_plan, 'invoice_totals', true);
		} elseif(!empty($sub_item_type) && $sub_item_type == 'line') { 
			$line_items = get_post_meta($sub_id, 'line_items', true);
			$totals = get_post_meta($sub_id, 'invoice_totals', true);		
		}
		update_post_meta($invoice_pid, 'line_items', $line_items);
		update_post_meta($invoice_pid, 'invoice_totals', $totals);	
		$currency = get_option('currency_symbol');
		$currency_code = get_option('currency_code');
		$currency_position = get_option('currency_symbol_position');
		$currency_space = get_option('currency_symbol_space'); 
		$client_currency = get_post_meta($subscription_client, 'currency_symbol', true);
		$client_currency_code = get_post_meta($subscription_client, 'currency_code', true);
		$client_currency_space = get_post_meta($subscription_client, 'currency_space', true);		
		$client_currency_position = get_post_meta($subscription_client, 'currency_position', true);
		$quote_currency = get_post_meta($sub_id, 'currency_symbol', true);
		$quote_currency_code = get_post_meta($sub_id, 'currency_code', true);
		$quote_currency_space = get_post_meta($sub_id, 'currency_space', true);
		$quote_currency_position = get_post_meta($sub_id, 'currency_position', true);
		if(!empty($quote_currency)) {
			update_post_meta($invoice_pid, 'currency_symbol', $quote_currency);
		} else {
			if(!empty($client_currency)) {
				update_post_meta($invoice_pid, 'currency_symbol', $client_currency);
			} else {
				update_post_meta($invoice_pid, 'currency_symbol', $currency);
			}
		}
		if(!empty($quote_currency_code)) {
			update_post_meta($invoice_pid, 'currency_code', $quote_currency_code);
		} else {
			if(!empty($client_currency_code)) {
				update_post_meta($invoice_pid, 'currency_code', $client_currency_code);
			} else {
				update_post_meta($invoice_pid, 'currency_code', $currency_code);
			}
		}
		if(!empty($quote_currency_space)) {
			update_post_meta($invoice_pid, 'currency_space', $quote_currency_space);
		} else {
			if(!empty($client_currency_space)) {
				update_post_meta($invoice_pid, 'currency_space', $client_currency_space);
			} else {
				update_post_meta($invoice_pid, 'currency_space', $currency_space);
			}
		}
		if(!empty($quote_currency_position)) {
			update_post_meta($invoice_pid, 'currency_position', $quote_currency_position);
		} else {
			if(!empty($client_currency_position)) {
				update_post_meta($invoice_pid, 'currency_position', $client_currency_position);
			} else {
				update_post_meta($invoice_pid, 'currency_position', $currency_position);
			}
		}
		$tax_app = get_post_meta($invoice_pid, 'tax_set', true);
		if(empty($tax_app)) {
			$client_details = get_post_meta($subscription_client, 'client_details', true);
			$client_tax = isset($client_details['tax_disabled']) ? $client_details['tax_disabled'] : '';
			$client_stax = isset($client_details['stax_disabled']) ? $client_details['stax_disabled'] : '';
			$system_tax = get_option('sales_tax_rate');
			$system_stax = get_option('secondary_sales_tax_rate');
			if(!empty($system_tax) && empty($client_tax)) {
				update_post_meta($invoice_pid, 'tax_applicable', 1);
				update_post_meta($invoice_pid, 'tax_set', 1);	
				update_post_meta($invoice_pid, 'tax_rate', $system_tax);	
				if(!empty($system_stax) && empty($client_stax)) {
					update_post_meta($invoice_pid, 'stax_applicable', 1);
					update_post_meta($invoice_pid, 'stax_set', 1);	
					update_post_meta($invoice_pid, 'stax_rate', $system_stax);			
				} else {
					update_post_meta($invoice_pid, 'stax_applicable', 0);
					update_post_meta($invoice_pid, 'stax_set', 1);
					update_post_meta($invoice_pid, 'stax_rate', 0);				
				}
			} else {
				update_post_meta($invoice_pid, 'tax_applicable', 0);
				update_post_meta($invoice_pid, 'tax_set', 1);
				update_post_meta($invoice_pid, 'tax_rate', 0);			
			}
		}
		return $invoice_pid;
	} else {
		return;
	}
}
function pto_check_subscriptions() {
	pto_process_subscription_reminders();
	$args = array(
		'post_type' => 'cqpim_subscription',
		'posts_per_page' => -1,
		'post_status' => 'private'
	);
	$subscriptions = get_posts($args);
	foreach($subscriptions as $subscription) {	
		$subscription_start = get_post_meta($subscription->ID, 'subscription_start', true);
		$subscription_gateway = get_post_meta($subscription->ID, 'subscription_gateway', true);
		$subscription_end = get_post_meta($subscription->ID, 'subscription_end', true);
		$next_charge = get_post_meta($subscription->ID, 'next_charge', true);
		$subscription_end = $subscription_end?$subscription_end:0;
		$now = current_time('timestamp');
		if(!empty($next_charge) && $next_charge < $now) {
			if($subscription_gateway == 'stripe') { 
				echo pto_process_stripe_payment($subscription->ID);
			} elseif($subscription_gateway == 'paypal') {
				echo pto_process_paypal_payment($subscription->ID);
			} elseif($subscription_gateway == '2checkout') {
				echo pto_process_2checkout_payment($subscription->ID);
			}	
		}	
		if(!empty($subscription_end) && $subscription_end < $now) {
			update_post_meta($subscription->ID, 'subscription_status', 'expired');
			update_post_meta($subscription->ID, 'next_charge', '');
			update_post_meta($subscription->ID, 'activated', '');
			update_post_meta($subscription->ID, 'activated_info', '');
			update_post_meta($subscription->ID, 'cancelled', '');
			update_post_meta($subscription->ID, 'cancelled_info', '');
			update_post_meta($subscription->ID, 'sent', '');
			update_post_meta($subscription->ID, 'sent_info', '');
		}	
	}
	return;	
}
function pto_process_subscription_reminders() {
	$args = array(
		'post_type' => 'cqpim_subscription',
		'posts_per_page' => -1,
		'post_status' => 'private'
	);
	$subscriptions = get_posts($args);
	foreach($subscriptions as $subscription) {
		$subscription_status = get_post_meta($subscription->ID, 'subscription_status', true);
		if(!empty($subscription_status) && $subscription_status == 'active') {
			$next_charge = get_post_meta($subscription->ID, 'next_charge', true);
			$reminder_1 = get_post_meta($subscription->ID, 'subscription_reminder_1', true);
			$reminder_2 = get_post_meta($subscription->ID, 'subscription_reminder_2', true);
			$next_charge_fm = date('Y-m-d', $next_charge);
			$current_time = current_time('timestamp');
			if(!empty($reminder_1)) {
				$reminder_1_date = strtotime('-' . $reminder_1 . ' days', $next_charge_fm);
				$reminder_1_sent = get_post_meta($subscription->ID, 'rem_1_sent', true);
				if(empty($reminder_1_sent) && $reminder_1_date < $current_time) {
					pto_send_sub_reminder($subscription->ID, 1);
					update_post_meta($subscription->ID, 'rem_1_sent', true);
				}
			}
			if(!empty($reminder_2)) {
				$reminder_2_date = strtotime('-' . $reminder_2 . ' days', $next_charge_fm);
				$reminder_2_sent = get_post_meta($subscription->ID, 'rem_2_sent', true);
				if(empty($reminder_2_sent) && $reminder_2_date < $current_time) {
					pto_send_sub_reminder($subscription->ID, 2);
					update_post_meta($subscription->ID, 'rem_2_sent', true);
				}
			}
		}
	}
	return;
}
function pto_send_sub_reminder($sub_id, $reminder) {
	$subscription = get_post($sub_id);
	$to = array();
	$subscription_client = get_post_meta($sub_id, 'subscription_client', true);
	$subscription_client_contact = get_post_meta($sub_id, 'subscription_client_contact', true);
	$client_contacts = get_post_meta($subscription_client, 'client_contacts', true);
	$client_details = get_post_meta($subscription_client, 'client_details', true);
	$client_main_id = isset($client_details['user_id']) ? $client_details['user_id'] : '';
	if($reminder == 1) {
		$reminder_days = get_post_meta($subscription->ID, 'subscription_reminder_1', true);		
	} else {
		$reminder_days = get_post_meta($subscription->ID, 'subscription_reminder_2', true);		
	}
	if(empty($client_contacts)) {
		$client_contacts = array();
	}
	if(!empty($subscription_client_contact)) {
		if($subscription_client_contact == $client_main_id) {
			$to[] = array(
				'mail' => $client_details['client_email'],
				'name' => isset($client_details['client_contact']) ? $client_details['client_contact'] : '',
			);
		} else {
			$to[] = array(
				'mail' => $client_contacts[$subscription_client_contact]['email'],
				'name' => isset($client_contacts[$subscription_client_contact]['name']) ? $client_contacts[$subscription_client_contact]['name'] : '',
			);
		}
	} else {
		$to[] = array(
			'mail' => $client_details['client_email'],
			'name' => isset($client_details['client_contact']) ? $client_details['client_contact'] : '',
		);
	}
	foreach($to as $address) {
		$subject = get_option('cqpim_subscription_reminder_subject');
		$content = get_option('cqpim_subscription_reminder_content');
		$content = str_replace('%%CLIENT_NAME%%', $address['name'], $content);
		$content = str_replace('%%DAYS%%', $reminder_days, $content);
		$subject = pto_replacement_patterns($subject, $subscription->ID, 'subscription');
		$content = pto_replacement_patterns($content, $subscription->ID, 'subscription');
		pto_send_emails($address['mail'], $subject, $content, '', '', 'sales');
	}
	return;
}
add_action( "wp_ajax_nopriv_pto_create_sub_from_cd", "pto_create_sub_from_cd");
add_action( "wp_ajax_pto_create_sub_from_cd", "pto_create_sub_from_cd");
function pto_create_sub_from_cd() {
	$plan = isset($_POST['id']) ? $_POST['id'] : '';
	$post = get_post($plan);
	$user = wp_get_current_user();
	$client = pto_get_client_from_userid($user);
	$subscription_frequency = get_post_meta($post->ID, 'subscription_frequency', true);
	$subscription_gateway = get_post_meta($post->ID, 'subscription_gateway', true);
	$sub_id = pto_get_subscription_id();
	$new_sub = array(
		'post_type' => 'cqpim_subscription',
		'post_status' => 'private',
		'post_title' => $sub_id,
	);
	$sub_pid = wp_insert_post( $new_sub, true );
	if( ! is_wp_error( $sub_pid ) ){
		update_post_meta($sub_pid, 'subscription_id', $sub_id);
		update_post_meta($sub_pid, 'subscription_date', current_time('timestamp'));
		update_post_meta($sub_pid, 'subscription_gateway', $subscription_gateway);
		update_post_meta($sub_pid, 'subscription_client', $client['assigned']);
		update_post_meta($sub_pid, 'subscription_client_contact', $user->ID);
		update_post_meta($sub_pid, 'subscription_frequency', $subscription_frequency);
		update_post_meta($sub_pid, 'subscription_start', '');
		update_post_meta($sub_pid, 'subscription_end', '');
		update_post_meta($sub_pid, 'subscription_invoice', 1);
		update_post_meta($sub_pid, 'subscription_status', 'sent');
		update_post_meta($sub_pid, 'subscription_reminder_1', '');
		update_post_meta($sub_pid, 'subscription_reminder_2', '');
		update_post_meta($sub_pid, 'sub_item_type', 'plan');
		update_post_meta($sub_pid, 'sub_plan', $post->ID);
		$currency = get_option('currency_symbol');
		$currency_code = get_option('currency_code');
		$currency_position = get_option('currency_symbol_position');
		$currency_space = get_option('currency_symbol_space'); 
		$client_currency = get_post_meta($client['assigned'], 'currency_symbol', true);
		$client_currency_code = get_post_meta($client['assigned'], 'currency_code', true);
		$client_currency_space = get_post_meta($client['assigned'], 'currency_space', true);		
		$client_currency_position = get_post_meta($client['assigned'], 'currency_position', true);
		$quote_currency = isset($_POST['currency_symbol']) ? $_POST['currency_symbol'] : '';
		$quote_currency_code = isset($_POST['currency_code']) ? $_POST['currency_code'] : '';
		$quote_currency_space = isset($_POST['currency_space']) ? $_POST['currency_space'] : '';
		$quote_currency_position = isset($_POST['currency_position']) ? $_POST['currency_position'] : '';
		if(!empty($quote_currency)) {
			update_post_meta($sub_pid, 'currency_symbol', $quote_currency);
		} else {
			if(!empty($client_currency)) {
				update_post_meta($sub_pid, 'currency_symbol', $client_currency);
			} else {
				update_post_meta($sub_pid, 'currency_symbol', $currency);
			}
		}
		if(!empty($quote_currency_code)) {
			update_post_meta($sub_pid, 'currency_code', $quote_currency_code);
		} else {
			if(!empty($client_currency_code)) {
				update_post_meta($sub_pid, 'currency_code', $client_currency_code);
			} else {
				update_post_meta($sub_pid, 'currency_code', $currency_code);
			}
		}
		if(!empty($quote_currency_space)) {
			update_post_meta($sub_pid, 'currency_space', $quote_currency_space);
		} else {
			if(!empty($client_currency_space)) {
				update_post_meta($sub_pid, 'currency_space', $client_currency_space);
			} else {
				update_post_meta($sub_pid, 'currency_space', $currency_space);
			}
		}
		if(!empty($quote_currency_position)) {
			update_post_meta($sub_pid, 'currency_position', $quote_currency_position);
		} else {
			if(!empty($client_currency_position)) {
				update_post_meta($sub_pid, 'currency_position', $client_currency_position);
			} else {
				update_post_meta($sub_pid, 'currency_position', $currency_position);
			}
		}
		$tax_app = get_post_meta($sub_pid, 'tax_set', true);
		if(empty($tax_app)) {
			$client_details = get_post_meta($client['assigned'], 'client_details', true);
			$client_tax = isset($client_details['tax_disabled']) ? $client_details['tax_disabled'] : '';
			$client_stax = isset($client_details['stax_disabled']) ? $client_details['stax_disabled'] : '';
			$system_tax = get_option('sales_tax_rate');
			$system_stax = get_option('secondary_sales_tax_rate');
			if(!empty($system_tax) && empty($client_tax)) {
				update_post_meta($sub_pid, 'tax_applicable', 1);
				update_post_meta($sub_pid, 'tax_set', 1);	
				update_post_meta($sub_pid, 'tax_rate', $system_tax);	
				if(!empty($system_stax) && empty($client_stax)) {
					update_post_meta($sub_pid, 'stax_applicable', 1);
					update_post_meta($sub_pid, 'stax_set', 1);	
					update_post_meta($sub_pid, 'stax_rate', $system_stax);			
				} else {
					update_post_meta($sub_pid, 'stax_applicable', 0);
					update_post_meta($sub_pid, 'stax_set', 1);
					update_post_meta($sub_pid, 'stax_rate', 0);				
				}
			} else {
				update_post_meta($sub_pid, 'tax_applicable', 0);
				update_post_meta($sub_pid, 'tax_set', 1);
				update_post_meta($sub_pid, 'tax_rate', 0);			
			}
		}
	}
	$return =  array( 
		'error' 	=> false,
		'redirect' 	=> get_the_permalink($sub_pid)
	);
	header('Content-type: application/json');
	echo json_encode($return);	
	exit();	
}