<?php
function pto_return_paypal_activate($post) { ?>
	<a href="#" id="pp-ajax-start" data-id="<?php echo $post; ?>"><img src="<?php echo PTO_PLUGIN_URL . '/img/ec-button.png'; ?>" /></a>
<?php }
function pto_return_paypal_update($post) { ?>
	<a href="#" id="pp-ajax-start" data-id="<?php echo $post; ?>"><img src="<?php echo PTO_PLUGIN_URL . '/img/ec-button.png'; ?>" /></a>
<?php }
add_action('wp_ajax_npriv_pto_process_paypal_redirect', 'pto_process_paypal_redirect');
add_action('wp_ajax_pto_process_paypal_redirect', 'pto_process_paypal_redirect');
function pto_process_paypal_redirect($post) {
	$post = isset($_POST['post_id']) ? $_POST['post_id'] : '';
	$post = get_post($post);
	require_once(PTO_SUBSCRIPTIONS_PATH . '/apis/paypal/config.php');
	require_once(PTO_SUBSCRIPTIONS_PATH . '/apis/paypal/autoload.php');
	$PayPalConfig = pto_return_pp_settings();	
	$PayPal = new angelleye\PayPal\PayPal($PayPalConfig);	
	$SECFields = array(
		'returnurl' => get_the_permalink($post->ID), 
		'cancelurl' => get_the_permalink($post->ID), 
	);
	$BillingAgreements = array();
	$Item = array(
		'l_billingtype' => 'MerchantInitiatedBillingSingleAgreement',
		'l_billingagreementdescription' => __('Subscription', 'cqpim-subscriptions') . ': ' . $post->post_title, 			 
		'l_paymenttype' => '', 							
		'l_billingagreementcustom' => ''					
	);
	array_push($BillingAgreements, $Item);
	$PayPalRequestData = array(
		'SECFields' => $SECFields,
		'BillingAgreements' => $BillingAgreements
	);
	$PayPalResult = $PayPal->SetExpressCheckout($PayPalRequestData);
	if($PayPalResult['ACK'] == 'failure' || $PayPalResult['ACK'] == 'Failure') {
		$return =  array( 
			'error' 	=> true,
			'message' 	=> $PayPalResult['L_LONGMESSAGE0']
		);
		header('Content-type: application/json');
		echo json_encode($return);	
		exit();			
	}
	$return =  array( 
		'error' 	=> false,
		'redirect' 	=> $PayPalResult['REDIRECTURL']
	);
	header('Content-type: application/json');
	echo json_encode($return);	
	exit();
}
function pto_process_paypal_return($post, $data) {
	$user = wp_get_current_user();
	$post = get_post($post);
	require_once(PTO_SUBSCRIPTIONS_PATH . '/apis/paypal/config.php');
	require_once(PTO_SUBSCRIPTIONS_PATH . '/apis/paypal/autoload.php');
	$PayPalConfig = pto_return_pp_settings();	
	$PayPal = new angelleye\PayPal\PayPal($PayPalConfig);
	$PayPalResult = $PayPal->CreateBillingAgreement($data);
	if(empty($PayPalResult['BILLINGAGREEMENTID'])) {	
		echo '<div class="cqpim-alert cqpim-alert-danger alert-display">' . __('We could not activate this subscription because we could not get a Billing ID from PayPal, please try again', 'cqpim-subscriptions') . '</div>';
		return;	
	}
	update_post_meta($post->ID, 'paypal_billing_id', $PayPalResult['BILLINGAGREEMENTID']);
	$subscription_start = get_post_meta($post->ID, 'subscription_start', true);
	$subscription_frequency = get_post_meta($post->ID, 'subscription_frequency', true);
	$frequency = pto_return_frequency_readable($subscription_frequency);
	$sub_item_type = get_post_meta($post->ID, 'sub_item_type', true); 
	$sub_plan = get_post_meta($post->ID, 'sub_plan', true);
	$next_charge = get_post_meta($post->ID, 'next_charge', true);
	if(!empty($sub_item_type) && $sub_item_type == 'plan') { 
		$totals = get_post_meta($sub_plan, 'invoice_totals', true);
		$total = isset($totals['total']) ? $totals['total'] : 0;
	} elseif(!empty($sub_item_type) && $sub_item_type == 'line') {
		$totals = get_post_meta($post->ID, 'invoice_totals', true);
		$total = isset($totals['total']) ? $totals['total'] : 0;		
	}
	$now = current_time('timestamp');
	if(empty($subscription_start) && empty($next_charge) || !empty($subscription_start) && $now > $subscription_start && empty($next_charge)) {		
		require_once(PTO_SUBSCRIPTIONS_PATH . '/apis/paypal/config.php');
		require_once(PTO_SUBSCRIPTIONS_PATH . '/apis/paypal/autoload.php');
		$PayPalConfig = pto_return_pp_settings();	
		$PayPal = new angelleye\PayPal\PayPal($PayPalConfig);
		$DRTFields = array(
			'referenceid' => get_post_meta($post->ID, 'paypal_billing_id', true),
			'paymentaction' => 'Sale',
			'paymenttype' => 'Any',
		);
		$OrderItems = array();
		$Item = array(
			'l_name' => __('Subscription', 'cqpim-subscriptions') . ': ' . $post->post_title,
			'l_description' => '',
			'l_amt' => $total,
			'l_qty' => 1,
		);						
		array_push($OrderItems, $Item);
		$PaymentDetails = array(
			'amt' => $total,
			'currencycode' => get_post_meta($post->ID, 'currency_code', true),
			'recurring' => 'Y'
		);
		$PayPalRequestData = array(
			'DRTFields' => $DRTFields, 
			'PaymentDetails' => $PaymentDetails,
			'OrderItems' => $OrderItems, 
		);
		$PayPalResult = $PayPal->DoReferenceTransaction($PayPalRequestData);	
		if($PayPalResult['PAYMENTSTATUS'] != 'Completed') {
			$payment_error = true;
			echo '<div class="cqpim-alert cqpim-alert-danger alert-display">' . __('Your payment didn\'t go through. Please try again', 'cqpim-subscriptions') . '</div>';
			return;
		} else {
			$args = array(
				'post_type' => 'cqpim_teams',
				'posts_per_page' => -1,
				'post_status' => 'private'
			);
			$teams = get_posts($args);			
			foreach($teams as $team) {
				$team_details = get_post_meta($team->ID, 'team_details', true);
				$user_id = isset($team_details['user_id']) ? $team_details['user_id'] : '';
				if(!empty($user_id)) {
					$user_obj = get_user_by('id', $user_id);
					if(user_can($user_obj, 'edit_cqpim_subscriptions')) {
						pto_add_team_notification($team->ID, $user->ID, $post->ID, 'subscription_activated');
					}
				}
			}
			$payment_processed = true;
			update_post_meta($post->ID, 'last_charge', current_time('timestamp'));
			update_post_meta($post->ID, 'last_amount', $total);
			update_post_meta($post->ID, 'next_charge', pto_calculate_next_charge($post->ID));
			update_post_meta($post->ID, 'rem_1_sent', true);
			update_post_meta($post->ID, 'rem_2_sent', true);
		}
	} elseif(empty($next_charge)) {
		echo '<div class="cqpim-alert cqpim-alert-success alert-display">' . sprintf(__('Your billing agreement has been saved to PayPal. You will be charged %1$s from %2$s', 'cqpim-subscriptions'), $frequency, date(get_option('cqpim_date_format'), $subscription_start)) . '</div>';
		update_post_meta($post->ID, 'next_charge', $subscription_start);
	}
	$activated = get_post_meta($post->ID, 'activated', true);
	if(empty($activated)) {
		$user = wp_get_current_user();
		update_post_meta($post->ID, 'cancelled', '');
		update_post_meta($post->ID, 'cancelled_info', '');
		update_post_meta($post->ID, 'activated', true);
		update_post_meta($post->ID, 'activated_info', array('by' => $user->ID, 'on' => current_time('timestamp')));
		update_post_meta($post->ID, 'subscription_status', 'active');
		pto_send_activation_mail($post->ID);
		$subscription_invoice = get_post_meta($post->ID, 'subscription_invoice', true);
		if(!empty($subscription_invoice) && $payment_processed == true) {
			$invoice_pid = pto_create_sub_invoice($post->ID);
			pto_mark_invoice_paid($invoice_pid, 'PayPal', $total);
			$auto_invoice = get_option('auto_send_invoices');
			if($auto_invoice) {
				pto_process_invoice_emails($invoice_pid);
			}	
		}
	}
	return;
}
function pto_return_pp_settings() {
	$PayPalConfig = array(
		'Sandbox' => false,
		'DeveloperAccountEmail' => false,
		'ApplicationID' => false,
		'DeviceID' => false,
		'IPAddress' => $_SERVER['REMOTE_ADDR'],
		'APIUsername' => get_option('cqpim_paypal_api_username'),
		'APIPassword' => get_option('cqpim_paypal_api_password'),
		'APISignature' => get_option('cqpim_paypal_api_signature'),
		'APISubject' => get_option('client_invoice_paypal_address'), 
		'PrintHeaders' => true,
		'LogResults' => false, 
		'LogPath' => false,
	);
	return $PayPalConfig;
}
function pto_process_paypal_payment($post) {
	$post = get_post($post);
	$user = get_post_meta($post->ID, 'subscription_client_contact', true);
	$user = get_user_by('id', $user);
	$client_id = pto_get_client_from_userid($user);
	$subscription_start = get_post_meta($post->ID, 'subscription_start', true);
	$subscription_gateway = get_post_meta($post->ID, 'subscription_gateway', true);
	$subscription_end = get_post_meta($post->ID, 'subscription_end', true);
	$subscription_frequency = get_post_meta($post->ID, 'subscription_frequency', true);
	$frequency = pto_return_frequency_readable($subscription_frequency);
	$sub_item_type = get_post_meta($post->ID, 'sub_item_type', true);
	$sub_plan = get_post_meta($post->ID, 'sub_plan', true);
	$next_charge = get_post_meta($post->ID, 'next_charge', true);
	if(!empty($sub_item_type) && $sub_item_type == 'plan') { 
		$totals = get_post_meta($sub_plan, 'invoice_totals', true);
		$total = isset($totals['total']) ? $totals['total'] : 0;
	} elseif(!empty($sub_item_type) && $sub_item_type == 'line') {
		$totals = get_post_meta($post->ID, 'invoice_totals', true);
		$total = isset($totals['total']) ? $totals['total'] : 0;		
	}
	require_once(PTO_SUBSCRIPTIONS_PATH . '/apis/paypal/config.php');
	require_once(PTO_SUBSCRIPTIONS_PATH . '/apis/paypal/autoload.php');
	$PayPalConfig = pto_return_pp_settings();	
	$PayPal = new angelleye\PayPal\PayPal($PayPalConfig);
	$DRTFields = array(
		'referenceid' => get_post_meta($post->ID, 'paypal_billing_id', true),
		'paymentaction' => 'Sale',
		'paymenttype' => 'Any',
	);
	$OrderItems = array();
	$Item = array(
		'l_name' => __('Subscription', 'cqpim-subscriptions') . ': ' . $post->post_title,
		'l_description' => '',
		'l_amt' => $total,
		'l_qty' => 1,
	);						
	array_push($OrderItems, $Item);
	$PaymentDetails = array(
		'amt' => $total,
		'currencycode' => get_post_meta($post->ID, 'currency_code', true),
		'recurring' => 'Y'
	);
	$PayPalRequestData = array(
		'DRTFields' => $DRTFields, 
		'PaymentDetails' => $PaymentDetails,
		'OrderItems' => $OrderItems, 
	);
	$PayPalResult = $PayPal->DoReferenceTransaction($PayPalRequestData);	
	if($PayPalResult['PAYMENTSTATUS'] != 'Completed') {
		$args = array(
			'post_type' => 'cqpim_teams',
			'posts_per_page' => -1,
			'post_status' => 'private'
		);
		$teams = get_posts($args);			
		foreach($teams as $team) {
			$team_details = get_post_meta($team->ID, 'team_details', true);
			$user_id = isset($team_details['user_id']) ? $team_details['user_id'] : '';
			if(!empty($user_id)) {
				$user = get_user_by('id', $user_id);
				if(user_can($user, 'edit_cqpim_subscriptions')) {
					pto_add_team_notification($team->ID, 'system', $post->ID, 'subscription_failed');
				}
			}
		}
		$payment_error = true;
		update_post_meta($post->ID, 'subscription_status', 'late');
		pto_subs_send_failed_mail();
		pto_add_team_notification($client_id, 'system', $post->ID, 'subscription_failed');
	} else {
		$args = array(
			'post_type' => 'cqpim_teams',
			'posts_per_page' => -1,
			'post_status' => 'private'
		);
		$teams = get_posts($args);			
		foreach($teams as $team) {
			$team_details = get_post_meta($team->ID, 'team_details', true);
			$user_id = isset($team_details['user_id']) ? $team_details['user_id'] : '';
			if(!empty($user_id)) {
				$user = get_user_by('id', $user_id);
				if(user_can($user, 'edit_cqpim_subscriptions')) {
					pto_add_team_notification($team->ID, 'system', $post->ID, 'subscription_renewed');
				}
			}
		}
		$payment_processed = true;
		pto_add_team_notification($client_id, 'system', $post->ID, 'subscription_renewed');
		update_post_meta($post->ID, 'last_charge', current_time('timestamp'));
		update_post_meta($post->ID, 'last_amount', $total);
		update_post_meta($post->ID, 'next_charge', pto_calculate_next_charge($post->ID));
		update_post_meta($post->ID, 'rem_1_sent', false);
		update_post_meta($post->ID, 'rem_2_sent', false);
	}
	$subscription_invoice = get_post_meta($post->ID, 'subscription_invoice', true);
	if(!empty($subscription_invoice)) {
		$invoice_pid = pto_create_sub_invoice($post->ID);
		if(!empty($payment_processed)) {
			pto_mark_invoice_paid($invoice_pid, 'PayPal', $total);
		}
		$auto_invoice = get_option('auto_send_invoices');
		if($auto_invoice) {
			pto_process_invoice_emails($invoice_pid);
		}	
	}
	return;
}