<?php
function pto_plan_subs_metabox_callback( $post ) {
 	wp_nonce_field( 
	'plan_subs_metabox', 
	'plan_subs_metabox_nonce' ); 
	$args = array(
		'post_type' => 'cqpim_subscription',
		'posts_per_page' => -1,
		'post_status' => 'private',
		'meta_key' => 'sub_plan',
		'meta_value' => $post->ID
	);
	$subs = get_posts($args);
	if(empty($subs)) {
		echo '<div class="cqpim-alert cqpim-alert-info alert-display">';
			_e('There are no subscriptions using this plan.', 'cqpim-subscriptions');
		echo '</div>';
	} else { ?>
		<table class="dataTable datatable_style" data-ordering="false" data-rows="10">
			<thead>
				<tr>
					<td><?php _e('ID', 'cqpim-subscriptions'); ?></td>
					<td><?php _e('Title', 'cqpim-subscriptions'); ?></td>
					<td><?php _e('Client', 'cqpim-subscriptions'); ?></td>
					<td><?php _e('Status', 'cqpim-subscriptions'); ?></td>
				</tr>
			</thead>
			<tbody>
				<?php foreach($subs as $sub) { 
					$subscription_id = get_post_meta($sub->ID, 'subscription_id', true); 
					$subscription_status = get_post_meta($sub->ID, 'subscription_status', true); 
					$subscription_client = get_post_meta($sub->ID, 'subscription_client', true);
					$client_details = get_post_meta($subscription_client, 'client_details', true); 
					$client_name = isset($client_details['client_company']) ? $client_details['client_company'] : ''; ?>
					<tr>
						<td><span class="cqpim_mobile"><?php _e('ID', 'cqpim-subscriptions'); ?></span> <a href="<?php echo get_edit_post_link($sub->ID); ?>"><?php echo $subscription_id; ?></a></td>
						<td><span class="cqpim_mobile"><?php _e('Title', 'cqpim-subscriptions'); ?></span> <a href="<?php echo get_edit_post_link($sub->ID); ?>"><?php echo $sub->post_title; ?></a></td>
						<td><span class="cqpim_mobile"><?php _e('Client', 'cqpim-subscriptions'); ?></span> <a href="<?php echo get_edit_post_link($subscription_client); ?>"><?php echo $client_name; ?></a></td>
						<td><span class="cqpim_mobile"><?php _e('Status', 'cqpim-subscriptions'); ?></span> <?php echo pto_return_subscription_status($subscription_status); ?></td>
					</tr>
				<?php } ?>				
			</tbody>
		</table>
	<?php }
}
add_action( 'save_post', 'save_pto_plan_subs_metabox_data' );
function save_pto_plan_subs_metabox_data( $post_id ){
	if ( ! isset( $_POST['plan_subs_metabox_nonce'] ) )
	    return $post_id;
	$nonce = $_POST['plan_subs_metabox_nonce'];
	if ( ! wp_verify_nonce( $nonce, 'plan_subs_metabox' ) )
	    return $post_id;
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
	    return $post_id;
	if ( 'page' == $_POST['post_type'] ) {
	    if ( ! current_user_can( 'edit_page', $post_id ) )
	        return $post_id;
	  	} else {
	    if ( ! current_user_can( 'edit_post', $post_id ) )
	        return $post_id;
	}
}