<?php
function pto_subscription_details_metabox_callback( $post ) {
 	wp_nonce_field( 
 	 	'subscription_details_metabox', 
 	 	'subscription_details_metabox_nonce' ); 
		$subscription_id = get_post_meta($post->ID, 'subscription_id', true);
		$subscription_date = get_post_meta($post->ID, 'subscription_date', true);
		$subscription_gateway = get_post_meta($post->ID, 'subscription_gateway', true);
		$subscription_client = get_post_meta($post->ID, 'subscription_client', true);
		$subscription_client_contact = get_post_meta($post->ID, 'subscription_client_contact', true);
		$subscription_frequency = get_post_meta($post->ID, 'subscription_frequency', true);
		$subscription_start = get_post_meta($post->ID, 'subscription_start', true);
		$subscription_end = get_post_meta($post->ID, 'subscription_end', true);
		$subscription_invoice = get_post_meta($post->ID, 'subscription_invoice', true);
		$subscription_status = get_post_meta($post->ID, 'subscription_status', true);
		$reminder_1 = get_post_meta($post->ID, 'subscription_reminder_1', true);
		$reminder_2 = get_post_meta($post->ID, 'subscription_reminder_2', true);
		$activated = get_post_meta($post->ID, 'activated', true);
		if($activated == true) { $disabled = 'disabled="disabled"'; } else { $disabled = ''; }
		if(!$subscription_date) {
			$subscription_date = date(get_option('cqpim_date_format'));
		}
		if(!empty($subscription_id)) {
			echo '<p>' . __('Subscription ID:', 'cqpim-subscriptions') . ' </p>';
			echo '<input type="text" name="subscription_id" id="subscription_id" value="' . $subscription_id . '" required ' . $disabled . ' />';	
		} else {
			$subscription_id = pto_get_subscription_id();
			echo '<p>' . __('Subscription ID:', 'cqpim-subscriptions') . ' </p>';
			echo '<input type="text" name="subscription_id" id="subscription_id" value="' . $subscription_id . '" required ' . $disabled . ' />';
		}
		echo '<p>' . __('Creation Date:', 'cqpim-subscriptions') . ' </p>';
		if(is_numeric($subscription_date)) { $subscription_date = date(get_option('cqpim_date_format'), $subscription_date); } else { $subscription_date = $subscription_date; }
		echo '<input type="text" name="subscription_date" id="subscription_date" value="' . $subscription_date . '" disabled />';
		$args = array(
			'post_type' => 'cqpim_client',
			'posts_per_page' => -1,
			'post_status' => 'private',
		);
		$clients = get_posts($args);
		echo '<p>' . __('Client:', 'cqpim-subscriptions') . '</p>';
		echo '<select id="subscription_client" name="subscription_client" required ' . $disabled . ' >';
		echo '<option value="">' . __('Select a Client:', 'cqpim-subscriptions') . '</option>';
		foreach($clients as $client) {
			$selected = '';
			$client_details = get_post_meta($client->ID, 'client_details', true);
			if($client->ID == $subscription_client) {
				$selected = 'selected';
			}
			echo '<option value="' . $client->ID . '" ' . $selected . '>' . $client_details['client_company'] . '</option>';
		}
		echo '</select>';
		$client_details = get_post_meta($subscription_client, 'client_details', true);
		$client_contacts = get_post_meta($subscription_client, 'client_contacts', true);
		if(!empty($subscription_client)) { ?>
			<select style="border-top:0" name="subscription_client_contact" id="subscription_client_contact" <?php echo $disabled; ?> >
				<option value=""><?php _e('Select a Contact', 'cqpim-subscriptions'); ?></option>
				<option value="<?php echo $client_details['user_id']; ?>" <?php selected($subscription_client_contact, $client_details['user_id']); ?>><?php echo $client_details['client_contact']; ?> <?php _e('(Main Contact)', 'cqpim-subscriptions'); ?></option>
				<?php
				if(!empty($client_contacts)) {
					foreach($client_contacts as $contact) { ?>
						<option value="<?php echo $contact['user_id']; ?>" <?php selected($subscription_client_contact == $contact['user_id']); ?>><?php echo $contact['name']; ?></option>							
					<?php }
				}
				?>
			</select>					
		<?php } else { ?>
			<select style="border-top:0" name="subscription_client_contact" id="subscription_client_contact" disabled >
				<option value=""><?php _e('Select a Contact', 'cqpim-subscriptions'); ?></option>
			</select>
		<?php }		
		echo '<p>' . __('Payment Gateway:', 'cqpim-subscriptions') . ' </p>';
		$gateways = pto_check_gateway_config();
		if(!empty($gateways)) {
			echo '<select name="subscription_gateway" id="subscription_gateway" required ' . $disabled . ' >';
				echo '<option value="">' . __('Choose a gateway...', 'cqpim-subscriptions') . '</option>';
				foreach($gateways as $gateway) {
					echo '<option value="' . $gateway['id'] . '" ' . selected($gateway['id'], $subscription_gateway) . '>' . $gateway['name'] . '</option>';
				}
			echo '</select>';
		} else {
			echo '<div class="cqpim-alert cqpim-alert-warning alert-display">';
				_e('You do not have any Payment Gateways configured for subscriptions. Set one up in the plugin settings.', 'cqpim-subscriptions');
			echo '</div>';				
		} ?>
		<p><?php _e('Billing Frequency:', 'cqpim-subscriptions'); ?></p>
		<select id="subscription_frequency" name="subscription_frequency" required <?php echo $disabled; ?>>
			<option value="" <?php selected($subscription_frequency, 0); ?>><?php _e('Select a frequency', 'cqpim-subscriptions'); ?></option>
			<option value="day" <?php selected($subscription_frequency, 'day'); ?>><?php _e('Daily', 'cqpim-subscriptions'); ?></option>
			<option value="week" <?php selected($subscription_frequency, 'week'); ?>><?php _e('Weekly', 'cqpim-subscriptions'); ?></option>
			<option value="biweek" <?php selected($subscription_frequency, 'biweek'); ?>><?php _e('Every Two Weeks', 'cqpim-subscriptions'); ?></option>
			<option value="month" <?php selected($subscription_frequency, 'month'); ?>><?php _e('Monthly', 'cqpim-subscriptions'); ?></option>
			<option value="bimonth" <?php selected($subscription_frequency, 'bimonth'); ?>><?php _e('Every Two Months', 'cqpim-subscriptions'); ?></option>
			<option value="trimonth" <?php selected($subscription_frequency, 'trimonth'); ?>><?php _e('Every Three Months', 'cqpim-subscriptions'); ?></option>
			<option value="sixmonth" <?php selected($subscription_frequency, 'sixmonth'); ?>><?php _e('Every 6 Months', 'cqpim-subscriptions'); ?></option>
			<option value="year" <?php selected($subscription_frequency, 'year'); ?>><?php _e('Yearly', 'cqpim-subscriptions'); ?></option>
			<option value="biyear" <?php selected($subscription_frequency, 'biyear'); ?>><?php _e('Every Two Years', 'cqpim-subscriptions'); ?></option>
		</select>
		<p><?php _e('Billing Start Date:', 'cqpim-subscriptions'); ?> <i class="fa fa-question-circle cqpim_tooltip" aria-hidden="true" title="<?php _e('Set a date to start billing, otherwise the client will be charged immediately when they activate the subscription.', 'cqpim-subscriptions'); ?>"></i></p>
		<?php if(is_numeric($subscription_start)) { $subscription_start = date(get_option('cqpim_date_format'), $subscription_start); } else { $subscription_start = $subscription_start; } ?>
		<input type="text" class="datepicker" name="subscription_start" id="subscription_start" value="<?php echo $subscription_start; ?>" <?php echo $disabled; ?> />
		<p><?php _e('Billing End Date:', 'cqpim-subscriptions'); ?> <i class="fa fa-question-circle cqpim_tooltip" aria-hidden="true" title="<?php _e('Leave blank to bill indefinitely', 'cqpim-subscriptions'); ?>"></i></p>
		<?php if(is_numeric($subscription_end)) { $subscription_end = date(get_option('cqpim_date_format'), $subscription_end); } else { $subscription_end = $subscription_end; } ?>
		<input type="text" class="datepicker" name="subscription_end" id="subscription_end" value="<?php echo $subscription_end; ?>" />
		<p><?php _e('First Reminder:', 'cqpim-subscriptions'); ?> <i class="fa fa-question-circle cqpim_tooltip" aria-hidden="true" title="<?php _e('Select how many days in advance to send a reminder that the subscription is due. Leave blank to disable this reminder', 'cqpim-subscriptions'); ?>"></i></p>
		<?php $days = range(2,90); ?>
		<select name="subscription_reminder_1">
			<option value=""><?php _e('Choose', 'cqpim-subscriptions'); ?></option>
			<option value="1" <?php selected(1, $reminder_1); ?>><?php _e('1 Day', 'cqpim-subscriptions'); ?></option>
			<?php foreach($days as $day) { ?>
				<option value="<?php echo $day; ?>" <?php selected($day, $reminder_1); ?>><?php printf(__('%1$s Days', 'cqpim-subscriptions'), $day); ?></option>
			<?php } ?>
		</select>
		<p><?php _e('Second Reminder:', 'cqpim-subscriptions'); ?> <i class="fa fa-question-circle cqpim_tooltip" aria-hidden="true" title="<?php _e('Select how many days in advance to send a reminder that the subscription is due. Leave blank to disable this reminder', 'cqpim-subscriptions'); ?>"></i></p>
		<select name="subscription_reminder_2">
			<option value=""><?php _e('Choose', 'cqpim-subscriptions'); ?></option>
			<option value="1" <?php selected(1, $reminder_2); ?>><?php _e('1 Day', 'cqpim-subscriptions'); ?></option>
			<?php foreach($days as $day) { ?>
				<option value="<?php echo $day; ?>" <?php selected($day, $reminder_2); ?>><?php printf(__('%1$s Days', 'cqpim-subscriptions'), $day); ?></option>
			<?php } ?>
		</select>
		<br /><br />
		<input type="checkbox" name="subscription_invoice" id="subscription_invoice" value="1" <?php checked($subscription_invoice, 1); ?> /> <?php _e('Generate an invoice for every charge.', 'cqpim-subscriptions'); ?>
		<br /><br />
		<?php if(current_user_can('publish_cqpim_subscriptions')) { ?>
			<a class="save cqpim_button cqpim_button_link font-white bg-blue rounded_2 block" href="#"><?php _e('Update Subscription', 'cqpim-subscriptions'); ?></a>
		<?php } ?>
		<?php if(current_user_can('delete_cqpim_subscriptions')) { ?>
			<a class="delete_plan cqpim_button cqpim_button_link font-white bg-red rounded_2 block mt-10" href="#"><?php _e('Delete Subscription', 'cqpim-subscriptions'); ?></a>
		<?php } ?>
		<div id="delete-plan-div-container" style="display:none">
			<div id="delete-plan-div">
				<div style="padding:12px">
					<h3><?php _e('Delete Subscription', 'cqpim-subscriptions'); ?></h3>
					<?php if(empty($subscription_status) || !empty($subscription_status) && $subscription_status != 'active') {
						echo '<p>' . __('Are you sure you want to delete this Subscription?', 'cqpim-subscriptions') . '</p>';
					} else {
						echo '<p>' . __('You cannot delete this Subscription, you must cancel it first.', 'cqpim-subscriptions') . '</p>';
					} ?>
					<a class="cancel-colorbox mt-10 cqpim_button font-red border-red op" href="#"><?php _e('Cancel', 'cqpim-subscriptions'); ?></a>
					<?php if(empty($subscription_status) || !empty($subscription_status) && $subscription_status != 'active') { ?>
						<button id="delete_task_confirm" data-id="<?php echo $post->ID; ?>" class="mt-10 cqpim_button font-green border-green right op"><?php _e('Delete Subscription', 'cqpim-subscriptions'); ?></button>
					<?php } ?>
				</div>
			</div>
		</div>		
<?php }
add_action( 'save_post', 'save_pto_subscription_details_metabox_data' );
function save_pto_subscription_details_metabox_data( $post_id ){
	if ( ! isset( $_POST['subscription_details_metabox_nonce'] ) )
	    return $post_id;
	$nonce = $_POST['subscription_details_metabox_nonce'];
	if ( ! wp_verify_nonce( $nonce, 'subscription_details_metabox' ) )
	    return $post_id;
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
	    return $post_id;
	if ( 'page' == $_POST['post_type'] ) {
	    if ( ! current_user_can( 'edit_page', $post_id ) )
	        return $post_id;
	  	} else {
	    if ( ! current_user_can( 'edit_post', $post_id ) )
	        return $post_id;
	}
	if(isset($_POST['subscription_id'])) {
		update_post_meta($post_id, 'subscription_id', $_POST['subscription_id']);
	}
	if(isset($_POST['subscription_date'])) {
		update_post_meta($post_id, 'subscription_date', $_POST['subscription_date']);
	}
	if(isset($_POST['subscription_gateway'])) {
		update_post_meta($post_id, 'subscription_gateway', $_POST['subscription_gateway']);
	}
	if(isset($_POST['subscription_client'])) {
		update_post_meta($post_id, 'subscription_client', $_POST['subscription_client']);
	}
	if(isset($_POST['subscription_client_contact'])) {
		update_post_meta($post_id, 'subscription_client_contact', $_POST['subscription_client_contact']);
	}
	if(isset($_POST['subscription_frequency'])) {
		update_post_meta($post_id, 'subscription_frequency', $_POST['subscription_frequency']);
	}
	if(isset($_POST['subscription_start'])) {
		$sub_start = pto_convert_date($_POST['subscription_start']);
		update_post_meta($post_id, 'subscription_start', $sub_start);
	}
	if(isset($_POST['subscription_end'])) {
		$sub_end = pto_convert_date($_POST['subscription_end']);
		update_post_meta($post_id, 'subscription_end', $sub_end);
	}
	if(!empty($_POST['subscription_invoice'])) {
		update_post_meta($post_id, 'subscription_invoice', $_POST['subscription_invoice']);
	} else {
		update_post_meta($post_id, 'subscription_invoice', 0);
	}
	if(isset($_POST['subscription_reminder_1'])) {
		update_post_meta($post_id, 'subscription_reminder_1', $_POST['subscription_reminder_1']);
	}
	if(isset($_POST['subscription_reminder_2'])) {
		update_post_meta($post_id, 'subscription_reminder_2', $_POST['subscription_reminder_2']);
	}
	$currency = get_option('currency_symbol');
	$currency_code = get_option('currency_code');
	$currency_position = get_option('currency_symbol_position');
	$currency_space = get_option('currency_symbol_space'); 
	$client_currency = get_post_meta($_POST['subscription_client'], 'currency_symbol', true);
	$client_currency_code = get_post_meta($_POST['subscription_client'], 'currency_code', true);
	$client_currency_space = get_post_meta($_POST['subscription_client'], 'currency_space', true);		
	$client_currency_position = get_post_meta($_POST['subscription_client'], 'currency_position', true);
	$quote_currency = isset($_POST['currency_symbol']) ? $_POST['currency_symbol'] : '';
	$quote_currency_code = isset($_POST['currency_code']) ? $_POST['currency_code'] : '';
	$quote_currency_space = isset($_POST['currency_space']) ? $_POST['currency_space'] : '';
	$quote_currency_position = isset($_POST['currency_position']) ? $_POST['currency_position'] : '';
	if(!empty($quote_currency)) {
		update_post_meta($post_id, 'currency_symbol', $quote_currency);
	} else {
		if(!empty($client_currency)) {
			update_post_meta($post_id, 'currency_symbol', $client_currency);
		} else {
			update_post_meta($post_id, 'currency_symbol', $currency);
		}
	}
	if(!empty($quote_currency_code)) {
		update_post_meta($post_id, 'currency_code', $quote_currency_code);
	} else {
		if(!empty($client_currency_code)) {
			update_post_meta($post_id, 'currency_code', $client_currency_code);
		} else {
			update_post_meta($post_id, 'currency_code', $currency_code);
		}
	}
	if(!empty($quote_currency_space)) {
		update_post_meta($post_id, 'currency_space', $quote_currency_space);
	} else {
		if(!empty($client_currency_space)) {
			update_post_meta($post_id, 'currency_space', $client_currency_space);
		} else {
			update_post_meta($post_id, 'currency_space', $currency_space);
		}
	}
	if(!empty($quote_currency_position)) {
		update_post_meta($post_id, 'currency_position', $quote_currency_position);
	} else {
		if(!empty($client_currency_position)) {
			update_post_meta($post_id, 'currency_position', $client_currency_position);
		} else {
			update_post_meta($post_id, 'currency_position', $currency_position);
		}
	}
	$tax_app = get_post_meta($post_id, 'tax_set', true);
	if(empty($tax_app)) {
		$client_details = get_post_meta($_POST['subscription_client'], 'client_details', true);
		$client_tax = isset($client_details['tax_disabled']) ? $client_details['tax_disabled'] : '';
		$client_stax = isset($client_details['stax_disabled']) ? $client_details['stax_disabled'] : '';
		$system_tax = get_option('sales_tax_rate');
		$system_stax = get_option('secondary_sales_tax_rate');
		if(!empty($system_tax) && empty($client_tax)) {
			update_post_meta($post_id, 'tax_applicable', 1);
			update_post_meta($post_id, 'tax_set', 1);	
			update_post_meta($post_id, 'tax_rate', $system_tax);	
			if(!empty($system_stax) && empty($client_stax)) {
				update_post_meta($post_id, 'stax_applicable', 1);
				update_post_meta($post_id, 'stax_set', 1);	
				update_post_meta($post_id, 'stax_rate', $system_stax);			
			} else {
				update_post_meta($post_id, 'stax_applicable', 0);
				update_post_meta($post_id, 'stax_set', 1);
				update_post_meta($post_id, 'stax_rate', 0);				
			}
		} else {
			update_post_meta($post_id, 'tax_applicable', 0);
			update_post_meta($post_id, 'tax_set', 1);
			update_post_meta($post_id, 'tax_rate', 0);			
		}
	}
}