<?php
function pto_subscription_invoices_metabox_callback( $post ) {
 	wp_nonce_field( 
 	 	'subscription_invoices_metabox', 
 	 	'subscription_invoices_metabox_nonce' ); 
		if(current_user_can('edit_cqpim_invoices')) {			
			$args = array(
				'post_type' => 'cqpim_invoice',
				'posts_per_page' => -1,
				'post_status' => 'publish',
				'orderby' => 'date',
				'order' => 'DESC',
				'meta_key' => 'subscription_id',
				'meta_value' => $post->ID
			);
			$invoices = get_posts($args);
			if(empty($invoices)) { 
				echo '<p>' . __('This subscription does not have any invoices.', 'cqpim-subscriptions') . '</p>';
			} else {
				echo '<br /><table class="datatable_style dataTable">';
				echo '<thead>';
				echo '<tr><th>' . __('Invoice ID', 'cqpim') . '</th><th>' . __('Owner', 'cqpim') . '</th><th>' . __('Invoice Date', 'cqpim') . '</th><th>' . __('Due Date', 'cqpim') . '</th><th>' . __('Amount', 'cqpim') . '</th><th>' . __('Status', 'cqpim') . '</th></tr>';
				echo '</thead>';
				echo '<tbody>';
				foreach($invoices as $invoice) {
					$invoice_id = get_post_meta($invoice->ID, 'invoice_id', true);
					$client_contact = get_post_meta($invoice->ID, 'client_contact', true);
					$owner = get_user_by('id', $client_contact);
					$invoice_details = get_post_meta($invoice->ID, 'invoice_details', true);
					$client_id = isset($invoice_details['client_id']) ? $invoice_details['client_id'] : '';
					$client_details = get_post_meta($client_id, 'client_details', true);
					$client_ids = get_post_meta($client_id, 'client_ids', true);
					$client_user_id = isset($client_details['user_id']) ? $client_details['user_id'] : '';
					$invoice_totals = get_post_meta($invoice->ID, 'invoice_totals', true);
					$tax_rate = get_option('sales_tax_rate');
					if(!empty($tax_rate)) {
						$total = isset($invoice_totals['total']) ? $invoice_totals['total'] : '';
					} else {
						$total = isset($invoice_totals['sub']) ? $invoice_totals['sub'] : '';
					}					
					$invoice_date = isset($invoice_details['invoice_date']) ? $invoice_details['invoice_date'] : '';
					if(is_numeric($invoice_date)) { $invoice_date = date(get_option('cqpim_date_format'), $invoice_date); } else { $invoice_date = $invoice_date; }
					$sent = isset($invoice_details['sent']) ? $invoice_details['sent'] : '';
					$paid = isset($invoice_details['paid']) ? $invoice_details['paid'] : '';
					$due = isset($invoice_details['terms_over']) ? $invoice_details['terms_over'] : '';
					$on_receipt = isset($invoice_details['on_receipt']) ? $invoice_details['on_receipt'] : '';
					$due = isset($invoice_details['terms_over']) ? $invoice_details['terms_over'] : '';
					if(empty($on_receipt)) {
						$due_readable = date(get_option('cqpim_date_format'), $due);
					} else {
						$due_readable = __('Due on Receipt', 'cqpim');
					}
					$current_date = time();
					$link = get_edit_post_link($invoice->ID);
					$password = md5($invoice->post_password);
					$url = $link;
					if(!$paid) {
						if($current_date > $due) {
							if(empty($on_receipt)) {
								$status = '<span class="cqpim_button cqpim_small_button font-red border-red op nolink sbold"><strong>' . __('OVERDUE', 'cqpim') . '</strong></span>';
							} else {
								$status = '<span class="cqpim_button cqpim_small_button font-red border-red op nolink"><strong>' . __('Due on Receipt', 'cqpim') . '</strong></span>';
							}
						} else {
							if(!$sent) {
								$status = '<span class="cqpim_button cqpim_small_button font-red border-red op nolink">' . __('New', 'cqpim') . '</span>';
							} else {
								$status = '<span class="cqpim_button cqpim_small_button font-amber border-amber op nolink">' . __('Outstanding', 'cqpim') . '</span>';
							}
						}
					} else {
						$status = '<span class="cqpim_button cqpim_small_button font-green border-green op nolink">' . __('PAID', 'cqpim') . '</span>';
					}	
					if(!is_array($client_ids)) {
						$client_ids = array();
					}
					echo '<tr>';
					echo '<td><a class="cqpim-link" href="' . $url . '" >' . $invoice_id . '</a></td>';
					echo '<td>' . $owner->display_name . '</td>';
					echo '<td>' . $invoice_date . '</td>';
					echo '<td>' . $due_readable . '</td>';
					echo '<td>' . pto_calculate_currency($invoice->ID, $total) . '</td>';
					echo '<td>' . $status . '</td>';
					echo '</tr>';
				}
				echo '</tbody>';
				echo '</table>';						
			}	
		} else {
			echo '<p>' . __('You do not have the relevant permissions to view invoices.', 'cqpim-subscriptions') . '</p>';		
		}

}
add_action( 'save_post', 'save_pto_subscription_invoices_metabox_data' );
function save_pto_subscription_invoices_metabox_data( $post_id ){
	if ( ! isset( $_POST['subscription_invoices_metabox_nonce'] ) )
	    return $post_id;
	$nonce = $_POST['subscription_invoices_metabox_nonce'];
	if ( ! wp_verify_nonce( $nonce, 'subscription_invoices_metabox' ) )
	    return $post_id;
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
	    return $post_id;
	if ( 'page' == $_POST['post_type'] ) {
	    if ( ! current_user_can( 'edit_page', $post_id ) )
	        return $post_id;
	  	} else {
	    if ( ! current_user_can( 'edit_post', $post_id ) )
	        return $post_id;
	}

}